/*
   ObjectEnvelope.java

Copyright (C) 1999 Geometrek	and 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */ 

package matrix;

import matrix.vrml.*;
import java.io.*;
/**
 *  This class builds and parses real time messages.
 *  Echo tells the Server to forward this msg to the sender also.
 *
 *  @version 1.1
 *  @see matrix.deck.RealTimeHandler
 */
public class ObjectEnvelope extends Message {

  final public static int TYPE = 7;

  public String tag = null;
  public String sender = null;
  public Field data  = null;
  public Field state = null;

  public ObjectEnvelope(){
  }

  public ObjectEnvelope( String tag, String sender, Field data, Field state ){
    this.tag = tag;
    this.sender = sender;
    this.data = data;
    this.state = state;
  }

  public ObjectEnvelope( DataInputStream in ) throws IOException {
  }

  public int getType(){
    return TYPE;
  }

  public  void read( DataInputStream in ) throws IOException {
  }

  public void write( DataOutputStream out ) throws IOException {

  }

  public String toString(){
    return tag+" "+sender+" "+state+" "+data;
  }
}
