/*
  Frontend.java

 Copyright (C) 1998 Geometrek
 
 *  This file is part of DeepMatrix V1.
 *
 *  DeepMatrix V1 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix V1 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.chat;

import matrix.*;
import matrix.deck.UserInterface;
import matrix.deck.UserInterfaceListener;
import java.awt.*;
import java.util.*;

/**
 * implements the user interface and gui intelligence for the client.
 * It uses LoginPanel and
 * RunPanel to build the GUI and implements the basic functionality
 * ( which is quite complex actually :).
 * <p>LoginPanel and RunPanel are just dump panels holding only building
 * code. All intelligence sits in this class, thus making it easier changing
 * the look.
 */

/*
  the strange way of using the Cardlayout stemms from a problem making
  it usable for awt 1.0 and awt 1.1 netscape versions.
  ns4.5pr1 has a problem if you define the cardlayout before adding the
  components and NOT using 1.1 methods. But now the cardlayout
  doesn't know about the names
*/
public class Frontend extends Panel implements UserInterface {
  private LoginPanel login;
  private RunPanel run;
  private String beamtoselect = null, name, pwd = "default";
  private String whisperto = null;
  private int a = 0;
  private boolean htmllogin = false, bpwd = false; 
  private CardLayout cards;
  private Vector listeners;
  private Container parent;

  public Frontend( boolean tf, Container parent, UserInterfaceListener listener ){
     htmllogin = tf;
    this.parent = parent;
    listeners = new Vector();
    setBackground( parent.getBackground());
    setForeground( parent.getForeground());
    cards = new CardLayout();
    run = new RunPanel( this );
    add( run );
    login = new LoginPanel( this );
    add( login );
    setLayout( cards );
     if(tf==false){
    cards.last( this );}
    else { cards.first( this );}
    addUserInterfaceListener( listener );
  }

/**
 * switches gui to login panel and clears fields
 */
  public void showLoginView(){
    login.Username.setText("");
    cards.last( this );
  }

/**
 * switches gui to run panel and clears fields too
 */
  public void showRunView(){
    run.Chatinput.setText("");
    run.Chatarea.setText("");

// real 1.0 old school style
    run.UserList.delItems(0, run.UserList.countItems()-1);

    cards.first( this );
  }

  public String getLoginName(){
    return login.Username.getText();
  }

   public void setWWW( Message msg ){
   }

   public void setLableAnchorInfo( boolean bBC, String mst [] ){
   }

    public void setNavChange( String [] types ){
   }

  public void setSpeedChange( float ft ){
  }

  public  void setAdmin( int arg ){
 }

  public void setGhostMode( boolean value ){
 }

  public void handleGhost( boolean value ){
  }

  public void setUsers( String[] names ){
// run.UserList.removeAll();
// real 1.0 old school style
    run.UserList.delItems(0, run.UserList.countItems()-1);
    for(int i = 0 ; i < names.length ; i++) {
      run.UserList.addItem(names[i]);
    }
  }
   public String setUserName( String un ){
   name = un; 
  return(name);
  } 

  public void setAvatars( String[] names, String[] urls ){
  }

  public void setGestures( String[] names ){
  }

 public String setPassWord( String un ){
   pwd = un; 
  return(pwd);
  }

  public String getUser(){
    String sel = run.UserList.getSelectedItem();
    run.UserList.deselect( run.UserList.getSelectedIndex());
    return sel;
  }

  public String getChatInput(){
    String input = run.Chatinput.getText();
    run.Chatinput.setText("");
    return input;
  }

/**
 * changes events from the underlying components. This method is called
 * by the AWT for any action events. It tweaks the events values to
 * build high level event values and hide the underlying GUI components.
 * The encapsulating container sees only action messages from the class
 * Frontend.
 */
  public boolean action( Event e, Object what ){
    Enumeration list;
    // to use the AWT event handling we tweak the events a bit
    if( e.target == login.Connect ){
      String passwd = null;
      boolean test = false; 
      if(htmllogin==false){ 
      name = login.Username.getText();
      name = name.replace(' ','_'); 
   if(bpwd==false){
      passwd = name;}
    else { passwd = pwd; }
      test = true; }
    else { 
    String st = login.Username.getText();
      st = st.replace(' ','_');
     if(name.equals(st)){ test = true;
      passwd = pwd; } 
       }
      if(test==true){
      list = listeners.elements();
      while( list.hasMoreElements())
       try {
        ((UserInterfaceListener)list.nextElement()).handleConnect( name, pwd, "" );
         }
      catch(InterruptedException f){ System.err.println("Frontend handleConnect: "+ f); }
      return true;
       }
      else {
       setStatus( "Please login at portal with correct password for your name!" );
      return true;
      }
    }
    if( e.target == run.Chatinput ){
      e.target = this;
     // e.arg = "Chat";
     // return false;
        String line = (String) what;
      String user = null;
      run.Chatinput.setText("");
      list = listeners.elements();
      while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).setUpChat( line, user );
      return true;

    }
    if( e.target == run.Disconnect ){
    list = listeners.elements();
      while( list.hasMoreElements())
        try {
        ((UserInterfaceListener)list.nextElement()).handleDisconnect();
          }
         catch(InterruptedException f){ System.err.println("Frontend handleConnect: "+ f); }
      return true;
    }
    return super.action( e, what );
  }

/**
 * writes formatted text lines into TextArea.
 * More or less decent output into main TextArea plus workaround
 * for MS textarea bug.
 */
  public void display( String by, String li ){
    FontMetrics met = run.Chatarea.getFontMetrics( run.Chatarea.getFont());
    String out = by+" :", tok;
    String help = out;
    StringTokenizer token = new StringTokenizer( li, " ");
    while( token.hasMoreTokens()){
      tok = token.nextToken();
      help = out +" "+tok;
      if( met.stringWidth( help ) > run.Chatarea.size().width - 20){
        run.Chatarea.appendText( out+"\n" );
        out = "     ";
      }
      out += " "+tok;
    }
    run.Chatarea.appendText( out+"\n");
    if( run.Chatarea.getText().length() > 31000 )
      run.Chatarea.replaceText("",0,10000);
  }

  public void setStatus( String line ){
    login.Status.setText( line );
  }
    public void addUserInterfaceListener( UserInterfaceListener listener ){
    if( ! listeners.contains( listener ))
      listeners.addElement( listener );
  }

  public void removeUserInterfaceListener( UserInterfaceListener listener ){
    listeners.removeElement( listener );
  }
}
