/*
  RunPanel.java

Copyright (C) 1998 Geometrek
 
 *  This file is part of DeepMatrix V1.
 *
 *  DeepMatrix V1 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix V1 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.chat;

import java.awt.*;
import matrix.deck.BorderPanel;

public class RunPanel extends BorderPanel
{

  protected TextArea Chatarea = null;
  protected TextField Chatinput = null;
  protected List UserList = null;
  protected Button Disconnect = null;
  protected GridBagLayout mainLayout;
  private Container parent;

  public RunPanel( Container parent )
  {
    super( BorderPanel.RAISED );
    this.parent = parent;
    Color bg = parent.getBackground();
    setBackground( bg );
    Color fg = parent.getForeground();
    setForeground( fg );
    setOuterMargin( 0 );
    setInnerMargin( 1 );
    mainLayout = new GridBagLayout();
    setLayout( mainLayout );
    Chatarea = new TextArea( "", 0, 20 );
    mainLayout.setConstraints( Chatarea, makeGridCons( 0, 0, 10, 11, 100, 100, GridBagConstraints.BOTH, GridBagConstraints.CENTER, 0, 0, 1, 1, 0, 0 ) );
    Chatarea.setForeground( fg );
    Chatarea.setBackground( bg );
    add( Chatarea );
    Chatarea.setEditable( false );
    Chatinput = new TextField( "", 20 );
    mainLayout.setConstraints( Chatinput, makeGridCons( 0, 11, 10, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 0, 1, 1, 0, 0 ) );
    Chatinput.setForeground( fg );
    Chatinput.setBackground( bg );
    add( Chatinput );
    UserList = new List( 5, false );
    mainLayout.setConstraints( UserList, makeGridCons( 10, 0, 5, 11, 20, 100, GridBagConstraints.BOTH, GridBagConstraints.CENTER, 0,1 , 1, 0, 0, 0 ) );
    UserList.setForeground( fg );
    UserList.setBackground( bg );
    add( UserList );
    Disconnect = new Button( "Disconnect" );
    mainLayout.setConstraints( Disconnect, makeGridCons( 10, 11, 5, 1, 20, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 1, 1, 0 , 0, 0 ) );
    Disconnect.setForeground( fg );
    Disconnect.setBackground( bg );
    add( Disconnect );
  }

  public GridBagConstraints makeGridCons( int x, int y, int dx, int dy, int wx, int wy, int fill, int anch, int it, int il, int ib, int ir, int px, int py )
  {
    GridBagConstraints cons = new GridBagConstraints();

    cons.weightx    = wx;
    cons.weighty    = wy;
    cons.gridx      = x;
    cons.gridy      = y;
    cons.gridwidth  = dx;
    cons.gridheight = dy;
    cons.fill       = fill;
    cons.anchor     = anch;
    cons.insets     = new Insets( it, il, ib, ir );
    cons.ipadx      = px;
    cons.ipady      = py;

    return cons;
  }
}
