 /*
  Frontend.java

  Copyright (C) 1998 Geometrek	and 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */  

package matrix.deck;
import matrix.AdminControl;
import matrix.Message;
import matrix.WhoWhatWhere;
import matrix.RoomControl;
import java.awt.*;
//import java.awt.event.KeyListener;
import java.util.*;

/**
 * implements the user interface and gui intelligence for the client.
 * It uses LoginPanel and
 * RunPanel to build the GUI and implements the basic functionality.
 * <p>LoginPanel and RunPanel are just dump panels holding only building
 * code. All intelligence sits in this class, thus making it easier changing
 * the look.
 *
 * @version 1.1
 */

/*
  the strange way of using the Cardlayout stemms from a problem making
  it usable for awt 1.0 and awt 1.1 netscape versions.
  ns4.5pr1 has a problem if you define the cardlayout before adding the
  components and NOT using 1.1 methods. But now the cardlayout
  doesn't know about the names
*/
public class Frontend extends Panel implements UserInterface {
  private LoginPanel login;
  private RunPanel run;
  private CardLayout cards;
  private Container parent;
  /**
 * New 11-12-05 beamtoselect keeps name of person selected to beamto.
 */
  private String beamtoselect = null, name, name2, room, newWorldName = null, newWorldUrl = null, sRoompass = null;
/**
 * New 11-12-05 whisperto keeps name of person selected to whisperto.
 */
  private String whisperto = null, sMove = null;
  /**
 * New 11-12-05 a is used as a boolean to determine if the whisper chat is active or not.( 0 == false, 1 == true )
 */
  private String [] sNEWUSR = new String [2];
  private Image [] IMGS;
  private int iNavTypeLength = 0;
  private int iPL = 1;
  private int iPLCT = 0;
  private int [] iRP =  { 0, 1, 2, 11, 12 };
  private String [] sNavTypes = null;
  private String [] sArchTypes  = new String [] {"WALK","FLY","EXAMINE","FREEFLY","LOOKAT","PAN","SLIDE" }; 
  private String sPrevNavType = "";
  private int iGhostCt = -1;
  private int iNavState = 1;
  private int iXsize = 0;
  private int iYsize = 0;
  private int iWhisp = 0;
  private int iRoom = 0;
  private int iMTM = 0;
  private int  iAdmin = 0;
  private int  iAC = -1;
  private int iRoomadd = 0;
 // private int a = 0;
  private int iAvPgCt = 0;
  private String sAvatarImages = null;
  private Color Cbg = null;
  private Color Cfg = null;
  private float fSpeed = (float) 3.0;
  private String[] urls;
  private String[] sGestures;
  private String sPrevNav;
  private Vector listeners;
  private Vector ignored;
  private Vector invisible;
  private Image cImg = null;
  private Vector vAvImages;
  private Hashtable objs;
  boolean bNone = false;
  private boolean bLogChat = true;
  private IButtonAnchor IBA;
  private ChatLog CL;
  private boolean bNavCallBack = false, bAI = false, bAI2 = false, bAI3 = false, bHeadlightState = false, bMasterCollision = true, bCollideState = false;
  private boolean bRun = false, bGhostReady = false, bSiteButton = false, bSiteLabel = false, bMTM = false;
  private boolean bGhost = false, bGhostHUD = false,  bMove = true,  bAddRoomState = false, bPublic = true, bIgnore = false, bRoompass = false;
  /**
 * New 11-12-05 iWS keeps track of the index of a person selected for whisper. 
 * If a user is whispering to someone and decides to beam to someone else, or more users are added to the userlist, 
 * idx will insure that the name selected on the user list will remain highlighted.
 */
  private int iWS = -1, iMO = -1;
 /**
 * New 11-12-05 bChatStatus determines if the client is in disconnect or transition state
 * so whether or not to add/remove chat and whisper can be decided.
 */
  private boolean bChatStatus = false;

  private WWWBuffer wwwBuffer;


  private class WWWBuffer implements Runnable {
        private boolean bKill = false;
        private Vector buffer;
        private Thread runner;
        
            WWWBuffer(){
            buffer = new Vector(10,10);
            
        }
        
        public void run(){
            while( Thread.currentThread() == runner ){
                try {
             synchronized( buffer ){
			if(!buffer.isEmpty()){
        	  String foo = null;
		      String foo2 = null;
		  Message msg = (Message) buffer.firstElement();
		  switch( msg.getType() ){
          case RoomControl.TYPE :
          RoomControl rc = (RoomControl)msg;
		   switch( rc.command ) { 
				 case  RoomControl.SET :
			   if(rc.rc[0].equals("private")){
				setPrivacy( 2 );
			    display("Matrix","Your world has been set to private!" );
        	   }
			if(rc.rc[0].equals("public")){
			    setPrivacy( 1 );
			   	display("Matrix","Your world has been set to public!" );
              }
             if(rc.rc[0].equals("logout")){
				setPrivacy( 3 );
                bKill = true;
        	}
                    break;
				 case	RoomControl.GET :
             foo = "(Highlight name and press Ctrl + c keys to copy!) Member list for this world: ";
            	for (int i = 0; i < rc.rc.length; i +=1 ) {
                 foo += rc.rc[i] + " ";
                  }
			   display("MatrixD:", foo );
                    break;
        	     case  RoomControl.ADDMEM :
                    break;
                 case  RoomControl.REMMEM :
                    break;
				 case  RoomControl.PASSWD :
				if(sRoompass!=null&&name!=null){ 
    		  display("Matrix","Welcome owner " + name + " your password is correct!" );
            if(rc.rc[0].equals("private")){
				setPrivacy( 2 );
			display("Matrix","Your world is currently private!" );
        	   }
			if(rc.rc[0].equals("public")){
			    setPrivacy( 1 );
			 display("Matrix","Your world is currently public!" );
              }
    		 }
               break;
				default :
		display("Fontend:", "WWWBuffer: unknown message type RoomControl: " + rc.toString() );
           break;
            }
          break;
          case WhoWhatWhere.TYPE :
        WhoWhatWhere  www = (WhoWhatWhere)msg;
          switch( www.command ) { 
          case WhoWhatWhere.WHO :
		int b = 0;
        run.UserList.removeAll();
		   for (int i = 0; i < www.wwwe.length; i +=1 ) {
       foo = www.wwwe[i];
      if(foo!=null){ 
       if(ignored.contains(foo)){
       resetIgnore( foo, "no");
       foo = ("(I)" + foo );
        }
	   if(invisible.contains(foo)){
       foo = ("(X)" + foo ); }
       run.UserList.addItem(foo);
     if(whisperto!=null){ if(whisperto.equals(foo)){
     setiWS( i ); run.UserList.select(i); b = 1;}}
        }
       }
     if(b == 0&&whisperto!=null){
      whisperto = null;	closeWhisperinput();
        }
            break;
          case WhoWhatWhere.WHAT :
		 run.ObjectList.removeAll();
	     for( int i = 0; i < www.wwwe.length; i +=1 ){
		 foo = www.wwwe[i];
		 if(foo!=null){ 
         if(foo.endsWith("(BP)")){ 
         foo2 = foo.substring(0,foo.length()-4);
         }  
		 else {
       foo2 = foo.substring(0,foo.length()); 
        }
       Integer Iclass = new Integer(i);
         objs.put(foo2,Iclass);
		  if(invisible.contains(foo)){
           foo = ( "(X)" + foo ); }
		  run.ObjectList.addItem(foo);
         if(sMove!=null&&sMove.equals(foo)) { 
         setiMO( i ); run.ObjectList.select(i);
         }
         }
         }
          break;
        case WhoWhatWhere.WHERE : 
		run.RoomList.removeAll();
		for( int i = 0; i < www.wwwe.length; i +=1 ){
		foo = www.wwwe[i];
		if(foo!=null){ 
		run.RoomList.addItem(foo);
          }
        }
        break; 
        case WhoWhatWhere.WHRUPD :
        boolean tf = false;
		String [] st = run.RoomList.getItems();
        for( int i = 0; i<st.length; i +=1 ){
        String st2 = st[i].substring(0,st[i].indexOf(" ("));
        if (st2.equals(www.name)){ 
		if(!www.wwwe[0].equals("(-1)")){
        run.RoomList.replaceItem(www.wwwe[0],i);
        }
        else {
        run.RoomList.remove( i );
        }
        tf = true;
        break;
          }
        }
        if(tf==false){ run.RoomList.add( (www.name + " " + www.wwwe[0]) );}
        break;
		default :
		display("Fontend:", "WWWBuffer: unknown message type WhoWhenWhere: " + www.toString() );
           break;
         }
         break;
         }
	   buffer.removeElementAt(0);              
          }
          else {
           if(!bKill){ buffer.wait(); }
            else {
              runner = null;
              buffer.removeAllElements();
              buffer.notify();
               }
                }
              }
             }
                catch(InterruptedException e){
                	System.out.println("Frontend: WWWBuffer: " + e);
                       }
                catch(Exception g){	
                	 System.out.println("Frontend: WWWBuffer: " + g);
                }
            }
        }
        
        public void put( Message msg ){
            synchronized( buffer ){
                buffer.addElement( msg );
                buffer.notify();
            }
        }
        
        public void start(){  
  if(runner==null){ 
        bKill = false;  
  runner = new Thread( this, ("wwwBuffer") ); 
   runner.start(); 
      }	
      }

        public void stop() {
             runner = null; 
            synchronized( buffer ){
            buffer.removeAllElements();
               buffer.notify(); 
            }
          }

        }

/**
 * builds the gui components. lines sets the text in the greeting box, if lines == null a standard
 * text is used.
 *
 * @param parent parent GUI element
 * @param lines greeting text in frontend
 * @param listener a UserInterfaceListener added right away
 */
  public Frontend( Container parent, String[] lines, UserInterfaceListener listener,  int iPL, String sAP, String sCD ){
    wwwBuffer = new WWWBuffer();
    CL = new ChatLog( sCD + "chat.log" );
    sAvatarImages = sAP; 
    this.parent = parent;
    this.iPL = iPL;
    //this.parent.setLocation(0,768);
    listeners = new Vector();
    ignored = new Vector();
    invisible = new Vector();
    objs = new Hashtable();
    //objs = new Vector();
    setBackground( parent.getBackground());
    setForeground( parent.getForeground());
    cards = new CardLayout();
		run = new RunPanel( this );
//		 setNavigation(true);
//	 setGhost(true);
//    run.addLoadUnload();
//    run.addRoomEnter();
//	run.addChatinput();
//    run.addWhisper();
//    run.addWhisperinput();
//    run.addDisconnect();
//    run.addView();
//    run.addIgnore();                    
    add( run );
    login = new LoginPanel( this, lines, iPL );
    add( login );
    setLayout( cards );
    cards.last( this );
	 //setObjList(true);
	
    //run.validate();
    //run.requestFocus();
    login.validate();
    login.requestFocus();
    addUserInterfaceListener( listener );
  }

/**
 * switches gui to login panel and clears fields
 */
  public void showLoginView(){
		bRoompass = false;  
    login.Username.setText("");
	  if(1<iPL){
    login.Password.setText("");
    }
    login.Url.setText("");
    cards.last( this );
    login.validate(); 
    login.requestFocus();
  }

/**
 * switches gui to run panel and clears fields too
 */
  public void showRunView(){
    cards.first( this );
    run.requestFocus();
    run.Viewpoints.repaint(25);
    run.Gesture.requestFocus();
    run.Gesture.repaint(25);
    run.Navigation.requestFocus();
    run.Navigation.repaint(25);
    run.Speed.requestFocus();
    run.Speed.repaint(25);
    run.Disconnect.requestFocus();
    run.Disconnect.repaint(25);
    run.validate();
    setbRun( true );
  }

  public void startWWWBuffer(){
   wwwBuffer.start();
  }

  public void stopWWWBuffer(){
   wwwBuffer.stop();
  }

  public void setAvatars( String[] names, String[] urls ){
    this.urls = urls;
//    login.inputpan.remove( login.Avatar );
    for (int i = 0 ; i < names.length ; i +=1 ) {
      login.Avatar.addItem(names[i]);
    }
    login.Avatar.addItem("Preview-Images");
    login.Avatar.addItem("Custom");
  }

  public void setGestures( String[] names ){

  // again the same ( I possibly should have put that in a method, but it is so
  // bad that I want to have it right in the face ( If we ever can change that ).
    run.Gesture.removeAll();
    for (int i = 0 ; i < names.length; i += 1 ) {
if(i<names.length&&names[i].indexOf("NG_")==-1){
 names[i] = names[i].replace(' ','_'); run.Gesture.addItem(names[i]);
        }
       }
 if(0==run.Gesture.getItemCount()){ run.Gesture.addItem("No Gestures"); }
 else {
 sGestures = names;
     }
    run.validate();
  }

	public void setAvatarImages ( Vector vAI ){
    vAvImages = vAI;
   AvImageLib ail = (AvImageLib)vAvImages.elementAt(0);
  if(ail!=null){ this.urls = ail.AvUrls;
  for (int i = 0 ; i < ail.AvNames.length ; i +=1 ) {
      login.Avatar.addItem(ail.AvNames[i]);
    }
    login.Avatar.addItem("Preview-Images");
 if(1<vAvImages.size()){ login.Avatar.addItem("More ->Page " + 2 ); }
    login.Avatar.addItem("Custom");
      }
    }

    public void setUsers( String[] modes ){
    run.Users.removeAll();
    run.validate();
    for (int i = 0 ; i < modes.length; i++ ) {
     run.Users.add(modes[i]);}
  } 

     public void setObjects( String[] modes ){
    run.Objects.removeAll();
    run.validate();
    for (int i = 0 ; i < modes.length; i++ ) {
     run.Objects.add(modes[i]);}
  } 

	   public void setWorlds( String[] modes ){
    run.Worlds.removeAll();
    run.validate();
    for (int i = 0 ; i < modes.length; i++ ) {
     run.Worlds.add(modes[i]);
     } 
	run.Worlds.insert( "Get-Members", 6 );
    run.Worlds.insert( "Add-Members", 7 );
    run.Worlds.insert( "End-Members", 8);
     }


    private void setPrivacy( int num ){
    int iWct = run.Worlds.getItemCount(); 
    if(num==1){ 
    
    if(iWct==10){
	 	try {
    run.Worlds.remove( "Set-Public" );
    run.Worlds.remove( "Get-Members"  );
    run.Worlds.remove( "Add-Members"  );
    run.Worlds.remove( "End-Members" );
     }
    catch(IllegalArgumentException e){}
    run.Worlds.insert( "Set-Private", 4 );
    }
    if(iWct==6){
    run.Worlds.insert( "Set-Private", iWct+1 );
    }
    bPublic = true;
    }
    if(num==2){
    try {
	run.Worlds.remove( "Set-Private" );
     }
	catch(IllegalArgumentException e){}
    iWct = run.Worlds.getItemCount();
	run.Worlds.insert( "Set-Public", iWct+1 );
    run.Worlds.insert( "Get-Members", iWct+2 );
    run.Worlds.insert( "Add-Members",iWct+3 );
    run.Worlds.insert( "End-Members",iWct+4);
    bPublic = false;
    }
    if(num==3){
    run.Worlds.removeAll();
    String [] wrls = { "Worlds","Enter","Add-Remove-World","Set-as-Start-Room","Owner's-Password","World's Objects" };
   for( int a = 0; a<wrls.length; a++){
      run.Worlds.add(wrls[a]);
     }
    }
    run.validate();
       }

  public void setWWW( Message msg ){
	 wwwBuffer.put(msg);
}

  public void confirmObjLoad( String objname ){
 if(!objname.startsWith("_")){
 String st = objname;
 String st2 =  st + "(BP)";
if(objs.containsKey( st )){ 
  Integer Iidx = (Integer)objs.get( st );
  int idx = Iidx.intValue(); 
 try{
  run.ObjectList.replaceItem( st,idx );
  run.ObjectList.select(idx);
}
catch(NoSuchElementException e){ System.out.println("Frontend confirmObjLoad: " + e); }
catch(Exception f){ System.out.println("Frontend confirmObjLoad: " + f);  }
   this.display(name,"Requested shared object " + st + " loaded!" );
  setbMove( true );
 }
 else {
 this.display("Matrix","Loading shared object " + st + " not found on Objectlist!" );
   }
  }
 }

 public  void setbRun( boolean tf ){
 bRun = tf;
 }
  
 private  void setbMove( boolean tf ){
 bMove = tf;
 }

 private  void setbAddRoomState( boolean tf ){
 bAddRoomState = tf;
 }

 private  void setiRoom( int num ){
 iRoom = num;
 }

 private  void setiAC( int num ){
 iAC = num;
 }

  private  void setiWhisp( int num ){
 iWhisp = num;
 }

 private  void setiAdmin( int num ){
 iAdmin = num;
 }

 private  void setbGhost( boolean tf ) {
 bGhost = tf;
 }

 private  void setiGhostCt( int num ){
 iGhostCt = num;
 }

 private  void setiPLCT( int num ){
 iPLCT = num;
 }
 
 private  void setiRoomadd( int num ){
 iRoomadd = num;
 }

 private  void setiWS( int num ){
 iWS = num;
 }

  private void setiMO( int num ){
 iMO = num;
 }

   public void deleteObjName( String objname ){
  if(objs.containsKey( objname )){ 
  Integer Iidx = (Integer)objs.get( objname );
  int idx = Iidx.intValue(); 
  run.ObjectList.replaceItem( (objname+"(BP)"),idx );
 this.display(name,"Requested shared object " + objname + " Unloaded!" );
 }
 else {
 this.display(name,"Unloading shared object " + objname + " not found on Objectlist!" );
 }
   }

public void setGhostMode( boolean value ){
    setbGhost( value ) ;
  }

/**
 * changes events from the underlying components. This method is called
 * by the AWT for any action events. It notifies all observers of any
 * events by calling the appropriate handleXXX method of the observers.
 */
  public boolean action( Event e, Object what )  {
    Enumeration list;
    // to use the AWT event handling we tweak the events a bit
    if( e.target == login.Username ){
    login.Username.requestFocus();
    }
    if( e.target == login.Url ){
    login.Url.requestFocus();
    }
    if(e.target == login.Password ) {
    login.Password.requestFocus();
    }
    if(e.target == login.Avatar ){
    Image avi = null;
      if(login.Avatar.getSelectedItem().equals("Preview-Images")){
	 bAI2 = false;
	 if(!bAI){
     bAI = true; 
      }
     else {
     bAI = false;
       }
	 } 
     else {
	 if( login.Avatar.getSelectedItem().startsWith("More ->Page ")){
   if(iAvPgCt+1<vAvImages.size()){ iAvPgCt += 1; }
	   AvImageLib ail = (AvImageLib)vAvImages.elementAt(iAvPgCt);
     login.Avatar.removeAll();
  if(ail!=null){ this.urls = ail.AvUrls;
  for (int i = 0 ; i < ail.AvNames.length ; i +=1 ) {
      login.Avatar.addItem(ail.AvNames[i]);
    }
    login.Avatar.addItem("Preview-Images");
 if(iAvPgCt+2<=vAvImages.size()){ login.Avatar.addItem("More ->Page " + ( iAvPgCt + 2 ) ); }
 login.Avatar.addItem("Back ->Page " + (iAvPgCt) ); 
    login.Avatar.addItem("Custom");

    bAI = true;
    bAI2 = true;
      }
     }
     else {
  	 if( login.Avatar.getSelectedItem().startsWith("Back ->Page ")){
	 if(0<=iAvPgCt-1){ iAvPgCt -= 1; }
	   AvImageLib ail = (AvImageLib)vAvImages.elementAt(iAvPgCt);
     login.Avatar.removeAll();
  if(ail!=null){ this.urls = ail.AvUrls;
  for (int i = 0 ; i < ail.AvNames.length ; i +=1 ) {
      login.Avatar.addItem(ail.AvNames[i]);
    }
    login.Avatar.addItem("Preview-Images");
 login.Avatar.addItem("More ->Page " + (iAvPgCt + 2) );
 if(0<iAvPgCt){ login.Avatar.addItem("Back ->Page " + (iAvPgCt) ); }
    login.Avatar.addItem("Custom");
 
    bAI = true; 
    bAI2 = true;
      }
     }
  else {
   bAI2 = false;
   bAI = false;
    }}}
   list = listeners.elements();
	 while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleAvImages( bAI, bAI2, iAvPgCt );
      return true;
    }
    if( e.target == login.Connect ){
      name2 = login.Username.getText();
     if(name2.indexOf("#")!=-1){
     setStatus("The pound sign (#) is not allowed in a user's name!"); 
     return false;
     }
      name = name2.replace(' ','_');
      String passwd = null;
      if(1<iPL){
      passwd = login.Password.getText();
      if(passwd==null)
      return false;
     if(passwd.indexOf("#")!=-1){
     setStatus("The pound sign (#) is not allowed in a user's password!"); 
     return false;
     }
      }
	  String url;
       if( login.Avatar.getSelectedItem().equals("Preview-Images")||login.Avatar.getSelectedItem().startsWith("Back ->Page ")||login.Avatar.getSelectedItem().startsWith("More ->Page ")){
       setStatus("Please select an avatar!"); 
       return true;
          }
       else {
       if( login.Avatar.getSelectedItem().equals("Custom"))
         url = login.Url.getText();
      else
        url = urls[login.Avatar.getSelectedIndex()];
      list = listeners.elements();
      if(bAI){
	 while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleAvImages( false, false, 0 );
     bAI = false;
     }
	 while( list.hasMoreElements())
       try {
        ((UserInterfaceListener)list.nextElement()).handleConnect( name, passwd, url );
         }
       catch(InterruptedException g){ }
      return true;
        }
      }
	    if( e.target == run.Disconnect ){
     list = listeners.elements();
      while( list.hasMoreElements())
        try {
        ((UserInterfaceListener)list.nextElement()).handleDisconnect();
            }
         catch(InterruptedException g){}
      return true;
    }
  if(bRun){
	if( e.target == run.SiteButton ){ 
   if(IBA!=null){ IBA.openUrl();}
    return true; 
    }
    if( e.target == run.Viewpoints ){ 
	String line = (String) what;
    if(line!=null&&!line.equals("Viewpoints")){
	list = listeners.elements();
    while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleViewpoint( line );
     if(1<run.Viewpoints.getItemCount()){
 String st = run.Viewpoints.getItem(0);
 if(!st.equals(line)){
		try {
	run.Viewpoints.remove(line);
    run.Viewpoints.remove(0);
     }
  catch(IllegalArgumentException x){}
 run.Viewpoints.insert( line, 0 );
 run.Viewpoints.insert( st, 1 );
     }
   }
      return true;
      }
     }
    if( e.target == run.Chatinput ){
      String line = (String) what;
      String user = null;
      run.Chatinput.setText("");
      list = listeners.elements();
      while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).setUpChat( line, user );
      return true;
    }
    if( e.target == run.Gesture ){
     if(what!=null){
     if(!what.equals("No Gestures")){
      String gesture = (String) what;
    int iGest = 0;
    for( int i = 0; i<sGestures.length; i +=1 ){
     if(gesture.equals(sGestures[i])){ iGest = i;
      break;
       }
	  }
      list = listeners.elements();
      while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleGesture( iGest );
      return true;
      }
     else  
      return false;
     }
     else  
      return false;
    }
      if( e.target == run.Navigation ){
      int num = 15;
	  list = listeners.elements();
      String mode = (String) what;
	if( mode.indexOf("Ghost")!=-1){
  int iGhpl = 1;
  if(1<sNavTypes.length){ 
  iGhpl = 2;
  }
 try {
      if(!bGhost){
   run.Navigation.remove("Ghost");
   run.Navigation.insert("*Ghost*",iGhpl);
   setiGhostCt( 1 );
   setbGhost( true );
   }
     else {
	run.Navigation.remove("*Ghost*");
    run.Navigation.insert("Ghost",iGhpl);
	 setiGhostCt( 0 );
     setbGhost( false );
       } 
         }
  catch(IllegalArgumentException h){System.out.println("Navigation Ghost: " + h);}
    while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleGhost( bGhost  );
      return true;
    }
    else {
  if( mode.indexOf("Straighten Up")!=-1){
   num = 7;
   System.out.println("Straighten Up num: " + num);
       }
  if( mode.indexOf("Headlight:")!=-1){
 int iHL = run.Navigation.getSelectedIndex();
 String sHL = "";
 if(!bHeadlightState){
 sHL = "Headlight: ON";
 bHeadlightState = true;
 num = 8;
  }
 else {
 sHL = "Headlight: OFF";
 bHeadlightState = false;
 num = 9;
 }
  try {
   run.Navigation.remove(iHL);
   run.Navigation.insert(sHL,iHL);
    }
  catch(IllegalArgumentException h){System.out.println("Navigation Headlight: " + h);}
  }
   if( mode.indexOf("Collision:")!=-1){
 if(!bMasterCollision){
 int iCL = run.Navigation.getSelectedIndex();
 String sCL = "";
 if(!bCollideState){
 sCL = "Collision: ON";
 num = 10;
 bCollideState = true;
 }
 else {
 sCL = "Collision: OFF";
 num = 11;
 bCollideState = false;
 }
  try {
   run.Navigation.remove(iCL);
   run.Navigation.insert(sCL,iCL);
    }
  catch(IllegalArgumentException h){System.out.println("Navigation Collision: " + h);} 
   }
  else {
  return false;
   }
  }
       else {
  if( mode.indexOf("WALK")!=-1 ){
      num = 1;
    }
  if( mode.indexOf("NONE")!=-1 ){
    return false;
     }
  if( mode.indexOf("FLY")!=-1 ){
      num = 2;
    }
   if( mode.indexOf("EXAMINE")!=-1 ){
      num = 0;
    }
  if( mode.indexOf("FREEFLY")!=-1 ){
      num = 3;
      }
  if( mode.indexOf("LOOKAT")!=-1 ){
      num = 4;
      }
  if( mode.indexOf("PAN")!=-1 ){
      num = 5;
      }
  if( mode.indexOf("SLIDE")!=-1 ){
      num = 6;
      }
     setbNavCallBack( true ); 
     if(mode.indexOf("*")!=-1){
	 mode.replace('*', ' ');
     mode.trim();
       }
      }
   if(7<=num){  setPrevNav( mode );  }
   else { run.Navigation.select( sPrevNav ); }
      while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleNavigation( num );
      return true;
    }
   }

//New 4_05_04 Adding more functionality with a beam to another avatar capability.

 if( e.target == run.Users ){
	 String act = (String) what;
	    if( act.equals("Beam-to") ){
       boolean bObjtf = false;
       String sBT = null;
       int iBT = -1;
       sBT = run.UserList.getSelectedItem();
       if(sBT!=null){
       if(sBT.startsWith("(I)")){ sBT = null; 
       this.display(name,"This person is on Ignore!" );
       return false;
        }
       iBT = run.UserList.getSelectedIndex();
       if(sBT.startsWith("(X)")){ 
       sBT = sBT.substring(2); }
       if(iBT!=iWS&&iBT!=-1){ run.UserList.deselect( iBT );}
       list = listeners.elements();
      while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleBeamto( sBT, bObjtf );
      return true;
       }
	   else { 
       this.display("Matrix","Please select someone to beam to!" );
       return true;
        }
       }
	  	  if( act.equals("Ignore")){
	        boolean bIggy = false;
       //String tf = null;
       String sIG = null;
       int iIG = -1;
       sIG = run.UserList.getSelectedItem();
       if(sIG!=null||!sIG.equals(name)){
       iIG = run.UserList.getSelectedIndex();
       if(sIG.startsWith("(X)")){
       sIG = sIG.substring(2); 
       run.UserList.replaceItem( "(I)"+ sIG,iIG );
       bIggy = true;
      // tf = "no" ;
       }
       if(!sIG.startsWith("(I)")){ 
       run.UserList.replaceItem( "(I)"+ sIG,iIG );
      // tf = "no"; 
       }
       else { 
       sIG = sIG.substring(2);
       run.UserList.replaceItem( sIG,iIG );
       if(invisible.contains( sIG )){
       invisible.removeElement(sIG);}
       // tf = "yes"; 
       }
       if(!ignored.contains( sIG )){
       ignored.addElement( sIG ); 
       bIgnore = true;}
       else { ignored.removeElement( sIG );
       if(ignored.isEmpty()){ bIgnore = false; }
       run.UserList.deselect( iIG );
        }
      list = listeners.elements();
      while( list.hasMoreElements())
      ((UserInterfaceListener)list.nextElement()).handleIgnore( sIG, bIggy );
      return true;
    }
      else {
      this.display("Matrix","Please select someone to ignore!" );
      return true;
       }
     }
	 if( act.equals("Whisper") ){
 if(iAdmin==1){
 this.display("Matrix","Please close admin control first!" );
 return false;
 }
 else {
 if(iRoom==1){
 closeRoominput();
 }
 if(iWhisp==0){ whisperto = run.UserList.getSelectedItem();
  setiWS( run.UserList.getSelectedIndex() );
  if(whisperto==null||whisperto.equals(name)){
   this.display("Matrix","Please select a user to whisper to!" ); 
   run.UserList.deselect( run.UserList.getSelectedIndex());
  }
  else {
  run.addWhisperinput();
  run.validate();
  setiWhisp( 1 ); }}
  else { int d = iWS;
         int c = run.UserList.getSelectedIndex();
         String foo = run.UserList.getSelectedItem();
  if((c==d&&c!=-1)||(foo!=null&&foo.equals(name))){
   closeWhisperinput();
  }
  else { whisperto = foo; }}
      return true;
      }
    }
     if( act.equals("Hide-Show") ){
       boolean bObjtf = false;
       String sV = null;
       int iV = -1;
       sV = run.UserList.getSelectedItem();
       if(sV!=null){
       if(!sV.startsWith("(I)")){
       iV = run.UserList.getSelectedIndex();
       if(sV.startsWith("(X)")){ sV = sV.substring(2);
       run.UserList.replaceItem( sV,iV );
       if(invisible.contains(sV)){ invisible.removeElement( sV );}
        }
       else {
       run.UserList.replaceItem( "(X)"+ sV, iV );
       if(!invisible.contains(sV)){ invisible.addElement( sV );}
        }
       }
       else { 
       this.display("Matrix","This user is on ignore! Please choose another!" );
       return true;
        }
       if(iV!=iWS&&iWS!=-1){ run.UserList.deselect( iV ); }
	  list = listeners.elements();
      while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleUserView( sV, bObjtf );
      return true;
       }
       else {
       this.display("Matrix","Please select a user!" );
       return true;
         }
       }
	if( act.equals("Stop-Chat-Logging")){
      bLogChat = false;
      resetLogChoice();
      return true;
	  }
	if( act.equals("Start-Chat-Logging")){
      bLogChat = true;
      resetLogChoice();
      return true;
	  }
	 }

  if( e.target == run.Objects ){ 
	   String act = (String) what;
	   if( act.equals("Beam-to") ){ 
	   boolean bObjtf = false;
       String sBT = null;
       int iBT = -1;
       sBT = run.ObjectList.getSelectedItem();
       if(sBT!=null){
       iBT = run.ObjectList.getSelectedIndex();
       if(sBT.startsWith("(X)")){ 
       sBT = sBT.substring(2); }
       if(!sBT.endsWith("(BP)")){
       bObjtf = true;
       }
	   else {
	   this.display("Matrix","Please select an object not marked '(BP)' to beam to!" );
       return true;
       }
       if(iBT!=iMO&&iBT!=-1){ run.ObjectList.deselect( iBT ); }       
       setbGhost( false );
       list = listeners.elements();
      while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleBeamto( sBT, bObjtf );
      return true;
       }
      else { 
       this.display("Matrix","Please select an object to beam to!" );
       return true;
      }
    }
   if( act.equals("Load-Unload")){
       String sLUl = null;
	   int iLUl = -1;
       int iState = 0;
       //String sLUlS = null;
       sLUl = run.ObjectList.getSelectedItem();
       //setiMO( run.ObjectList.getSelectedIndex() );
       if(sLUl!=null){
       if(sLUl.endsWith("(BP)")){ 
       iLUl = sLUl.indexOf("(BP)");
	   sLUl = sLUl.substring(0,iLUl);
	   this.display("Matrix","Requesting server to load object" + sLUl + " into this world..." );
       //sLUlS = "true";
       iState = 1;
       }
       else {
	   if(sLUl.startsWith("(X)")){ 
	   sLUl = sLUl.substring(2);
       }
	   this.display("Matrix","Requesting server to unload object" + sLUl + " from this world..." );
       //sLUlS = "false";
       }
       list = listeners.elements();
	   while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleObjRequest( sLUl, iState );
	   run.ObjectList.deselect(iMO);
       return true;
       }
	   else {
       this.display("Matrix","Please select an object to load into the scene or unload from the scene!" );
       return false;
        }
        }
	     if(act.equals("Move")){
       String sM = null;
     if(bMove==true){
       if(sMove!=null){
	   run.ObjectList.deselect( iMO );
       this.display("Matrix","Please close and clear Prime Mover before trying to move another object!" );
       return true;
       }
       sM = run.ObjectList.getSelectedItem();
       setiMO( run.ObjectList.getSelectedIndex() );
       if(sM!=null){
       if(sM.startsWith("(X)")){ 
       run.ObjectList.deselect( iMO );
       this.display("Matrix","Please make selected object visible to move!" );
       return true;
        }
       else 
	   if(sM.endsWith("(BP)")){
	   run.ObjectList.deselect( iMO );
       this.display("Matrix","Please load the selected object first to move it!" );
       return true;
       }
       else {
       sMove = sM;
       list = listeners.elements();
      while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleObjectRoutes( sMove ); 
       setbMove( false ); 
       return true;
        }
       }
       else {
       this.display("Matrix","Please select an object to move!" );
       return true; 
        }
       }
       else {
       list = listeners.elements();
      while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleObjectRoutes( sMove );
       run.ObjectList.deselect( iMO );
       setiMO( -1 );
       sMove = null;
       setbMove( true );
       return true;
      }
    }
   if( act.equals("Hide-Show") ){
       boolean bObjtf = false;
       String sV = null;
       int iV = -1;
       sV = run.ObjectList.getSelectedItem();
	   iV = run.ObjectList.getSelectedIndex();
       if(sV!=null){
	   if(sV.endsWith("(BP)")){
	   this.display("Matrix","Please select an object not ending in '(BP)' to hide!" );
       return true;
       }
       else {
	   if(sV.startsWith("(X)")){ 
       sV = sV.substring(2); 
       run.ObjectList.replaceItem( sV, iV );
	   if(invisible.contains(sV)){ invisible.removeElement( sV );}
        }
	   if(iV!=iMO){
       run.ObjectList.replaceItem( ("(X)"+sV),iV );
       run.ObjectList.deselect( iV );
	   if(!invisible.contains(sV)){ invisible.addElement( sV );}
        }
        else { 
       if(iMO!=-1){ 
       this.display("Matrix","Please turn off shared objects controls to hide!" );
        return true;
                }
              }
    	  }
	   bObjtf = true;
	   list = listeners.elements();
      while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleUserView( sV, bObjtf );
      return true;

     }
    else {
	       this.display("Matrix","Please select an object!" );
        return true;
    }
   }
   if( act.equals("Object-info") ){
	 this.display("Matrix","'Object-info' command has not been implemented yet!" );
     return true;
   }
	if( act.equals("Load-Sample")){
	 	  boolean bObjtf = false;
       String sBT = null;
       int iBT = -1;
       sBT = run.ObjectList.getSelectedItem();
       if(sBT!=null){
       iBT = run.ObjectList.getSelectedIndex();
       if(sBT.startsWith("(X)")){ 
       sBT = sBT.substring(2); }
       if(sBT.endsWith("(BP)")){
       sBT = sBT.substring(0,sBT.length()-4);
       bObjtf = true;
       }
	   else {
	   this.display("Matrix","Please select an object marked '(BP)' to sample view" );
       return true;
       }
       if(iBT!=iMO&&iBT!=-1){ run.ObjectList.deselect( iBT ); }       
       setbGhost( false );
       list = listeners.elements();
      while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleLoadSample( sBT, bObjtf );
      return true;
       }
   }
  if( act.equals("Send-Matrix-Messages")){
  if(iMTM==0){
    if(iAdmin==1){
   this.display("Matrix","Please close admin control first!" );
   return false;
     }
  if(iWhisp==1){ 
  closeWhisperinput();
   }
  if(iRoom==1){ 
   closeRoominput();
    }
 run.addMatrixMsginput();
  iMTM = 1;
    }
 else {
 closeMatrixMsginput();
     }
   }
  }
 if( e.target == run.Worlds ){
	 String act = (String) what;
	  if( act.equals("Enter")){
	   String sV = null;
       int iV = -1;
       sV = run.RoomList.getSelectedItem();

      if(sV==null){ 
	  this.display("Matrix","Please select a world to enter!" );
      }
      else {
      sV = sV.substring(0,sV.indexOf(" ("));
      list = listeners.elements();
      while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleRoomRequest( sV );
       }
      return true;
     }
	if( act.equals("Set-as-Start-Room")){
	 String sV = null;
       int iV = -1;
       sV = run.RoomList.getSelectedItem();
      if(sV==null){ 
	  this.display("Matrix","Please select a world to set as start room!" );
      }
      else {
      sV = sV.substring(0,sV.indexOf(" ("));
      list = listeners.elements();
      while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).setStartRoom( sV );
      this.display("Matrix",sV + " is now set as your initial re-connect start room after disconnecting." );
       }
      return true;
     }
//     if( act.equals("Remove-World")){
//     String sR = null;
//        sR = run.RoomList.getSelectedItem();
//        if(sR==null){ 
// 	  this.display("Matrix","Please select a world to remove!" );
//       return true;
//       }
//  else {
// 	 sR = sR.substring(0,sR.indexOf(" ("));
//      list = listeners.elements();
//    while( list.hasMoreElements())
//         ((UserInterfaceListener)list.nextElement()).handleNewRoom( sR, "remove" );
//       return true;	
//       }
//     }
    if( act.equals("Get-Members")){
 this.display("Matrix","Requesting list from server of this world's members." );
      list = listeners.elements();
   while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleRoomControl( RoomControl.GET, new String ( this.name + sRoompass ), new String [] {"get"}  );
      return true;
     }
  if( act.equals("World's Objects")){
 this.display("Matrix","'World's Objects' command is not yet implemented!" );
    return true;
  }
 if( act.equals("Owner's-Password")){
 this.display("Matrix","'Owner's-Password' command is not yet implemented!" );
	return true;
  }
  if( act.equals("Add-Remove-World")){
 if(!bAddRoomState){
  if(iAdmin==1){
 this.display("Matrix","Please close admin control first!" );
 return false;
 }
 else {
	 if(iWhisp==1){ 
     closeWhisperinput();
     }
     if(iMTM==1){
	 closeMatrixMsginput();
     }
	 run.addRoominput();
     setiRoom( 1 );
     run.validate();
  this.display("Matrix","Please enter a world name followed by a pound sign and then a password of your choice into the World input!" );
  this.display("Matrix","example: 'chess2#wxyz9' Without single quotes!" );
   setbAddRoomState( true );
     return true;
      }
  }
 else {
	closeRoominput();
     return true;
 }
    }


   if( act.equals("Set-Public")){
  String foo;
  if(!bPublic){
  foo = "public";
  setbAddRoomState( false );
   }
  else {
  this.display("Matrix","Error! this world is already set to public!" );
  foo = "private";
  }
  list = listeners.elements();
   while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleRoomControl( RoomControl.SET, new String ( this.name + sRoompass ), new String [] {foo}  );
  setbAddRoomState( false );
  return true;
     }
  if( act.equals("Owner's-Password")){
   if(!bRoompass){
  if(iAdmin==1){
 this.display("Matrix","Please close admin control first!" );
 return false;
 }
 else {
	 if(iWhisp==1){ 
     closeWhisperinput();
     }
       if(iMTM==1){
	 closeMatrixMsginput();
     }
	 run.addRoominput();
     setiRoom( 1 );
     run.validate();
  this.display("Matrix","Please enter your room ownership password!" );
   setiRoomadd( 5 );
   bRoompass = true;
     return true;
      }
  }
 else {
  run.remove( run.Roominput );
  setiRoom( 0 );
  bRoompass = false;
  run.validate();
     return true;
 }
    }
      if( act.equals("Set-Private")){
  String foo;
  if(bPublic){
  foo = "private";
  setbAddRoomState( false );
   }
  else {
  this.display("Matrix","Error! this world is already set to public!" );
  foo = "public";
  }
  list = listeners.elements();
   while( list.hasMoreElements())
       ((UserInterfaceListener)list.nextElement()).handleRoomControl( RoomControl.SET, new String ( this.name + sRoompass ), new String[] {foo} );
  return true;
     }
   if( act.equals("Add-Members")){
    if(!bAddRoomState){
  if(iAdmin==1){
 this.display("Matrix","Please close admin control first!" );
 return true;
 }
 else {
	 if(iWhisp==1){ 
      closeWhisperinput();
     }
	  if(iMTM==1){
	 closeMatrixMsginput();
     }
	 run.addRoominput();
     setiRoom( 1 );
     run.validate();
   this.display("Matrix","Enter new member names seperated by a comma into world input." );
   setiRoomadd( 3 );
   setbAddRoomState( true );
     return true;
      }
  }
   else {
    closeRoominput();
       return true;
   }
     }
   if( act.equals("End-Members")){
    if(!bAddRoomState){
  if(iAdmin==1){
 this.display("Matrix","Please close admin control first!" );
 return true;
 }
 else {
	 if(iWhisp==1){ 
      closeWhisperinput();
     }
       if(iMTM==1){
	 closeMatrixMsginput();
     }
	 run.addRoominput();
     setiRoom( 1 );
    setiRoomadd( 4 );
     run.validate();
 this.display("Matrix","Enter member names seperated by a comma into world input." );
   setbAddRoomState( true );
     return true;
      }
  }
    else {
    closeRoominput();
       return true;
   }
    }
   }
   if( e.target == run.Roominput ){
   String st = (String)what;
   if(st==null){
   if(iRoomadd==0){
  this.display("Matrix","Please enter a world name followed by a pound sign and then the password!" );
  this.display("Matrix","example: 'chess2#wxyz9' Without single quotes!" );
    }
   if(iRoomadd==1){this.display("Matrix","Please enter a world url!" );	}
   if(iRoomadd==3){this.display("Matrix","Please enter names of new members!" );}
   if(iRoomadd==4){this.display("Matrix","Please enter names of members to remove!" ); }
   if(iRoomadd==5){this.display("Matrix","Please enter your password to access room controls!" ); }
   return true;
   }
   else {
   StringTokenizer token;
 //  if(st.indexOf("World input:")==0){ 
 //  st = st.substring(12);
 //  }
 //  if(st.endsWith("World input:")){
 //  st = st.substring(0,st.length()-12);
 //   }
   st = st.trim();
   if(st.indexOf("(")!=-1||st.indexOf(")")!=-1){ 
   this.display("Matrix","World name must not have '(' , ')' , '#' as characters or contain spaces!" );
   return true;
  }
if(st!=null){ 
  if(iRoomadd==0){ 
 int iP = 0; 
 for(int ct = 0; ct<st.length(); ct += 1){
 if(st.charAt(ct)=='#'){ iP += 1; }
 }
 if(iP==0){
  this.display("Matrix", "Please use a pound sign (#) as a seperator between the world name and your password!" );
  return true;
  }
 if(1<iP){
 this.display("Matrix", "Both the world name and your password can not contain the pound sign (#)!" );
 return true;
 }
 if(iP==1&&st.indexOf("#")==(st.length()-1)){
 this.display("Matrix", "Please include a password!" );
 return true;
 }
 if(iP==1&&st.indexOf("#")==0){
 this.display("Matrix", "Please include a name!" );
 return true;
 }
 String st2 = st.substring(0,st.indexOf("#"));
 if(25<st2.length()){
  this.display("Matrix","World name must be less then twenty six characters!" ); 
   return true;
  }
	newWorldName = st;
  run.Roominput.setText("");
  this.display("Matrix", "Step 2: To add your world please enter either its url starting with 'http://'," );
  this.display("Matrix", " or to remove your world just type 'remove' (minus quotes)." );   
    setiRoomadd( 1 );
    return true;
         } 
   if(iRoomadd==1){ 
   newWorldUrl = st;
   if(st.startsWith("http://")){
   this.display("Matrix","You will soon be transfered to your new world!" );
   } 
   else {
   if(!st.equals("remove")){
   this.display("Matrix","Please begin url with 'http://'!" );
   return true;
     }
   }
  list = listeners.elements();
   while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleNewRoom( newWorldName, newWorldUrl );
    closeRoominput(); 
    run.validate();
      return true;
        }
    if(iRoomadd==3||iRoomadd==4){
   String [] mems;
   if(st.indexOf(",")==-1){ 
   mems = new String [] {st};
   }
   else {
    int iStl = 1;
   for( int i = 0; i<st.length(); i +=1){
   if(st.charAt(i)==(',')){ iStl +=1; }
   }
   mems = new String [iStl];
   for( int i = 0; i<iStl; i +=1){
   int i2 = st.indexOf(",");
  if(i2!=-1){ mems[i] = st.substring(0,i2);
   st = st.substring(i2+1);
    }
  else { 
   mems[i] = st;
     }
    }
   }
   boolean tf = true; 
    if(iRoomadd==4){ 
   tf = false;
   }
  String stest = "";
  for(int j = 0; j<mems.length; j +=1 ){
 if(j<mems.length-1){ stest += (mems[j]+","); }
 else { stest += mems[j]; }
  }
   int iCom = 0;
    if(tf){ iCom = RoomControl.ADDMEM; }
    else { iCom = RoomControl.REMMEM; }
   list = listeners.elements();
   while( list.hasMoreElements())
  ((UserInterfaceListener)list.nextElement()).handleRoomControl( iCom, new String ( this.name + sRoompass ), mems );
   closeRoominput();
    return true;
        }
  if(iRoomadd==5){
  sRoompass = st;
    list = listeners.elements();
   while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleRoomControl( RoomControl.PASSWD, new String ( this.name + st ), new String [] {st}  );
   closeRoominput();
   return true;
    	}
       }
   else {
  if(iRoomadd==0){
  this.display("Matrix","Please enter a world name followed by a pound sign and then the password!" );
  this.display("Matrix","example: 'chess2#wxyz9' Without single quotes!" );
    }
   if(iRoomadd==1){this.display("Matrix","Please enter a world url!" );	}
   if(iRoomadd==3){this.display("Matrix","Please enter names of new members!" );}
   if(iRoomadd==4){this.display("Matrix","Please enter names of members to remove!" ); }
   if(iRoomadd==5){this.display("Matrix","Please enter your password to access room controls!" ); }
   return true;
         }
      }
     }
 if( e.target == run.Admin ){
 String act = (String) what;
 if(act.equals("Add-New-User")){
 if(1<iPL){ this.display("Matrix","Admin first enter name of approved user!" );
  setiPLCT( 1 );
 }
 else {
  this.display("Matrix","Admin please enter name of approved user!" );
 }
  setiAC( AdminControl.NEWUSR );
  }
 if(act.equals("Ban-User")){
  this.display("Matrix","Admin please enter the name of user to be banned!" );
  setiAC( AdminControl.BANUSR );
  } 
 if(act.equals("Ban-Address")){
  this.display("Matrix","Admin please enter the address to be banned!" );
  setiAC( AdminControl.BANADD );
  } 
 if(act.equals("Approve-World")){
    setiAC( AdminControl.APRVRM ); 
	this.display("Matrix","Admin please enter a world to approve!" );
   return true;
 }
 if(act.equals("Remove-World")){
    setiAC( AdminControl.REMRM ); 
	this.display("Matrix","Admin please enter a world to remove!" );
   return true;
  }
  if(act.equals("Clear-Events")){
    setiAC( AdminControl.CLREVN ); 
	this.display("Matrix","Admin please enter the world to be cleared of events!" );
   return true;
  }
 if(act.equals("Add-New-Object")){
 //  this.display("Matrix","Admin, 'Add-New-Object' command is not yet implemented!" );
  setiAC( AdminControl.NEWOBJ );
   this.display("Matrix","Admin please enter the information of the object to be added!" );
// this.display("Matrix","Admin the information has to be five items seperated by commas." );
  this.display("Matrix","Admin the information has to be three items seperated by commas." );
  //this.display("Matrix","1. name of object 2. object's url 3. object's creator's name 4. object's owner's name 5. The number of objects available" );
 this.display("Matrix","1. name of object 2. object's url 3.Room name for location of Object");
   this.display("Matrix","For example (minus single quotes): 'Mobius,http://www.foobar.net/vrml/mobius.wrl,matrix");
// this.display("Matrix","For example (minus single quotes): 'Mobius,http://www.foobar.net/vrml/mobius.wrl,Pyth7,Pyth7,10'");
//  iAC = AdminControl.NEWOBJ;
  }
 if(act.equals("Remove-Object")){
 // this.display("Matrix","Admin, 'Remove-Object' command is not yet implemented!" ); 
  setiAC( AdminControl.REMOBJ );
 this.display("Matrix","Admin please enter the name of the object to be removed and it's room seperated by a comma with no spaces!" );
  this.display("Matrix","For example (minus single quotes): 'Mobius,matrix");
 // iAC = AdminControl.REMOBJ;
  }
 if(act.equals("Drop-Rights-Enabled")){
 this.display("Matrix","Admin, 'Drop-Rights-Enabled' command in not yet implemented!" );
  setiAC( -1 );
//  iAC = AdminControl.DRPTRU;
//  this.display("Matrix","Admin please enter a world name for addition of object drop rights!");
  }
 if(act.equals("Drop-Rights-Disabled")){
this.display("Matrix","Admin, 'Drop-Rights-Disabled' command in not yet implemented!" );
 setiAC( -1 );
//  iAC = AdminControl.DRPFAL;
//  this.display("Matrix","Admin please enter a world name for removal of object drop rights!");
  }
  if(act.equals("Remove-World+Ban")){
   setiAC( AdminControl.REMBAN );
  this.display("Matrix","Admin please enter a world name for both the removal and banning of its creator!");
  }
 if(act.equals("Close" )){
 list = listeners.elements();
      while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).setUpAdmin( AdminControl.DONE, "d","d" );
 setiAC( -1 );
   }
  }
 if( e.target == run.Speed ){
  String act = (String) what;
 if(act!=null){
 if(act.equals("Faster")){  
	   //setfSpeed( fSpeed + (float) 1.0 );
      list = listeners.elements();
      while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleSpeed( (fSpeed + (float) 1.0) );     
      return true;
    }
 if(act.equals("Slower")&&0<=(fSpeed - (float) 1.0 )){
	   //setfSpeed( fSpeed - (float) 1.0 );
      list = listeners.elements();
      while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleSpeed( (fSpeed - (float) 1.0) );
         return true;
       }
     }
    }
//New 4_05_04 Adding more functionality to obscured whispering capability.
 
if(iWhisp==1){
  if( e.target == run.Whisperinput ){
      String line =  "whispered: " + (String) what;
      list = listeners.elements();
      while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).setUpChat( line, whisperto );
      run.Whisperinput.setText("");
      return true;
    }
}
   if( e.target == run.MatrixMsginput ){
     String st = (String)what;
   if(st!=null){
String [] mst = null;
  st = st.trim();
  //st = st.substring(17);
if(st.indexOf("\\")!=-1){
Vector vMMi = new Vector();
int iCt1 = 0;
int iCt2 = 0;
for( int x = 0; x<st.length(); x +=1 ){
String sMMi = null;
 if(st.charAt(x)=='\\'){
 sMMi = st.substring(iCt2,x); 
 sMMi = sMMi.trim();
 iCt2 = x+1; 
if(!sMMi.equals("")){ vMMi.insertElementAt(sMMi,iCt1); 
iCt1 += 1;
     }
   }
if(x==st.length()-1){
 sMMi = st.substring(iCt2); 
 sMMi = sMMi.trim(); 
if(!sMMi.equals("")){vMMi.insertElementAt(sMMi,iCt1);}
  }
 }
if(!vMMi.isEmpty()){
mst = new String[vMMi.size()];
for( int y = 0; y<vMMi.size(); y += 1 ){
mst[y] = (String)vMMi.elementAt(y);
   }
  }
 }
else {
if(!st.equals("")){ mst = new String[] {st}; }
}
if(mst!=null){ 
 list = listeners.elements();
    while( list.hasMoreElements())
    ((UserInterfaceListener)list.nextElement()).handleMatrixTextMsgs( mst );
  }
 run.MatrixMsginput.setText("");
 return true;
     }
   }
  if( e.target == run.Admininput ){
    if(iAC!=-1) { 
   String st = (String)what;
   if(st==null){
   this.display("Matrix","Admin please enter relevant information!" );
   }
   else {
   //if(st.indexOf("Admin input:")==0){ 
   //st = st.substring(12);
   //}
   //if(st.endsWith("Admin input:")){
   //st = st.substring(0,st.length()-12);
   // }
	st = st.trim();
  if(iAC==AdminControl.NEWOBJ){
  String [] sFoo = new String [3];
  int iCt = -1;
  int iC = 0;
  String st2 = st;
  boolean bTf = true;
  for( int i = 0; i<st2.length(); i +=1 ){
  if(st2.charAt(i)==(',')){
   iCt += 1; 
  sFoo[iCt] = st2.substring(iC,i);
  iC = i+1;
  if(iCt==1){ 
  sFoo[2] = st2.substring(i+1);
  break;
     }
    }
   }
 if(sFoo[0]!=null){
  if(sFoo[0].length()==0){
 this.display("Matrix","Admin: Add-Object has failed! The first entry of object's name is incomplete!" );
  bTf = false;
  return true;
    }
   }
 else {
 this.display("Matrix","Admin: Add-Object has failed! The first entry of object's name is null!" );
  bTf = false;
  return true;
  }
// if(sFoo[1]!=null){
// if(sFoo[1].length()==0||sFoo[1].indexOf("http://")!=0){
//  this.display("Matrix","Admin: Add-Object has failed! The second entry of object's url must start with 'http://'!" );
//  bTf = false;
//  return true;
//   }
 // }
   if(sFoo[1]==null){
   this.display("Matrix","Admin: Add-Object has failed! The second entry of object's url is null!" );
    bTf = false;
  return true;
   }
  if(sFoo[2]!=null){
 if(sFoo[2].length()==0){
 this.display("Matrix","Admin: Add-Object has failed! The third entry of object's room location is incomplete!" );
  bTf = false;
  return true;
  }
 }
 else {
 this.display("Matrix","Admin: Add-Object has failed! The third entry of object's room location is null!" );
  bTf = false;
  return true;
  }
 if(bTf){
if(iCt==1){ 
    list = listeners.elements();
    while( list.hasMoreElements())
    ((UserInterfaceListener)list.nextElement()).setUpAdmin( iAC, "d", st );
   run.Admininput.setText("");
    //	setiAC( -1 );
   }
 else {
 this.display("Matrix", "Admin: Too many commas are in the entry for Add-Object!"); 
  return true;
    }
   }
  }
  else 
   if(iAC==AdminControl.REMOBJ){
  String [] sFoo = new String [2];
  int iCt2 = 0;
  int iCt3 = 0;
  boolean bTf = true;
  for( int i = 0; i<st.length(); i +=1 ){
  if(st.charAt(i)==(',')){
   iCt2 += 1; iCt3 = i;
      }
   }
  if(iCt3==0||iCt2==0||iCt3==st.length()-1){
   this.display("Matrix", "Admin: The name and room of the object to be removed must be seperated by commas!"); 
  return true;
  }
  if(1<iCt2){
   this.display("Matrix", "Admin: Too many commas are in the entry for Remove-Object!"); 
  return true;
  }
  sFoo[0] = st.substring(0,iCt3);
  sFoo[1] = st.substring(iCt3+1);
  list = listeners.elements();
    while( list.hasMoreElements())
    ((UserInterfaceListener)list.nextElement()).setUpAdmin( iAC, sFoo[0], sFoo[1] );
	run.Admininput.setText("");
    //	setiAC( -1 );
	}
 else 
 if(iAC==AdminControl.NEWUSR){
 if(iPL==3){
 if(iPLCT==1){
  sNEWUSR[0] = st; 
 this.display("Matrix", "Admin: Next please enter the password for the user!"); 
 setiPLCT( 2 );
   }
 else {
 sNEWUSR[1] = st; 
 list = listeners.elements();
    while( list.hasMoreElements())
    ((UserInterfaceListener)list.nextElement()).setUpAdmin( iAC, sNEWUSR[0], sNEWUSR[1] ); 
 setiPLCT( 0 );
   }
  }
 else {
  if(iPL==2){
 sNEWUSR[0] = st;
 sNEWUSR[1] = "";
     list = listeners.elements();
    while( list.hasMoreElements())
    ((UserInterfaceListener)list.nextElement()).setUpAdmin( iAC, sNEWUSR[0], sNEWUSR[1] );
   }
  }
 }
 else {
 list = listeners.elements();
    while( list.hasMoreElements())
    ((UserInterfaceListener)list.nextElement()).setUpAdmin( iAC, "d", st );
  	setiAC( -1 );
   }
   }
   } 
     else {
this.display("Matrix","Please make a choice from Admin options first!" );
     }
  run.Admininput.setText("");
      return true;
    }
 }
 else {
 return false;
  }
 return super.action( e, what );
  }


//  public void paint( Graphics g )  {
//    g.drawImage( cImg, 150, 300, parent );
//  }

  /**
  *	New 07-05-09 A filter for ignored  network users is needed before going to the synchronized
  *	display call. The bIgnore boolean is NOT redundant! It is faster for to use a simple boolean
  * than to constantly review the ignored Vector when it is not needed.
  */

  public void networkChatInput( String from, String line ){
   	  if(!bIgnore){
      display( from, line );
    }
      else {
     if(!ignored.contains(from)){
     display( from, line );
     }
   }
  }


/**
 * writes formatted text lines into TextArea.
 * More or less decent output into main TextArea plus workaround
 * for MS textarea bug. In Windows ( 95 only ? ) the textarea only holds
 * about 30000 chars.
 * New 11-12-05 The amount aloted for char display was shortened to 25000 for a bug in Netscape. 
 */
      public synchronized void display( String from, String line ){
 if( run.Chatarea.getText().length() < 25000 ) {
    FontMetrics met = run.Chatarea.getFontMetrics( run.Chatarea.getFont());
    String out = from+" :", tok;
    String help = out;
    StringTokenizer token = new StringTokenizer( line, " ");
    while( token.hasMoreTokens()){
      tok = token.nextToken();
      help = out +" "+tok;
      if( met.stringWidth( help ) > run.Chatarea.size().width - 20){
        run.Chatarea.appendText( out+"\n" );
        out = "     ";
      }
      out += " "+tok;
    }
    run.Chatarea.appendText( out+"\n");
 } else {
    run.Chatarea.replaceText("",0,10000);  
   }
 if(bLogChat){
 CL.println( new String [] {from,line} );
  }
  }

  public void setStatus( String line ){
    login.Status.setText( line );
  }


public void setObjList( boolean tf ){

}

  public synchronized void setAdmin( int arg ){
	 switch( arg ){
        case 1 :
		if(iWhisp==1){ 
        closeWhisperinput();
        }
	    if(iRoom==1){ 
        closeRoominput();
        }
        if(iMTM==1){
		closeMatrixMsginput();
        }
        run.addAdmininput();
		setiAdmin( 1 );
        break;
        case 2 :
     try {
      run.Admin.remove( "Admin" );
     }
    catch(IllegalArgumentException e){}
      run.Admin.insert("Admin",0);
        run.Input.setText("");
        run.remove( run.Input );
    	run.remove( run.Admininput );
        run.remove( run.Admin );
        setiAdmin( 0 );
        setiAC( -1 );
        break;
        }
       run.validate();
  }

  private synchronized void setPrevNav( String st ){
  sPrevNav = st;
  }

  private synchronized void closeWhisperinput(){
  run.Input.setText("");
  run.remove( run.Input );
  run.Whisperinput.setText("");
  run.remove( run.Whisperinput );
  setiWS( -1 );
  whisperto = null;
  run.validate(); 
  run.UserList.deselect( run.UserList.getSelectedIndex());
  setiWhisp( 0 );
  }

  private synchronized void closeRoominput(){
  run.Input.setText("");
  run.remove( run.Input );
  setiRoomadd( 0 );
  newWorldName = null; 
  newWorldUrl = null;
  setbAddRoomState( false );
  run.Roominput.setText("");
  run.remove( run.Roominput );
  setiRoom( 0 );
  }

  private synchronized void closeMatrixMsginput(){
  run.Input.setText("");
  run.remove( run.Input );
  run.MatrixMsginput.setText("");
  run.remove( run.MatrixMsginput );
  iMTM = 0;
  }

/**
 * New 11-12-05 resetSelect If user was in whisper mode and used "beamto"
 * this method re-selects person whispered to.
 */

  public void resetSelect (){
if(whisperto!=null){ run.UserList.select(iWS);}
}

  public void resetIgnore( String iggy, String st ){
 //   Enumeration list;
 //  list = listeners.elements();
 //     while( list.hasMoreElements())
 //     ((UserInterfaceListener)list.nextElement()).handleIgnore( iggy, st );
 } 

  public boolean checkIgnored( String nm ){
   if(ignored.contains(nm)){
   return true;
   }
   else {
   return false;
   }
  } 
  

  public void resetObjectMove( String mv ){
       String st = null;
       Enumeration list;
        if(iMO!=-1){
         st = run.ObjectList.getItem(iMO);
       if(st!=null){ 
       if(st.equals(mv)){
      list = listeners.elements();
      while( list.hasMoreElements())
        ((UserInterfaceListener)list.nextElement()).handleObjectRoutes( mv );
     sMove = null;
     setbMove( true );
      setiMO( -1 );
        }
      }
     }
  }


  public void setSize( int xsize, int ysize ){
	 iXsize = xsize;
     iYsize = ysize;
     login.setSize( xsize, ysize );
   }

 /**
 * New 11-12-05 resetGui Removes ability to chat or whisper during transition period between rooms. 
 * Keeps chat off the network. 
 */
 


  public void resetGui(){
  bNone = false;
  bGhostReady = false;
  bHeadlightState = true; 
  bMasterCollision = false;
  bCollideState = true;
 whisperto = null;
 sMove = null;
 beamtoselect = null;
 setbMove( true );
 setiRoomadd ( 0 );
 setbAddRoomState( false );
 setbGhost( false );
 bGhostHUD = false;
 setiGhostCt( -1 );
 setiAC( -1 );
 setiPLCT( 0 );
 setiWS( -1 );
 setiMO( -1 );
 run.Viewpoints.removeAll();
 run.Viewpoints.add("Viewpoints");
 if(bSiteButton){
 run.SiteButton.setLabel("");
 run.remove( run.SiteButton );
 if(IBA!=null){ IBA.stop(); }
 run.remove( run.Viewpoints );
 run.remove( run.Gesture );
 run.remove( run.Navigation );
 run.remove( run.Speed );
 run.remove( run.Disconnect );
 run.addSiteLabel("");
 run.addViewpoints();
 run.Viewpoints.repaint(25);
 run.addGesture();
 run.Gesture.repaint(25);
 run.addNavigation();
 run.Navigation.repaint(25);
 run.addSpeed();
 run.Speed.requestFocus();
 run.Speed.repaint(25);
 run.addDisconnect();
 run.Disconnect.requestFocus();
 run.Disconnect.repaint(25);
 run.validate();
 bSiteButton = false;
 }
 if(bSiteLabel){
 //run.SiteLabel.setText("");
 bSiteLabel = false;
 }
 	if(iWhisp==1){ 
		closeWhisperinput();
        }
	    if(iRoom==1){ 
		closeRoominput();
        }
       if(bMTM){ 
		closeMatrixMsginput();
	      try {
	run.Objects.remove( "Send-Matrix-Messages" );
     }
	catch(IllegalArgumentException e){}
      bMTM = false;
        }
	if(iAdmin==1){ 
		run.Input.setText("");
        run.remove( run.Input );
		run.remove( run.Admininput );
		run.remove( run.Admin );
        setiAdmin( 0 );
        }
	run.Chatinput.setText("");
    run.Chatarea.setText("");
    run.Navigation.removeAll();
    run.ObjectList.removeAll();
    run.Gesture.removeAll();
    run.UserList.removeAll();
	run.RoomList.removeAll();
         try {
      run.Admin.remove( "Admin" );
      run.Worlds.remove( "Worlds" );
	  run.Users.remove( "Users" );
	  run.Objects.remove( "Objects" );
      }
    catch(IllegalArgumentException e){}
      run.Admin.insert("Admin",0);
      run.Worlds.insert("Worlds",0);
	  run.Users.insert("Users",0);
	  run.Objects.insert("Objects",0);
     run.validate();
 }


private synchronized void setbNavCallBack( boolean tf ){
bNavCallBack = tf;
}

public synchronized void setNavChange(  String [] types ){
 if(types!=null){
Vector vSort = new Vector();
int iBlk = -1;
for( int i = 0; i<types.length; i +=1 ){ 
if(types[i].indexOf(" ")==-1||types[i].length()!=0||types[i].equals("")){ 
iBlk += 1; 
vSort.add(iBlk,types[i]);
  }
} 
String [] sSort = new String [ vSort.size() ];
for( int i = 0; i<vSort.size(); i +=1 ){ 
 sSort[i] = (String)vSort.elementAt(i);
  } 
boolean bAny = false;
sNavTypes = new String [sSort.length];
for( int i = 0; i<sSort.length; i +=1 ){
if( !sSort[i].equals("NONE") ){ 
bNone = false;
if( !sSort[i].equals("ANY")){ 
sNavTypes[i] = sSort[i].toUpperCase();
}
else {
  bAny = true;
 } 
}
else {
 run.Navigation.removeAll();
 run.Navigation.add("*NONE*"); bNone = true;
break;
 }
}
if(!bNone){
if(bAny){
if(sSort.length==1){ 
sNavTypes = sArchTypes; 
  } 
else {
String [] sAT = new String [7];
String [] sAT2 = new String [6];
sAT[0] = sNavTypes[0];
int iNavCt = -1;
for( int k = 0; k<sArchTypes.length; k +=1 ){
 if(!sArchTypes[k].equals(sNavTypes[0])){ iNavCt +=1;
  sAT2[iNavCt] = sArchTypes[k];
    }
  }
for( int l = 0; l<sAT2.length; l +=1 ){
sAT[l+1] = sAT2[l];
  }
sNavTypes = sAT;
 }
}
 run.Navigation.removeAll();
 String st = null;
 for( int j = 0; j<sNavTypes.length; j +=1 ){
 if(j==0){ st = ("*"+sNavTypes[0]+"*"); setPrevNav( st ); }
 else { st = sNavTypes[j]; } 
 if(st!=null){ run.Navigation.add(st); }
   }
if(bGhostReady){
int iGhpl = 1;
if(1<run.Navigation.countItems()){ 
iGhpl = 2;
 } 
if(!bGhost){
  run.Navigation.insert("Ghost",iGhpl); 
}
else {
 run.Navigation.insert("*Ghost*",iGhpl);
   }
  }
 run.Navigation.add("Straighten Up");
if(bHeadlightState){ run.Navigation.add("Headlight: ON"); }
else {run.Navigation.add("Headlight: OFF");    }
if(bMasterCollision){
run.Navigation.add("Collision: ON");
}
else {
if(bCollideState){ run.Navigation.add("Collision: ON");}
else { run.Navigation.add("Collision: OFF");}
  }
 }
}
//if(bNavCallBack){ setbNavCallBack( false ); }
run.validate();
}

 public void setGhostNav(){
 if(!bGhostReady){
   int iGhpl = 1;
if(1<sNavTypes.length){ 
iGhpl = 2;
 }
if(!bGhost&&!bNone){
  run.Navigation.insert("Ghost",iGhpl);
  }
  bGhostReady = true;
   }
 run.Speed.requestFocus();
 run.Speed.repaint(25);
 run.Disconnect.requestFocus();
 run.Disconnect.repaint(25);
 run.validate(); 
  }

 public void setRoomName( String room ){
 this.room = room;
 }

 private synchronized void setfSpeed( float ft ){
 fSpeed = ft;
 try {
    run.Speed.remove(0);
     }
  catch(IllegalArgumentException e){}
    
 run.Speed.insert( ("Speed: " + new Float(fSpeed).intValue() ), 0 );
 }


 public void setLableAnchorInfo( boolean bBC, String mst [] ){
 run.remove( run.SiteLabel );
 run.remove( run.Viewpoints );
 run.remove( run.Gesture );
 run.remove( run.Navigation );
 run.remove( run.Speed );
 run.remove( run.Disconnect );
if(bBC){
if(mst[0]!=null){ run.addSiteButton( mst[0] );	}
 IBA = new IButtonAnchor( true, mst[1] );
 bSiteButton = true;
 }
else {
if(mst[0]!=null){ 
 run.addSiteLabel( mst[0] );
  bSiteLabel = true;
}
 }
 
 run.addViewpoints();
 run.Viewpoints.repaint(25);
 run.addGesture();
 run.Gesture.repaint(25);
 run.addNavigation();
 run.Navigation.repaint(25);
 run.addSpeed();
 run.Speed.requestFocus();
 run.Speed.repaint(25);
 run.addDisconnect();
 run.Disconnect.requestFocus();
 run.Disconnect.repaint(25);
 run.validate();
}

 public void handleBGColor( Color cBg ){
 Cbg = cBg;
 run.setBGColor( cBg );
 }

 public void handleFGColor( Color cFg ){
 Cfg = cFg;
 run.setFGColor( cFg );
 }

 public void handleBGColor2(){
 if(Cbg!=null){
 login.setBGColor( Cbg );
  Cbg = null;
 }
 }

 public void handleFGColor2(){
 if(Cfg!=null){
 login.setFGColor(Cfg);
   Cfg = null;
 }
 }

 public void setCollide_Headlight( boolean bHL, boolean bMCOL, boolean bCOL ){
 // System.out.println("Frontend setCollide_Headlight bHL: " + bHL + " bMCOL: " + bMCOL + " bCOL: " + bCOL);
 bHeadlightState = bHL;
 bMasterCollision = bMCOL;
 bCollideState = bCOL;
 }

 public void setViewDescriptions( String [] sDescs ){
 run.Viewpoints.removeAll();
 int iRev = (sDescs.length-1);
 for( int i = 0; i<sDescs.length; i++ ){
 if(i==0){ run.Viewpoints.add(sDescs[i]); }
 else { if(0<iRev){ run.Viewpoints.add(sDescs[iRev]); iRev -=1; 
     }
    }
   }
 }

private synchronized void setfHeadlight( float ft ){
boolean bHL = false;
String sHL = "";
 if(ft==-1){
 sHL = "ON";
bHL = true;
 }
else { 
 sHL = "OFF";
bHL = false;
 }
if(bHL!=bHeadlightState){
int	iHL = run.Navigation.getItemCount();
for(int iCt = 0; iCt<iHL; iCt += 1 ){
String st = run.Navigation.getItem(iCt);
if(st.indexOf("Headlight:")!=-1){
try {
run.Navigation.remove(iCt);
}
catch(IllegalArgumentException e){}
run.Navigation.insert( ("Headlight: " + sHL ), iCt );
bHeadlightState = bHL;
break;
    }
   }
  }
 }

private synchronized void setfCollide( float ft ){
boolean bCL = false;
String sCL = "";
 if(ft==-3){
 sCL = "ON";
bCL = true;
 }
else { 
 sCL = "OFF";
bCL = false;
 }
if(bCL!=bCollideState){
int	iCL = run.Navigation.getItemCount();
for(int iCt = 0; iCt<iCL; iCt += 1 ){
String st = run.Navigation.getItem(iCt);
if(st.indexOf("Collision:")!=-1){
try {
run.Navigation.remove(iCt);
}
catch(IllegalArgumentException e){}
run.Navigation.insert( ("Collision: " + sCL ), iCt );
bCollideState = bCL;
break;
    }
   }
  }
 }

 public void setSpeedChange( float ft ){
if(0.0<=ft){  setfSpeed( ft );	}
else {
if(-3<ft){
  setfHeadlight( ft );
 }
else {
if(-5<ft){  
  setfCollide( ft );	
   }
else {
if(ft==-5){ 
 bMasterCollision = true;
 setfCollide(-3);
// System.out.println(" setSpeedChange: -5 ft is " + ft );
  }
if(ft==-6){ 
 bMasterCollision = false;
// System.out.println(" setSpeedChange: -6 ft is " + ft );
  }
       }
     }
   }
 }

 public void setMatrixText(){
 run.Objects.add("Send-Matrix-Messages");
 run.addMatrixMsginput();
  iMTM = 1;
 bMTM = true;
 run.validate();
 }

  // adding / removing UserInterfaceListener

  public void addUserInterfaceListener( UserInterfaceListener listener ){
    if( ! listeners.contains( listener ))
      listeners.addElement( listener );
  }

  public void removeUserInterfaceListener( UserInterfaceListener listener ){
    listeners.removeElement( listener );
  }
  
 private void resetLogChoice(){
 String st = null;
 if(bLogChat){
 st = "Stop-Chat-Logging";
 }
 else {
 st = "Start-Chat-Logging";
 }
 try {
    run.Users.remove(5);
     }
  catch(IllegalArgumentException e){}
  run.Users.insert( st, 5 );
 }

 public void closeChatLogger(){
 if(CL!=null){ CL.stop(); }
 }

}
