 /*
  RunPanel.java

  Copyright (C) 1998 Geometrek	and 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */  

package matrix.deck;

import java.awt.*;

/**
 * RunPanel puts together the components for the client's use after login.
 */

public class RunPanel extends BorderPanel
{
  
  protected TextArea Chatarea = null;
  protected TextField Chatinput = null;
  protected TextField Objectinput = null;
  protected TextField Whisperinput = null;
  protected TextField Roominput = null;
  protected TextField MatrixMsginput = null;
  protected TextField Admininput = null;
  protected List UserList = null;
  protected List ObjectList = null;
  protected List UserObjectList = null;
  protected List RoomList = null;
  protected Button Disconnect = null;
 // protected Button SpeedUp = null;
 // protected Button SpeedDown = null;
  protected Button SiteButton = null;
  protected Label SiteLabel = null;
  protected Label SiteLabel2 = null;
  protected Label Input = null;
  protected Choice Viewpoints = null;
  protected Choice Speed = null;
  protected Choice Gesture = null;
  protected Choice Navigation = null;
  protected Choice Users = null;
  protected Choice Objects = null;
  protected Choice Worlds = null;
  protected Choice Admin = null;
  protected GridBagLayout mainLayout;
  protected Color bg, fg;
  private Container parent;

  public RunPanel( Container parent, int os )
  {
    super( BorderPanel.RAISED );
    this.parent = parent;
    bg = parent.getBackground();
    setBackground( bg );
    fg = parent.getForeground();
    setForeground( fg );
    setOuterMargin( 0 );
    setInnerMargin( 1 );
    mainLayout = new GridBagLayout();
    setLayout( mainLayout );
    SiteLabel = new Label( "" );
    SiteLabel.setForeground( fg );
    SiteLabel.setBackground( bg );
	mainLayout.setConstraints( SiteLabel, makeGridCons( 0, 0, 2, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTH, 1, 1, 0, 0, 0, 0 ) );
	add( SiteLabel );
    validate();
	SiteButton = new Button( "" );
    SiteButton.setForeground( fg );
    SiteButton.setBackground( bg );
    Viewpoints = new Choice();
    Viewpoints.setForeground( fg );
    Viewpoints.setBackground( bg );
    mainLayout.setConstraints( Viewpoints, makeGridCons( 2, 0, 2, 1, .5, .5, GridBagConstraints.NONE, GridBagConstraints.NORTH, 1, 1, 1, 0 , 0, 0 ) );
    Viewpoints.add("Viewpoints");
    add( Viewpoints );
    validate();
    Gesture = new Choice();
    Gesture.setForeground( fg );
    Gesture.setBackground( bg );
	 mainLayout.setConstraints( Gesture, makeGridCons( 4, 0, 2, 1, .5, .5, GridBagConstraints.NONE, GridBagConstraints.NORTH, 1, 1, 1, 0 , 0, 0 ) );
	Gesture.add("Gestures");
      add( Gesture );
      validate();
		Navigation = new Choice();
    Navigation.setForeground( fg );
    Navigation.setBackground( bg );
	 mainLayout.setConstraints( Navigation, makeGridCons( 6, 0, 2, 1, .5, .5, GridBagConstraints.NONE, GridBagConstraints.NORTHWEST, 1, 1, 1, 0 , 0, 0 ) );
      add( Navigation );
    validate();
	Speed = new Choice();
    Speed.setForeground( fg );
    Speed.add("Speed: 3");
    Speed.add("Faster");
    Speed.add("Slower"); 
    Speed.setBackground( bg );
	mainLayout.setConstraints( Speed, makeGridCons( 8, 0, 2, 1, 1, 1, GridBagConstraints.NONE, GridBagConstraints.NORTH, 1, 1, 1, 0, 0, 0 ) );
	add( Speed );
	validate();
   Disconnect = new Button( "Disconnect" );
    Disconnect.setForeground( fg );
    Disconnect.setBackground( bg );
	mainLayout.setConstraints( Disconnect, makeGridCons( 12, 0, 2, 1, .5, .5, GridBagConstraints.NONE, GridBagConstraints.NORTHEAST, 1, 1, 0, 0, 0, 0 ) );
     add( Disconnect );
     validate();
		Chatarea = new TextArea( "", 0, 20 );
    mainLayout.setConstraints( Chatarea, makeGridCons( 0, 1, 4, 6, 100, 100, GridBagConstraints.BOTH, GridBagConstraints.NORTH, 0, 0, 1, 1, 0, 0 ) );
    //Chatarea.setLocation(0,130);
    Chatarea.setForeground( fg );
    Chatarea.setBackground( bg );
    add( Chatarea );
    Chatarea.setEditable( false );
	UserList = new List( 5, false );
	UserList.setForeground( fg );
    UserList.setBackground( bg );
	mainLayout.setConstraints( UserList, makeGridCons( 4, 1, 4, 8, 20, 100, GridBagConstraints.BOTH, GridBagConstraints.NORTH, 0,1 , 1, 0, 0, 0 ) );
    add( UserList );
	ObjectList = new List( 5, false );
    ObjectList.setForeground( fg );
    ObjectList.setBackground( bg );
	mainLayout.setConstraints( ObjectList, makeGridCons( 8, 1, 4, 8, 20, 100, GridBagConstraints.BOTH, GridBagConstraints.CENTER, 0,1 , 1, 0, 0, 0 ) );
     add( ObjectList );
	UserObjectList = new List( 5, false );
    UserObjectList.setForeground( fg );
    UserObjectList.setBackground( bg );
	mainLayout.setConstraints( UserObjectList, makeGridCons( 12, 1, 4, 8, 20, 100, GridBagConstraints.BOTH, GridBagConstraints.CENTER, 0,1 , 1, 0, 0, 0 ) );
	RoomList = new List( 5, false );
    RoomList.setForeground( fg );
    RoomList.setBackground( bg );
	mainLayout.setConstraints( RoomList, makeGridCons( 12, 1, 4, 8, 20, 100, GridBagConstraints.BOTH, GridBagConstraints.CENTER, 0,1 , 1, 0, 0, 0 ) );
     add( RoomList );
	Chatinput = new TextField( "", 20 );
    Chatinput.setForeground( fg );
    Chatinput.setBackground( bg );
	 mainLayout.setConstraints( Chatinput, makeGridCons( 0, 11, 4, 1, 0, 0, GridBagConstraints.BOTH, GridBagConstraints.WEST, 1, 0, 1, 1, 0, 0 ) );
     add( Chatinput );
	Users = new Choice();
    Users.setForeground( fg );
    String [] use = { "Users", "Whisper", "Beam-to", "Ignore", "Hide-Show","Stop-Chat-Logging", "User's objects" };
    Users.setBackground( bg );
	 mainLayout.setConstraints( Users, makeGridCons( 4, 11, 5, 1, 20, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHWEST, 1, 1, 1, 0 , 0, 0 ) );
      add( Users );
   for( int a = 0; a<use.length; a++){
      Users.add(use[a]);
     } 
    Objects = new Choice();
    Objects.setForeground( fg );
    String [] objs = { "Objects","Beam-to","Load-Unload","Move","Hide-Show","Object-info","Load-Sample" };
    Objects.setBackground( bg );
	 mainLayout.setConstraints( Objects, makeGridCons( 8, 11, 5, 1, 20, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHWEST, 1, 1, 1, 0 , 0, 0 ) );
      add( Objects );
   for( int a = 0; a<objs.length; a++){
      Objects.add(objs[a]);
     }
	Worlds = new Choice();
    Worlds.setForeground( fg );
    String [] wrls = { "Worlds","Enter","Add-Remove-World","Set-as-Start-Room","Owner's-Password","World's Objects" };
    Worlds.setBackground( bg );
	 mainLayout.setConstraints( Worlds, makeGridCons( 12, 11, 5, 1, 20, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHWEST, 1, 1, 1, 0 , 0, 0 ) );
      add( Worlds );
   for( int a = 0; a<wrls.length; a++){
      Worlds.add(wrls[a]);
     }
   Input = new Label( "" );
   Input.setForeground( fg );
   Input.setBackground( bg );
   Whisperinput = new TextField( "", 20 );
    Whisperinput.setForeground( fg );
    Whisperinput.setBackground( bg );
   Roominput = new TextField( "", 20 );
   Roominput.setForeground( fg );
   Roominput.setBackground( bg );
   Admininput = new TextField( "", 20 );
   Admininput.setForeground( fg );
   Admininput.setBackground( bg );
   MatrixMsginput = new TextField( "", 20 );
   MatrixMsginput.setForeground( fg );
   MatrixMsginput.setBackground( bg );
    Objectinput = new TextField( "Object input: ", 20 );
    Objectinput.setForeground( fg );
    Objectinput.setBackground( bg );
        Admin = new Choice();
    Admin.setForeground( fg );
    String [] com = { "Admin","Add-New-User","Ban-User","Ban-Address","Approve-World","Remove-World","Add-New-Object","Remove-Object","Drop-Rights-Enabled","Drop-Rights-Disabled","Remove-World+Ban","Clear-Events","Close" };
    Admin.setBackground( bg );
   for( int a = 0; a<com.length; a++){
      Admin.add(com[a]);
     }
  } 

  public void addDisconnect(  ){
		mainLayout.setConstraints( Disconnect, makeGridCons( 12, 0, 2, 1, .5, .5, GridBagConstraints.NONE, GridBagConstraints.NORTHEAST, 1, 1, 0, 0, 0, 0 ) );
     add( Disconnect );
    }

  public void addChatarea(){ 
  mainLayout.setConstraints( Chatarea, makeGridCons( 0, 1, 4, 6, 100, 100, GridBagConstraints.BOTH, GridBagConstraints.NORTH, 0, 0, 1, 1, 0, 0 ) );
    add( Chatarea );
  }

  public void addUserList(){
  mainLayout.setConstraints( UserList, makeGridCons( 4, 1, 4, 8, 20, 100, GridBagConstraints.BOTH, GridBagConstraints.NORTH, 0,1 , 1, 0, 0, 0 ) );
    add( UserList );
  }

  public void addObjectList(){
   	mainLayout.setConstraints( ObjectList, makeGridCons( 8, 1, 4, 8, 20, 100, GridBagConstraints.BOTH, GridBagConstraints.CENTER, 0,1 , 1, 0, 0, 0 ) );
     add( ObjectList );
   }

  public void addRoomList(){
	 mainLayout.setConstraints( RoomList, makeGridCons( 12, 1, 4, 8, 20, 100, GridBagConstraints.BOTH, GridBagConstraints.CENTER, 0,1 , 1, 0, 0, 0 ) );
     add( RoomList );
  }

  public void addChatinput(  ){
   mainLayout.setConstraints( Chatinput, makeGridCons( 0, 12, 0, 1, 0, 0, GridBagConstraints.BOTH, GridBagConstraints.CENTER, 1, 0, 1, 1, 0, 0 ) );
     add( Chatinput ); 
   }

 public void addUserObjectList(  ){
 mainLayout.setConstraints( UserObjectList, makeGridCons( 8, 11, 4, 8, 20, 100, GridBagConstraints.BOTH, GridBagConstraints.CENTER, 0,1 , 1, 0, 0, 0 ) );
   add( UserObjectList );
}

 public void addViewpoints(  ){
   mainLayout.setConstraints( Viewpoints, makeGridCons( 2, 0, 2, 1, .5, .5, GridBagConstraints.NONE, GridBagConstraints.NORTH, 1, 1, 1, 0 , 0, 0 ) );
    add( Viewpoints );
 }

 public void addSpeed(  ){
		mainLayout.setConstraints( Speed, makeGridCons( 8, 0, 2, 1, 1, 1, GridBagConstraints.NONE, GridBagConstraints.NORTH, 1, 1, 1, 0, 0, 0 ) );
	add( Speed );
   }


  public void addWhisperinput(  ){
       mainLayout.setConstraints( Input, makeGridCons( 0, 12, 2, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 0, 1, 1, 0, 0 ) );
      Input.setText("Whisper here:");
      add( Input );
   mainLayout.setConstraints( Whisperinput, makeGridCons( 2, 12, 4, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 0, 1, 1, 0, 0 ) );
      add( Whisperinput );
   }

  public void addObjectinput(  ){
   mainLayout.setConstraints( Objectinput, makeGridCons( 0, 12, 4, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 0, 1, 1, 0, 0 ) );
      add( Objectinput );
   }

    public void addAdmininput(  ){
       mainLayout.setConstraints( Input, makeGridCons( 0, 12, 2, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 0, 1, 1, 0, 0 ) );
      Input.setText("Admin input:");
      add( Input );
   mainLayout.setConstraints( Admininput, makeGridCons( 2, 12, 4, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 0, 1, 1, 0, 0 ) );
      add( Admininput );
   	 mainLayout.setConstraints( Admin, makeGridCons( 6, 12, 4, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHWEST, 1, 1, 1, 0 , 0, 0 ) );
      add( Admin );
   }

      public void addMatrixMsginput(  ){
      mainLayout.setConstraints( Input, makeGridCons( 0, 12, 2, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 0, 1, 1, 0, 0 ) );
      Input.setText("Matrix Msg input:");
      add( Input );
   mainLayout.setConstraints( MatrixMsginput, makeGridCons( 2, 12, 4, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 0, 1, 1, 0, 0 ) );
      add( MatrixMsginput );
   }

  public void addRoominput(  ){
    mainLayout.setConstraints( Input, makeGridCons( 0, 12, 2, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 0, 1, 1, 0, 0 ) );
      Input.setText("Room input:");
      add( Input );
   mainLayout.setConstraints( Roominput, makeGridCons( 2, 12, 4, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 1, 0, 1, 1, 0, 0 ) );
      add( Roominput );
   }

  public void addGesture(  ){
  mainLayout.setConstraints( Gesture, makeGridCons( 4, 0, 2, 1, 0, 0, GridBagConstraints.NONE, GridBagConstraints.NORTH, 1, 1, 1, 0 , 0, 0 ) );
     Gesture.add("Gestures");
      add( Gesture );
   }

  public void addNavigation(  ){
	mainLayout.setConstraints( Navigation, makeGridCons( 6, 0, 2, 1, .5, .5, GridBagConstraints.NONE, GridBagConstraints.NORTHWEST, 1, 1, 1, 0 , 0, 0 ) );
      add( Navigation );
  }


  public void addSiteButton( String st  ){ 
  mainLayout.setConstraints( SiteButton, makeGridCons( 0, 0, 2, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHWEST, 1, 1, 0, 0, 0, 0 ) );
     SiteButton.setLabel( st );
     add( SiteButton );
   }

  public void addSiteLabel( String st  ){
  mainLayout.setConstraints( SiteLabel, makeGridCons( 0, 0, 2, 1, 0, 0, GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHWEST, 1, 1, 0, 0, 0, 0 ) );
     SiteLabel.setText( st );
     add( SiteLabel );
   }

   public void addSiteLabel2( String st  ){
 int iX = 2;
 int iH = 0;
 if(!st.equals("")){ iX = 4; iH = 1; }
  mainLayout.setConstraints( SiteLabel, makeGridCons( 6, 0, iX, iH, 0, 0, GridBagConstraints.NONE, GridBagConstraints.NORTHWEST, 1, 1, 0, 0, 0, 0 ) );
     SiteLabel2.setText( st );
     add( SiteLabel2 );
   }

 
  public void setBGColor(Color cBg){
  setBackground( cBg );
  Chatarea.setBackground( cBg );
  Chatinput.setBackground( cBg );
  Objectinput.setBackground( cBg );
  Whisperinput.setBackground( cBg );
  Admininput.setBackground( cBg );
  MatrixMsginput.setBackground( cBg );
  Roominput.setBackground( cBg );
  UserList.setBackground( cBg );
  ObjectList.setBackground( cBg ); 
  UserObjectList.setBackground( cBg ); 
  RoomList.setBackground( cBg );
  Disconnect.setBackground( cBg );
    SiteButton.setBackground( cBg );
    SiteLabel.setBackground( cBg );
    Input.setBackground( cBg );
    Viewpoints.setBackground( cBg );
    Speed.setBackground( cBg );
    Gesture.setBackground( cBg );
    Navigation.setBackground( cBg );
    Users.setBackground( cBg );
    Objects.setBackground( cBg );
    Worlds.setBackground( cBg );
    Admin.setBackground( cBg );
  }

  public void setFGColor( Color cFg ){
  setForeground( cFg );
  Chatarea.setForeground( cFg );
  Chatinput.setForeground( cFg );
  Objectinput.setForeground( cFg );
  Whisperinput.setForeground( cFg );
  Admininput.setForeground( cFg );
  MatrixMsginput.setForeground( cFg );
  Roominput.setForeground( cFg );
  UserList.setForeground( cFg );
  ObjectList.setForeground( cFg ); 
  UserObjectList.setForeground( cFg ); 
  RoomList.setForeground( cFg );
  Disconnect.setForeground( cFg );
    SiteButton.setForeground( cFg );
    SiteLabel.setForeground( cFg );
    Input.setForeground( cFg );
    Viewpoints.setForeground( cFg );
    Speed.setForeground( cFg );
    Gesture.setForeground( cFg );
    Navigation.setForeground( cFg );
    Users.setForeground( cFg );
    Objects.setForeground( cFg );
    Worlds.setForeground( cFg );
    Admin.setForeground( cFg );
  }
 
  public GridBagConstraints makeGridCons( int x, int y, int dx, int dy, double wx, double wy, int fill, int anch, int it, int il, int ib, int ir, int px, int py )
  {
    GridBagConstraints cons = new GridBagConstraints();

    cons.weightx    = wx;
    cons.weighty    = wy;
    cons.gridx      = x;
    cons.gridy      = y;
    cons.gridwidth  = dx;
    cons.gridheight = dy;
    cons.fill       = fill;
    cons.anchor     = anch;
    cons.insets     = new Insets( it, il, ib, ir );
    cons.ipadx      = px;
    cons.ipady      = py;

    return cons;
  }
}
