/*
  Beta.java


  Copyright (C) 1998 Geometrek and 2005 in part by Russ Kinter

 *  SET Matrix 1 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  SET Matrix 1 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


package matrix.deck.eai;

import matrix.Connection;
import matrix.Message;
import matrix.RealTimeMessage;
import matrix.WhoWhatWhere;
import matrix.RoomControl;
import matrix.deck.*;
import java.lang.ArrayIndexOutOfBoundsException;
import java.awt.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;
import vrml.external.*;
import vrml.external.field.*;
import vrml.external.exception.*;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent; 


/**
 *  Applet Client for EAI browsers.Uses an EAIViewer to handle EAI handles UI issues
 * as well as program control. It observes the network backend used to control
 * the connection to the server and acts upon updates from the backend.
 *
 * @version 1.07
 */

public class Beta extends Applet implements NetworkListener, UserInterfaceListener, ViewerListener, WindowListener {

    /**
    * Frontend controls users interfaces
    */
 
    private Frontend gui;

    /**
     * EAIViewer controls VRML browser and EAI stuff
     */

    private EAIViewer viewer;
   /**
    * beta_updateOk means the VRML plugin has the begin and end update methods used in a later version of EAI.
    */
    private boolean beta_updateOk = false;
   /**
    * New 11-12-05 useravdone marked false means that incoming avatar info is stored in the objects Vector until either the World or another avatar is finished.
    * In previous Deep Matrix versions avatars were loaded ad-hoc. Now they are loaded one at a time.
    */ 
    private boolean finished = false;

    private boolean useravdone = false; 
    /**
     *  New 11-12-05 if false tells handleLOGOUT to call viewer.delete if the client has NOT been disconnected before window closing
     *  Set to false by stop method.
     */
    private boolean closing = true; 
    /**
     *  New 11-12-05 bFirstRoom 2 determines if the room is very first world loaded by applet to start Roomloader thread.
     */
    private boolean bFirstRoom2 = true; 
    /**
     *  New 11-12-05 bFirstRoom 3 determines if the room is very first world loaded by applet to start ChatLoader thread.
     */
    private boolean bFirstRoom3 = true;

    private boolean  bNetFailure = false;
     /**
     *  New 11-12-05 bConnectState shows if connection 
     */
    public boolean bLogOut = false;
    private boolean bConnectState = false;
    //private boolean bLogOut = false;
    /**
     *  New 11-12-05 truth determines whether an avatar's name has been found in Vector TestVec or not.
     */
    private boolean truth = false;
    
     /**
     *  New 11-12-05 bViewer determines whether to addViewerlistener and start EAIViewer thread. Only changed once in life of Applet.
     */
    private boolean bViewer = true;
    

    private boolean bChatSuicide = false, bRoomSuicide = false;
    /**
     *  New 11-12-05 bigchat used to determine if user's chat string is over 150 characters.
     */
    
    private boolean bigchat = false;
    /**
     *  New 11-12-05 bRoom determines whether room is being changed so chat is stopped from entering network.
     */
    private boolean bRoom = false; 
	 /**
     *  New 11-12-05 bGate another boolean indicating whether room is being changed so chat is stopped from entering network.
     */
    private boolean bGate = false;
     /**
     *  New 11-12-05 bdoneGB determines whether the small frame applet for Internet Explorer has succeeded in getting the VRML browser.
     */
    private boolean bdoneGB = false;
    private boolean bLocal = false;
    private boolean bObjList = false;
    private boolean bChatter = false;
    private boolean bPW = false;
    /**
    * WorldOject controls main VRML world. It is loaded first. The boolean finish is marked true when the VRML in the WorldObject is completely read.
    */
   private WorldObject world;
     /**
      * Original 1.2.1 keeps stores incoming avatars.
      */
    private Vector objects = new Vector();
    
    /** 
     * New 11-12-05 Vectors keep track of Avatar objects 
     * TestVec is to see if avatar already exists. RemVec is to see if avatar has been removed.
     */  
     private Vector TestVec = new Vector(), RemVec = new Vector(), SharedObjectVec = new Vector(), SharedObjectReq = new Vector(); 
     /** 
     * New 11-12-05 Vectors keep track of Avatar objects 
     * ChatVec2 is part of Chat thread. Internet Explorer needs the user's chat input as a Thread
     * It will lock up otherwise. 
     *
      * New 11-12-05 ChatVec3 is again part of the user's chat thread. Another optimization is that the users
      * chat is limited to a string of 150 characters per packet accross the network. 
      */
    private Vector ChatVec2, ChatVec3; 
      /**
       *  Keeps applet parameter of "Room"
       */
    private String startRoom;
     /**
      *  user's name
      */
    private String name;
      /**
       *  user's name with a "_" in front of it
       */
    private String name2; 
      /**
       * hostname keeps Applet parameter for the host's name for the socket.
       */
    private String hostname; 
    private String directPath;
      /**
       * Absolute url of user's avatar.
       */
    private String avatarUrl;
	private static String sShutdown = "";
      /**
       * Absolute url of current world.
       */
    private String sTarget;
    private String worldUrl;
    private String sVendor;
    private String sClasspath;
    private int iOS = 0;
    private String sOS1;
    private String sOS2;
    private String sOS3;
	private String sPassWord;
      /** 
       * New 11-12-05 used in Cortona workaround.
       */ 
    private String loadname;
      /** 
       * New 11-12-05 used in Cortona workaround.
       */ 
    private String loadurl;  
      /** 
       * New 11-12-05 FRAME holds applet parameter Frame. Looks to see if applet is in seperate frame from VRML file
       */
    private String FRAME = "default";
    private String sHTTPTunnel = null;
    private String sAbsolutePath;
    private String sDirectory;
    private String sFile;
      /**
       * Backend class does all the network stuff.
       */
    private Backend network;
      /**
       * port holds Applet parameter for the chosen socket port
       */
    private int port = 6666, vpIndex = -1, iObjct = 0;

     /**
     * New 11-12-05 iRoomLoad tracks the time for the RoomLoader RL to run finalization and garbage collection between room changes.
     */

     private int iRoomLoad = 0;

	 private int iXPos = 32;	//( 32, 514, 960, 150 );

	 private int iYPos = 514;	//(int x, int y, int width, int height) 

	 private int iXSize = 960;

	 private int iYSize = 150;

	 private int iViewerLoad = 0;
     /**
     * New 11-12-05 tracks the number of rooms for RoomLoader so it can send correct agruement to server.
     */

     private int iWorldCount = 0;

    /**
     * New 11-12-05 trcnt is counts to 30 for clearing memory every thirty seconds 
     */
   
    private int trcnt = 0;

     /**
     * New 11-12-05 cDLcount is to track the number of attempts Cortona makes to call url. Part of Cortona workaround. 
     */
   
    private int cDLcount = 0;
    /**
     * New 11-12-05 counter keeps track of the number of worlds loaded.
     */ 
    private int counter = 0;

    private int iPL = 1;

    private long lSleep = 400;
 
     /**
      * UserAvatar class controls the user's avatar
      */
    private UserAvatar avatar;
      /**
       * oobe is to see if user is in ghost mode or not
       */
    private boolean oobe = false;
       /**
       * New 11-12-05 Mfstg and Mfstg2 are arrays for chat to VRML strings.
       */
    private String Mfstg [] = new String[2];

    /**
     * New 11-12-05 VRML eventins for chat strings to avatar and world
     */ 
    private EventInMFString yak = null;
     /**
     * New 11-12-05 VRML eventins for chat strings to world
     */  
    private EventInMFString worldchat = null;

    /**
     * New 11-12-05 CRT is a class synchronized as part of new chat thread mechanism.
     */
    private Cretan CRT;
    /**
     * New 11-12-05 Chatloader is threaded class for user's chat input. See setUpChat and setDownChat methods below.
     */
    private Chatloader CL;
     /**
     * New 11-12-05 URLTimer is threaded class for loading Avatars with Contact,CosmoPlayer and WorldView
     */
    private URLTimer URLT;

	private CretanString CVL;

	private ViewerLoader VL;


    private boolean bWorldChat = false;
	private AppFrame window;

    //private UserTalk UT = null;

    /**     		
     * inits UI and network backend. reads applet parameters and sets everything accordingly.
     * also implements some workarounds to Netscape bugs
     */
  public Beta( String file ){
  init();
  loadInit( file );
  start();
 }
    public void init() {
	try {
	    network = new Backend( this );
	}
	catch(IOException e){
	    System.err.println("PANIC : can't start Network Backend "+e);
	}
 sVendor =  System.getProperty("java.vendor").toLowerCase(); 
 String local = System.getProperty("user.dir");
 System.out.println("User directory: " + local);
 String cp = System.getProperty("java.class.path");
 int foo = cp.indexOf("DeepMatrixIP9client.jar");
 cp = cp.substring(0,foo);
 sDirectory =  "file://" + cp + "world/html/";
 System.out.println("Local html url: " + sDirectory);
 System.out.println("Vendor: " + sVendor);
 sOS1 = System.getProperty("os.name").toLowerCase();
 sOS2 = System.getProperty("os.arch").toLowerCase();
 sOS3 = System.getProperty("os.version").toLowerCase();
 sClasspath = System.getProperty("java.class.path");
 System.out.println("OS name: " + sOS1);
 System.out.println("OS arch: " + sOS2);
 System.out.println("OS version: " + sOS3 );
 if(sOS1.indexOf("windows")!=-1){ 
sShutdown = "cmd.exe /E:1900 /C Tskill InstantPlayer";
 }
 else {
sShutdown = "killall InstantPlayer";
 }
    }

  public void loadInit(String file) {
        sFile = file;
          char x = '_';
          char y = ' ';
        File foobar;
        BufferedReader fin = null;
        Vector names = new Vector(), urls = new Vector(), lines = new Vector();
        String line, lower, background, foreground, keyword, keyword2;
        String liness [] = null;
        int index = 1, maxNumber, avCT = 1, urlCT = 1, lineCT = 1;
        iPL = 1;
        bPW = false;
        try {
            foobar = new File(file);
            sAbsolutePath = foobar.getAbsolutePath();
            fin = new BufferedReader(new FileReader(file));
            line = fin.readLine();
            while(line != null ) {
                if( line.length() > 0 ) {
                    StringTokenizer token = new StringTokenizer(line," ");
                    keyword = token.nextToken();
                    if(keyword.charAt(0) != '#') {                          // No Comment !
                        lower = keyword.toLowerCase();
                        if(lower.equals("room") ) {  // loglevel
                            startRoom = token.nextToken();
                        }
                        else if(lower.equals("port")) {  // portnumber
                            port = Integer.parseInt( token.nextToken() );
                        }
						else if(lower.equals("xpos")) {  // X position number
                            iXPos = Integer.parseInt( token.nextToken() );
                        }
						else if(lower.equals("ypos")) {  // Y position number
                            iYPos = Integer.parseInt( token.nextToken() );
                        }
						else if(lower.equals("xsize")) {  // X size number
                            iXSize = Integer.parseInt( token.nextToken() );
                        }
							else if(lower.equals("ysize")) {  // Y size number
                            iYSize = Integer.parseInt( token.nextToken() );
                        }
						else if(lower.equals("passlevel")) {  // Password status
                                 try {
							 Integer INT = new Integer( token.nextToken() );
						    iPL =  INT.intValue();
                                     }
    					catch(NumberFormatException e){ System.err.println("passlevel "+e);}
                        }
                        else if(lower.equals("sleep")) { 
                        lSleep = Long.parseLong(token.nextToken());
                        }
                        else if(lower.equals("hostname")) {
                            hostname = token.nextToken();
                        }
                         else if(lower.equals("httptunnel")) {
                            sHTTPTunnel = token.nextToken();
                        }
                         else if(lower.equals("path")) {
                            directPath = token.nextToken();
                        }
                          else if(lower.equals("local")) { 
                           String li = token.nextToken();
                            li = li.toLowerCase();
                            if(li.equals("true")){
                                bLocal = true;
                              }
                            }
                        else 
                          if(lower.equals( ("line"+lineCT) )) {  
                            String li = token.nextToken();
                            li = li.replace(x,y);
                            lines.addElement(li);
                            lineCT +=1;
                        }
                  
                        else if(lower.equals("background")){   
                            background = token.nextToken();
                           try {
		                    setBackground( new Color( Integer.valueOf( background, 16 ).intValue()));
	                            }
	                     catch(NumberFormatException e){ System.err.println("backgroundformat "+e);}
                        }
                           else if(lower.equals("foreground")){ 
                            foreground = token.nextToken();
                           try {
		                    setForeground( new Color( Integer.valueOf( foreground, 16 ).intValue()));
	                            }
	                     catch(NumberFormatException e){ System.err.println("foregroundformat "+e);}
                        }
                        else 
                             if(lower.equals( ("avatar"+avCT) )) {
                               String avline = token.nextToken();
                               avline = avline.replace(x,y);  
                               names.addElement(avline);
                                 avCT +=1;
                                 } 
                        else  if(lower.equals( ("avatarurl"+urlCT) )) {  
                               urls.addElement(token.nextToken());
                                 urlCT +=1;
                                  }     
                    
                  }
                }
                line = fin.readLine();
                index++;
            }
        }
        catch(Exception e) { 
            fail(e,"Error reading "+file+" in line "+index); 
        }
        finally { 
            try{ 
                if(fin != null) 
                    fin.close(); 
            } 
            catch(Throwable e) {}
        }
// width="100%" height="150"
  window = new AppFrame(this, "InstantMatrix for InstantReality" );
  window.addWindowListener(this);
  window.add( this );
  //window.setBounds( iXPos, iYPos, iXSize, iYSize );
   if( lines.size() > 0 ){
	    liness = new String[lines.size()];
	    for( int i = 0; i < lines.size(); i++ ){
		liness[i] =(String)lines.elementAt( i );
	    }
	   }
  sAbsolutePath = sAbsolutePath.substring(0, sAbsolutePath.indexOf(sFile) );
	setLayout( new GridLayout(1,1,0,0));
	String sChatDir = "";
    if(sOS1.indexOf("linux")!=-1){
    sChatDir = sClasspath;
    }
    else {
    sChatDir = sAbsolutePath;
    }
	gui = new Frontend(this, liness, this, iPL, sAbsolutePath, sChatDir, iOS  );
	add( gui );
	String[] h1 = new String[names.size()];
	String[] h2 = new String[urls.size()];
	for( int i = 0; i < h1.length ; i++ ) {
	    h1[i] = (String)names.elementAt(i);
	    h2[i] = (String)urls.elementAt(i);
	}
System.out.println(sAbsolutePath);
	gui.setAvatars( h1, h2 );
	validate();
 window.pack();
 if(bPW){
 iYPos = iYPos - 25;
 iYSize = iYSize + 25;
 }
 window.setBounds( iXPos, iYPos, iXSize, iYSize );
 gui.setSize( iXSize, iYSize );
 window.show();
}

/**
 * Gets a reference to the plugin. This should be done in start not in init !
 * New 11-12-05 Checks to see if html browser is InternetExplorer or Netscape
 * for using this Beta applet in a seperate frame from the VRML scene
 * If netscape the browser is gotten with standard EAI Browser.getBrowser(applet,frame,index)
 * call. Otherwise it calls GetBrowser applet in the VRML frame to pass the Browser object 
 */
  public void start(){
  closing = true;
  counter = 0;
 URLT = new URLTimer();
 URLT.start();
 CVL = new CretanString();
 ChatVec2 = new Vector(); 
 ChatVec3 = new Vector();  
 CRT = new Cretan();
   VL = new ViewerLoader( this );
  VL.start();
 CL = new Chatloader( this );
  CL.start();
  viewer = new EAIViewer( this, FRAME, sVendor, sOS1, sOS2, sOS3, sShutdown );
  viewer.addViewerListener( this );
  network.setViewer( viewer );
  }
   
 public static void main(String[] args){
 String rcfile = null;
 Runtime rt = Runtime.getRuntime();
    rt.addShutdownHook( 
	new Thread() {
      public void run() { 
        try {
 Runtime.getRuntime().exec( sShutdown );
   }
catch(IOException f){ }
 //  System.exit(0); 
  }
 }
);
 System.out.println( "Matrix client starting up ...");
 if( 2==args.length ){
  if( args[0].equals("-rcfile") ) {
  rcfile = args[1];
   }
   else {  
     usage();
          }
        }
 if( 2<args.length||1==args.length ){ usage(); }
 if( 0==args.length ){ rcfile = "matrixclientrc"; }
 Beta deck = new Beta( rcfile );
 }
 
  public static void usage(){
        System.err.println("Usage : java matrix.server.MatrixD  [-rcfile name]");
        System.exit(1);
    }

 public static void fail( Throwable e,String msg ) {
        System.err.println("Matrix client application "+msg+":"+e);
        System.exit(1);
    }

    // UserInterfaceListener interface begin

    public void handleConnect( String loginName, String password, String avatarUrl ) throws InterruptedException {
	// initialization didn't work !!
	if( viewer == null )
	    return;
	// we keep them for later
    bNetFailure = false;
	bLogOut = false;
    sPassWord = password;
	name = loginName;
 name2 = "_"+name;
  viewer.setUserName( name2 );
	this.avatarUrl = avatarUrl;
	if( loginName.equals("") ){
	    gui.setStatus("Please enter a user name !");
	    return;
	}
  sTarget = startRoom;
 gui.setStatus("Trying to connect to "+hostname);
 synchronized(CVL){
  CVL.setString("START");
 CVL.notify();
    }
   }



/**
 *  New 11-12-05  seUpChat method was implemented to turn the user's
 *  chat input String into the context of a Thread. A work-around
 *  for Internet Explorer to lockup when a user's chat enters the
 *  Frontend's display at the same time as chat Strings coming in
 *   from the Backend network
 * 
 */

       public void setUpChat( String line, String to ){
      if(line.startsWith("/admin")) {
	  try {
   network.askAdminControl( line.substring(1,5), line.substring(7)  );
     }
	catch( IOException e ){
    System.out.println("ControlMessage error asking AdminControl "+e);
	    } 
      }
      else {
      if(line.equals("/stop heart")){ 
          viewer.setbNet(false);
      System.out.println("stopping heart");
         }
      if(line.equals("/start heart")){ viewer.setbNet(true); }
   if(bRoom==false){ CL.stopChat( true ); bRoom = true; }
    if(!line.equals("")){String Mfs [] = {line,to};
   synchronized(CRT) {
  if(CRT.getCretan()==true){
      ChatVec3.addElement( Mfs );
     CRT.setCretan(false);
     CRT.notify();
       }
     }
    }
   }
  }

   public void setUpAdmin( int icom, String line1, String line2 ){
    try {
   network.sendAdminControl( icom, line1, line2 );
     }
	catch( IOException e ){
                System.out.println("error sending AdminControl "+e);
	    }
  }

	   public void handleViewpoint( String sDesc ){
    // if(world!=null){
    // world.setViewpoint( iVP );
    //  }
     }

    public void handleLoadSample( String sBT, boolean bObjtf ){
        gui.display("Matrix","'Load-Sample' has not been implemented yet!" );
  }

  public void handleObjectInfoRequest( String objName ){
  }

/**
 *  New 11-12-05 setDownChat method accomplishes two things:
 *  1. Puts the user's String chat from a Vector to the
 *  handleChat method.
 *  2. It analyzes the user's String and breaks up any string lengths over 150,
 *  for dispersal over 3 second intervals to make things easier on the server/network.
 * 
 */

       public void setDownChat() throws InterruptedException {
   synchronized(CRT) {
     int z = 1;
    String [] Mfs7 = new String[2];
    if(!ChatVec3.isEmpty()){
    Mfs7 = (String [])ChatVec3.firstElement();
    int d = Mfs7[0].length();
   if(150<=d){ 
   bigchat = true;
   Vector stg = new Vector();
   int b = 0; 
  for( int a = 0; a<d; a++){
     if(a==0){ b +=1; String st1 = Mfs7[0].substring(0,150);
       stg.addElement(st1); 
     }  
   if(150<=a&&(a%150==0)){
   if( 150<=(d-a)){  
         b +=1; 
   String st2 = Mfs7[0].substring((150*(b-1)),150*b);
   stg.addElement(st2);
    }
   else { String st3 = Mfs7[0].substring(a,d);
   stg.addElement(st3);
        }
    }
    }
    int c = stg.size();
  String Mfs2 [] = new String[c];
   for( int a = 0; a<c; a++){
   Mfs2[a] = (String)stg.elementAt(a);
    }
    int f = -1;
 for( int a = 0; a<c; a++){
  f = Mfs2[a].indexOf(". ");
   if(-1==f)
     continue;
     if(0<a){
    Mfs2[a-1] = Mfs2[a-1]+ Mfs2[a].substring(0,f+1);
    Mfs2[a] = Mfs2[a].substring(f+1,Mfs2[a].length());
       } 
    }
  if(f==-1){  
 for( int a = 0; a<c; a++){
 int g = Mfs2[a].indexOf(" ");
   if(-1==g)
     continue;
     if(0<a){
      Mfs2[a-1] = Mfs2[a-1]+ Mfs2[a].substring(0,g+1);
      Mfs2[a] = Mfs2[a].substring(g+1,Mfs2[a].length());
        } 
      }
     }
  for( int a = 0; a<c; a++){ 
 String Mfs5 [] = new String[2];
   Mfs5[0] = Mfs2[a]; Mfs5[1] = Mfs7[1];
  ChatVec2.addElement(Mfs5);
  }  
   stg.removeAllElements();
}   
  else { if(-1<d){
 String Mfs3 [] = {Mfs7[0],Mfs7[1]};
  ChatVec2.addElement(Mfs3);
      } 
     }
   ChatVec3.removeElementAt(0);
   }
 if(!ChatVec2.isEmpty()){
 z = ChatVec2.size();
 String[] tt = (String[])ChatVec2.firstElement();
 handleChat( tt[0], tt[1] );
 ChatVec2.removeElementAt(0);
      }   
   CRT.setCretan(true);
  if(2<z){ CRT.wait(4000);}
if(z==2){ if(bigchat==false){ CRT.wait(500);} else { CRT.wait(4000);}}
if(z==1){ CRT.wait(); }
    }
  }


    public void handleChat( String line, String to ){
	if(network.isConnected()){	 
	    try {
		network.sendChatMessage(to, line);
	    }
	    catch(IOException e){
		System.err.println("IOEx in handleChat : "+e);
	    }
   gui.display( name, line);
  	 Mfstg[0] = name;
    Mfstg[1] = line;
  //if(yak!=null&&to==null){ yak.setValue(Mfstg);}
  if(to==null&&world!=null) { world.setWorldMessage( line, name); } 
  if(bChatter==true&&to==null){ avatar.chatDisplay(Mfstg);}
       }
    }
 
   /**
 *    New 11-12-05 handleChat2 method delivers chat strings from the VRML World
 *    via WorldSendChat class, if it has "MatrixSendChat" Proto implemented.
 */
       public void handleChat2( String line, String to ){
	if(network.isConnected()){	 
	    try {
		network.sendChatMessage(to, line);
	    }
	    catch(IOException e){
		System.err.println("IOEx in handleChat : "+e);
	    }	
   gui.display( name, line);
   if(world!=null)world.setWorldMessage( line, name);
   // handleWorldChat( line, name);
          }
    }

  /**
 *    New 11-12-05 handleWorldChat method delivers chat strings to the World
 *    if it has "MatrixReceiveChat" Proto implemented.
 */

     public synchronized void handleWorldChat( String line, String from ){
    if(worldchat!=null) { 
    String Mfs [] = {from,line};
   worldchat.setValue(Mfs);
     }
  }



 /**
 *  New 11-12-05 resetChat method resets the user's chat thread when switching rooms
 *  and disconnecting.
 */

    public void resetChat() throws InterruptedException {
  synchronized(CRT) {
    ChatVec3.removeAllElements();
     ChatVec2.removeAllElements();
    bigchat = false; 
  CRT.setCretan(true);
  CRT.wait();
    }
   }

 /**
  *  New 11-12-05 holdChat method makes the thread of ChatLoader class
  *  wait at start up. 
  */

   public void holdChat() throws InterruptedException {
    synchronized(CRT) { 
     CRT.wait();
    }
   }


    public void holdVL() {
    synchronized(CVL) { 
     try {
      CVL.wait();
     }
   catch( InterruptedException e ){}
    }
   }


    public void handleGesture( int gest ){
	if( avatar != null ) {
	    avatar.gesture( gest);
	}
    }

      public void handleIgnore( String target, boolean hidestate  ){ 
     if(!hidestate){
	handleUserView( target, false );
    }
 }

    public void handleGhost( boolean value ){
	if( avatar != null ) {
	    if( value == false )
		avatar.hide();
	    else
		avatar.show();
	}
    }

     public void handleSpeed( float ft ){
    if( world!= null){
       world.setSpeed( ft );
      }
    }

   public void getFocus(){
 if(sVendor.equals("sun")){
 this.requestFocus();
     }
   }

   public void handleCTRLEV( String target, String [] lock ){
 if(world!=null){
  world.handleControlEvent( target, lock );
   }
  }
 
  /**
   *  New 11-12-05 Sends name of beamto target av to RealTimeHandler via Backend.
   */

 public void handleBeamto( String value, boolean objtf ){
if(value!=null&&name.indexOf(value)==-1){ 
  avatar.beamtostate = true;
if(!objtf){ network.beamtotarget( "_"+value );	}
else { network.beamtotarget( value );}
}
else {
gui.display(name,"Please select a user to beam to !" ); 
}}
 //throws InterruptedException  
   
public void handleDisconnect2()  {
  stop();
window.removeWindowListener(this);
System.exit(0);
  }
 
 public void handleRoomRequest( String target ){
   gateFired( target );
 }

 public void handleRoomControl( int com, String nmpw, String [] info  ){
  try {
network.sendRoomControl( new RoomControl( com, nmpw, info ) );
  }
catch(IOException e){ System.err.println("Beta handleRoomControl: " + e); }
 }

 public void handleNewRoom( String name, String url ){
 try {
network.sendNewRoom( name, url );
  }
catch(IOException e){ System.out.println("Beta handleRoomRequest: " + e); }
 }




 public void handleObjRequest( String target, int state ){
 if(0<state){
 SharedObjectReq.addElement(target);
 }
if(world!=null&&avatar!=null){
world.beamingObjectName( target, avatar.getUserPosition_Rotation(), state );
}
//  try {  
//   network.sendObjectRequest( target, tf );
//		          } catch( IOException e ){
//                System.out.println("error handleObjRequest "+e);
//	    }
//        	catch(InterruptedException f){
//	    System.err.println("error handleObjRequest "+f);
//	    } 
 }

  public void handleUserView( String value, boolean objtf ){
 System.out.println("Beta: hUV: " + value);
  if(value!=null&&name.indexOf(value)==-1){ 
 if(!objtf){  network.setUserView( "_"+ value );}
 else { network.setUserView( value ); }
  }
 else {
 gui.display(name,"Please select a user to hide or show!" ); 
 } 
 }

  public void handleMatrixTextMsgs( String [] mtm ){
   if(world!=null){ world.setMatrixTextMsgs( mtm );	}
 }

  public void setStartRoom( String rm ){
 startRoom = rm; 
 }

 public void handleObjectRoutes( String target ){
 if(target!=null){
  network.setObjectRoutes( target );
  world.objectRoutes( target );
   }
  else {
 gui.display(name,"Please select an Object to Move!" ); 
 } 
 }

   public void handleAvImages( boolean tf, boolean tf2, int iIMG ){
   }

    public void handleDisconnect() throws InterruptedException {
   URLT.setTruth( false ); 
   viewer.setbNet(false);
	bRoom = useravdone = finished = bConnectState = bChatter = false;
  CL.stopChat( false );
   if(world!=null){ 
 world.reset();
 }
 SharedObjectReq.removeAllElements();
 SharedObjectVec.removeAllElements();
 objects.removeAllElements();
 TestVec.removeAllElements();
 RemVec.removeAllElements();
	if( avatar != null ){
	    try {
		network.deleteSharedObject(avatar.getName());
        network.removeConsumer(avatar.getName());
        viewer.removeSharedObject(avatar.getName());
	    }
	    catch(IOException e) {
		System.err.println("IOEx deleting avatar "+e);
	    }
	}
 String stf	= null;
   if(bGate){
 stf = "true";
 }
 else {
 stf = "false";
 }
network.disconnect( stf );
// gui.resetChat( false ); 
  }
  
  public void handleNavigation( int num ){
if(world!=null){ world.setNavigation( num ); }
 }

    // UserInterfaceListener end

    // NetworkListener interface begin

    public void handleLOGOUT(){
  if(bConnectState){
   	 try{ 
	gui.setWWW( new RoomControl( RoomControl.SET, " ", new String [] {"logout"} ) );
    }
    catch(IOException e){}
    }
  // gui.setNavigation( false );
  // gui.stopWWWBuffer();
  	bRoom = useravdone = finished = bConnectState = bChatter = false;
//  gui.setGhost( false );
  URLT.setTruth( false ); 
   CL.stopChat( false );
	viewer.setbNet(false);
 System.out.println("Beta handleLOGOUT");
	 synchronized(CVL){
  iViewerLoad = -1;
    if(bGate==false){
	bLogOut = true;
 	gui.display("Matrix","disconnected from "+ hostname);
	CVL.setString("DISCONNECT");
  }
 else {
 CVL.setString("GATE");
  }
 CVL.notify();
   }
   bGate = false; 
 }
    


 /**
 *  New 11-12-05 This method of the NetworkListener interface has been drastically changed and represents
 *  the key differences between the old www.geometrek.com Deep Matrix applet and my later versions
 *  In the old version after the enviroment world was finished any incoming avatar url was immediately
 *  loaded into the  viewer.addSharedObject method
 *
 *       public void handleOBJADD( String name, String url ){
	* if( finished == true ){
	    viewer.addSharedObject( name, generateUrl( url ));
	* }
	*  else {
	*    String[] tt = { name, generateUrl( url ) };
	*    objects.addElement( tt );
	*  }
 *   }
 *
 * Now if the VRML browser is attempting to load a avatar/vrmlobject, any new incoming avatar/vrmlobject
 * is stored in the objects Vector until the previous avatar is completely finished and running.
 * In other words the rate of avatar loading has been slowed down a bit.
 *
 */

   public void handleOBJADD( String name, String url ){
 if(!TestVec.contains( name )){
  RemVec.removeElement( name );
	if( finished == true ){
 if( useravdone == true ){
  gui.display("Matrix","loading Shared Object....");
 System.out.println("handleOBJADD 1: " + name);
  cDLcount = 0;
  String st = generateUrl( url ); 
   URLT.setTruth( false );
   viewer.addUserAvatar( name, st ); 
      useravdone = false;
	}
	else {
System.out.println("handleOBJADD finish true useravdone false: " + name);	   
   String[] tt = { name, generateUrl( url ) };
	    objects.addElement( tt );
	 }
 } 
	else {
  System.out.println("handleOBJADD finish false useravdone false: " + name);
	    String[] tt = { name, generateUrl( url ) };
	    objects.addElement( tt );
	   }
  }
 }

   // viewer.checkTestName( name );

   /**
 *  New 11-12-05 handleOBJDEL method has been modified to empty and add to the Vectors used
 * keep track of user avatars.
 */

    public void handleOBJDEL( String name ){
  if(SharedObjectVec.contains( name )){ 
 String foo = name.substring(1,name.length()-4);
  gui.resetObjectMove( name );
  gui.deleteObjName( name ); 
  SharedObjectVec.removeElement( name );
   }
	network.removeConsumer( name );
	viewer.removeSharedObject( name );
 TestVec.removeElement( name );
  RemVec.addElement(name);
 if(useravdone==true){  System.gc(); System.runFinalization();}
    }

  public void handleOBJIGN( String name, String tf ){
  }                                                                                                                                                                         

/**
 *  New 11-12-05 First stage of new room transition of RoomLoader
 *  Does cleanup and now starts the viewer thread on first load
 *  Checks to see if VRML browser is Cortona or else to load or start correct Avatar loading class aid
 */
    public void handleROOM_A( String roomnm ) throws InterruptedException {
  }


 /**
  * new 11-12-05 Last stage of transition between rooms
  * Starts the Chat loader and if Cortona plugin creates an instance of CortDroneLoader class
  */

   public void handleROOM_B( String name, String url ) throws InterruptedException {
 bConnectState = true;
 cDLcount = 0;
 world = null;
    avatar = null;
 sTarget = name;
  viewer.setbNet(true);
 //gui.resetChat( true );
 bRoom = false;
 worldUrl = generateUrl(url);
   gui.display("Matrix","loading room "+name+" ( "+url+" )");
 if(bObjList){ setObjList( false ); }
  viewer.loadWorld( "world", worldUrl ); 

  }

 public void handleNetFailure( String reason ){
 bNetFailure = true; gui.setStatus( reason );
 }

 /**
  * handles messages from chat and delivers them to chat display.
  */
    public void handleMSG( String from, String line ){
   CL.pleaseHoldup();
	gui.networkChatInput( from, line );
    }

  /**
  * handles user's names
  */



    public void handleWHOIS( String[] users ){
	//gui.setUsers( users );
    }

   public void handleOBJIS( String[] objects ){
   //  gui.setObjNames( objects );
    }

   public void handleWWW( Message msg ){
     gui.setWWW( msg );
   } 

  public void handleNEWRM( String new_room ){
	gateFired( new_room );
  }

   public void handleADMIN( int arg ){
	  switch( arg ){
        case 1 :
        handleMSG( "Matrix", "Welcome Admin!" );
        break;
        case 2 :
		handleMSG( "Matrix", "Goodbye Admin!" );
        break;
        }
	   gui.setAdmin( arg );
   }


   public void handleObjNames( String obj, String url ){
 System.out.println("handleObjNames1: " + obj);
 if(SharedObjectReq.contains(obj)){
System.out.println("handleObjNames SharedObjectReq contains: " + obj);
   try {  
   network.addSharedObject( obj, url );
		          } catch( IOException e ){
                System.out.println("error adding shared object "+e);
	    }
    SharedObjectReq.removeElement( obj ); 
   }
    SharedObjectVec.addElement( obj );
  }

    public void handleERROR( String from, String line ){
	gui.display("Error",from+" "+line);
if(line.equals("Still connected!")){ 
  gui.setStatus( name + " is still connected!");
   }
    }


   public void handleNavChange( String [] types ){
	gui.setNavChange( types ); 
   }

   public void handleSpeedChange( float ft ){
	gui.setSpeedChange( ft ); 
   }

    // NetworkListener interface end

   public void setObjList( boolean tf ){
  bObjList = tf;
  gui.setObjList( tf );
  }

  public Node getPrimeMover(){
  Node pm = world.getPrimeMover();
  return pm;
  }

    // ViewerListener interface start

  public void resetSystem(){
  gateFired( sTarget );
  }

  public void browserAchieved( boolean tf ){
if(tf){ reConnect(); }
else { 	gui.setStatus("Error making connection to VRML !");
}
  }

   public void destroyProcess(){
   }

 public void networkConsumers( boolean tf ){
if(tf){ 
   network.clearConsumers();
    yak = worldchat = null;
  }
  else {
	gui.showLoginView();
	gui.setStatus("Press CONNECT to login !");
   }
 }

   public void browserControl( int iCtrl ){
    }

   public void onReset(){
  // if(world!=null){ world.resetSharedObjects(); }
   }

    /**
     * new 11-12-05 onHeartBeat polls server every seven seconds with a new ContolMessage HRTBT
     * Called from EAIViewer run
     */

       public void onHeartBeat(){
      try {
   network.sendHeartBeat( "name" );	
      }
    catch(IOException e){  System.out.println("Beta hB1 IOExeption "+e); 
      }
     }

   /**
     * new 11-12-05 onWorldLoaded differs considerably from original Geometrek Deep Matrix applet
     * First it sees if the world has been removed by (RemVec Vector) by the handleOBJDEL method 
     * or if it already exists (TestVec Vector) If neither Vector contain the name, then the boolean
     * "truth" is made true and the object proceeds to load as a World class 
     * Otherwise a Deadend Class is called and the VRML is removed from the scene. The Deadend class
     * is only really necessary for Cortona and its lackadaisacal Browser.createVRMLfromURL bug
     * With the work around I wrote by simply recalling the missing url the problem is this: Did
     * Cortona REALLY screw up and ignore the call OR is the network simply slow on delivering the goods?
     * If the latter is true, then object will show up twice. Deadend class will eliminate the successfull
     * second call
     * "Viewer.putSO" is a call back to the EAIViewer class to put the vrml object
     * in its objects hashtable IF there is no duplicate. Originally it went directly 
     * the objects hashtable before the Beta onObjectLoaded method was called
    */

     public void onWorldLoaded( String name, SharedObject object ){
     counter += 1; 
  if(!TestVec.contains(name)){ truth = true; TestVec.addElement(name);}
	// if nothing was loaded
 if(truth==true){
	if( object == null ){
	    System.out.println("Error loading world !");
	    gui.display("Matrix","could not load the world - disconnecting");
	    network.disconnect("false");
	    return;
	}

	// do the world parsing thing !!

 //viewer.putSO( (SO1)object );
	avatar = null;
	try{
	    world = new WorldObject( (SO1)object, viewer.getBrowser(), network, this, vpIndex, viewer.getViewernum(), lSleep, sDirectory );
	}
	catch(ConsumerException e){
	    gui.display("Matrix",e.toString());
	    network.disconnect("false");
	    return;
	}
       	
}
else { 
 Deadend dead = new Deadend( (SO1)object );
  if(useravdone==true){  
 System.gc();
 System.runFinalization();
     } 
   }
    }

    /**
     * new 11-12-05 onObjectLoaded differs considerably from original Geometrek Deep Matrix applet.
     * First it sees if the object has been removed by (RemVec Vector) by the handleOBJDEL method. 
     * or if it already exists (TestVec Vector) If neither Vector contain the name, then the boolean
     * "truth" is made true and the object proceeds to load as either a UserAvatar or Avatar class. 
     * Otherwise a Deadend Class is called and the VRML is removed from the scene. The Deadend class
     * is only really necessary for Cortona and its lackadaisacal Browser.createVRMLfromURL bug.
     * With the work around I wrote by simply recalling the missing url the problem is this: Did
     * Cortona REALLY screw up and ignore the call OR is the network simply slow on delivering the goods?
     * If the latter is true, then object will show up twice. Deadend class will eliminate the successfull
     * second call.
    */

    public void onObjectLoaded( String name, SharedObject object ){
 if(RemVec.contains(name)) { truth = false; }
 else {
 if(!TestVec.contains(name)){ truth = true; TestVec.addElement(name);}
 else { truth = false; }
  }
 if(truth==true){
	if( object != null ){ 
   // new 11-12-05 putSO is a call back to the EAIViewer class to put the vrml object
   // in its objects hashtable IF there is no duplicate. Originally it went directly 
   // the objects hashtable before the Beta onObjectLoaded method was called. 
	    // check for users avatar
	    if( name.equals( name2 )){
      System.out.println("Beta onObjectLoaded UA");
		avatar = new UserAvatar( (SO1)object,  network, viewer.getBrowser(), world.getProxy(), this, viewer.getViewernum(), world.getOffset(), lSleep );
		network.addConsumer( avatar );
	    } else {
		Avatar av = new Avatar( (SO1)object, viewer.getBrowser(), network, this, viewer.getViewernum(), lSleep );
		//viewer.resetLoaded( (SO1)object );
		network.addConsumer( av );
		// get some updates for this object
        gui.confirmObjLoad( av.getName() );
if(bConnectState){
        System.out.println("Beta oOL update: " + av.getName() );
		try {
		    network.update(av.getName(), av.getbObject() );
		}
		catch( IOException e ){
		    System.out.println("Error updating "+av.getName()+" "+e);
		}
     }
	    }
    //viewer.putSO( (SO1)object );
 } else {
	    System.out.println("Error loading object "+name+" !");
	  } 
  }
else { 
 viewer.resetLoaded();
  System.out.println("Beta onObjectLoaded Deadend");
  Deadend dead = new Deadend( (SO1)object );
  if(useravdone==true){ 
    System.gc();
   System.runFinalization();}
  System.out.println(name +" again deleted"); 
  }   
}

/**
 * New 11-12-05 world_loaded method is called when the VRML world is initialized.
 * It then calls the user's personal avatar. In previous versions of the applet the
 * the objects Vector was unloaded in the "onWorldLoaded" method above: 
 *
 * 
 *
 * In my opinion this was expecting too much out of the VRML plugin to work
 * well. The EAI had a tendency to get a head of itself and would try to do too much 
 * at one time and head for lock up. My system slows things down quite a bit. A new
 * VRML file is not loaded UNTIL the previous one is fully initialized!
 */
 

  public void world_loaded(){
 System.gc();
 System.runFinalization();
 // gui.setNavigation( true ); 
if(bConnectState){ 
 	gui.display("Matrix","world loaded !");
 network.addConsumer( world );
	// lets get some updates for the worlds states
	try {
	    network.update( "world", false );
	}
	catch( IOException e ){
	    System.out.println("Error updating world "+e);
	}          
 finished = true;
	if( avatarUrl != null ){
   System.out.println("Beta world_loaded avatarUrl not null");
 gui.display("Matrix","loading User's Avatar....");
   String st = generateUrl(avatarUrl);
   cDLcount = 0;
 URLT.setTruth(true); 
viewer.resetLoaded();
viewer.addUserAvatar( name2, st );
    }
   }
  } 

 /**
 * New 11-12-05 urlTimerLoad method called by URLTimer class. Contact, Cosmoplayer, WorldView only.
 */

   public void urlTimerLoad(){
 cDLcount +=1;
 URLT.sleepyTime();
   if(1<cDLcount&&cDLcount<4){ gui.display("Matrix","waiting...."); }
 if(4==cDLcount){
    if(!objects.isEmpty()){
    gui.display("Matrix","Failure to get url!"); 
    gui.display("Matrix","Loading next Shared Object!");
    userAvDone();
    } 
    else {  gui.display("Matrix","Failure to get url!"); 
           }
   }   }
 


/**
 * New 11-12-05 
 * user_av_finished is called to show user's personal av is done
 * UserAvatar must load between the World and drone Avatars.
 */

 public void user_av_finished(){
  System.out.println("Beta user_av_finished");
	URLT.setTruth( false );
	viewer.resetLoaded();
   if(bConnectState){
  viewer.setHeartBeatCount(); 
   try {  
   network.addSharedObject( name2, avatarUrl );
		          } catch( IOException e ){
                System.out.println("error adding user avatar "+e);
	    }
 // gui.setGhost( true ); 
  gui.display("Matrix","loaded User's Avatar!");
  userAvDone();
	  }
 	  } 

  public boolean checkIgnored( String nm ){
  boolean tf = gui.checkIgnored(nm);
   return tf;
   }
 
 /**
 * New 11-12-05 drone_av_finished is called either when another users avatar
 * is finished and fully running OR if EITHER it or the user's avatar have
 * failed to load.
 * 
 */
     public void drone_av_finished( boolean tf ){
System.out.println("Beta drone_av_finished: " + tf );
	   URLT.setTruth( false );
	viewer.resetLoaded();
   if(bConnectState){
  viewer.setHeartBeatCount();
 if(tf==true){ gui.display("Matrix","loaded Shared Object!"); }
 else { gui.display("Matrix","failed to load Shared Object!"); }
   userAvDone();
	}
  }

/**
 * New 11-12-05 userAvDone method is called by a finished World or avatar to see if there
 * are any waiting av urls in the objects Vector and attempts to have them called.
 */

  public void userAvDone(){ 
  //System.gc();
  System.out.println("userAvDone 1 ");
  int b = (objects.size()-1);
  if(-1<b){useravdone = false; 
	    String[] tt = (String[])objects.elementAt(b);
     objects.removeElementAt(b);
     cDLcount = 0;
   gui.display("Matrix","loading Shared Object....");
  System.out.println("userAvDone: " + tt[0] );
  URLT.setTruth( true );	
  viewer.addUserAvatar( tt[0], tt[1] );
	  }
else { useravdone = true; }
 }


    // ViewerListener interface end

    /**
     * new 11-12-05 Tells server to remove user from room and go to transition state.
     */
  void gateFired( String target ){
	iViewerLoad = -1;
    bGate = true;
    sTarget = target;
     try{
	handleDisconnect();
     }
    catch(InterruptedException e){ System.out.println("Gate mis-fired: " + e ); }
    }

 //try {
//	    if( avatar != null ){
//		network.deleteSharedObject(avatar.getName());
//	    }
//	    finished = false;
//	    network.switchRoom( target, "A" );
//	}
//	catch(IOException e){
//	    System.err.println("Ex in gate callback "+e);
//	}
// 	catch(InterruptedException f){
//	    System.err.println("Ex in gate callback "+f);
//	}
// gui.resetChat( false );




   private void reConnect(){
 if(bFirstRoom3==true){ 
 gui.setStatus("Connecting to "+hostname);
  bFirstRoom3 = false;
  }
 else {
 gui.setStatus("Reconnecting to "+hostname); 
  }
  gui.startWWWBuffer();
 String st;
 if(1<iPL){
  st = sPassWord;
  }
 else {
  st = name;
  }
	 	try {
	    network.connect(hostname, port, name, st, sTarget, "BOT" );
	}
	catch( IOException e){
            try {
                if( sHTTPTunnel != null&&!bNetFailure ){                
                    gui.setStatus("Trying to connect to Servlet at "+("http://" + hostname + "/" + sHTTPTunnel ));
                    network.connect(("http://" + hostname + "/" + sHTTPTunnel), port, name, name, sTarget, "BOT" );
                } else {
                    throw new IOException("No fallback parameters defined !");
                }
            }
            catch(IOException e2){
                gui.setStatus("Connecting failed : "+e2);
                gui.showLoginView();
                return;
            } 
	}
	gui.showRunView();
 

 // passing browser name to RealTimeHandler via Backend so Cosmo and I.E. combo will work.

 beta_updateOk =  viewer.updateOk;
 network.BackendupdateOk(viewer.updateOk);
  gui.display("Matrix","connected to "+ hostname);
}




   public void reloadRoot(){
    synchronized(CVL){
String st = CVL.getString();
 if(st.equals("DISCONNECT")){
   viewer.viewerDisconnect( 0 );
  }
 else 
 if(st.equals("GATE")){
     viewer.viewerDisconnect( 1 );
   }
 else 
 if(st.equals("START")){
    viewer.viewerDisconnect( 2 );
   }
  try {
  CVL.wait();
  }
  catch(InterruptedException f){ System.err.println("Ex in reloadRoot wait "+f);
     }
  }
} 
    /**
     * adds behaviours the behaviours of the used Avatar to the GUI
     */
    public void addBehavs( String[] behavs ){
	gui.setGestures( behavs );
    }

   /**
    * helper functions, accessible by everyone
    * should maybe be static but depend on getDocumentBase
    * exchange table for Blaxxun Url character problems,
    * the other browser work with the % version as
    * well as with the substitution, so no special cases for them :-)
    */

    private static String substitution[][] = {{"%7C","|"},{"%20"," "}};

    /**
     * little helper to construct URLs from DocumentBase.
     * usually used for URLs send to Cosmoplayer. Cosmoplayer 2.0 is inconsistend with
     * the base of relative URLs, so we avoid that by using only absolute ones.
     */
    String generateUrl( String url ){
String hs;
if(url.indexOf("http")==-1){
if(bLocal==false){
hs = ("http://" + hostname + directPath + url );
 }
 else {
 hs = url;
  }
 }
 else {
 hs = url;
 }
	return hs;
    }

/**
  *  New 11-12-05 trying to improve window closings in Netscape
  *  Notifying the synchronized classes of threads tends to cause crashes
  *  with Cosmoplayer so those calls have been removed. 
  *  See RealTimeHandler close method.
  *  Calling delete method of viewer has been commented out as well.
  *  Still some question about "what" to correctly stop.
 */
      public void stop(){ 
 closing = useravdone = finished = false;
//if(viewer!=null){ viewer.delete();}
 network.disconnect("false");
 //network.close();
  VL.stop();
  CL.stop();  
 if(URLT!=null){  URLT.stop(); }
  yak = worldchat = null;
  System.runFinalization();
  System.gc();
  }


 /** 
  * New 11-12-05 Sets up Beta to deliver chat to UserAvatar class
  */

   public void set_yakker( EventInMFString talk_talk ){
  yak = talk_talk;       
  }

 /**
  *  New 11-12-05 Sets up Beta to deliver chat to World class
  */ 

   public void set_worldchat( EventInMFString talk_talk  ){
  worldchat = talk_talk;
  }

  /**
  *  New 11-12-05 Warns when loading WorldObject has a lot of Matrix Protos.
  */

  public void worldLoadWarning( String warning ){
  gui.display("Matrix", warning );
  }



 /**
 * New 11-12-05 Call back to world to reset viewpoint during UserAvatar construction.
 */

 public void setViewpoint(){
  world.setBinder();
}

    public Browser getBrowser(){
Browser br = viewer.getBrowser();
	return br;
    }

  public void chatDisplay ( boolean tf ){
   bChatter = tf;
    }

     public void handleMatrixText(){
   gui.setMatrixText();
   }

    public void sharedObjectName( String target, int state ){
  if(world!=null)
   world.sharedObjectName( target, state );
 }

  /**
 * New 11-12-05 set_AvatarName and set_AvatarUrl are called by World class if MatrixAvatar_Name_Url Proto has been implemented.
 */

 public String set_AvatarName (){
 return(name);
 }

     public String set_AvatarUrl (){
 return(avatarUrl);
 }

/**
* New 11-12-05 Gives UserAvatar target drone Avatar coordinates for beam to.
*/

  public void beamtocoord ( float[] beaminfo ){
   avatar.beamover(beaminfo);}
 /**
 * New 11-12-05 Feedback to Frontend that beamto is finished so select can be reset.
 */

  public void beamtoFinished (){
 gui.resetSelect(); 
 }

    /**
     * reads a file referenced by an URL. mostly used for reading wrl files, to work around
     * the insecure createVrmlFromURL call.
     * not really used in this version.
     */
    String readUrl( String url ) throws Exception {
	StringBuffer content = new StringBuffer();
	url = generateUrl( url );
	URL contentUrl = new URL( url );
	DataInputStream s = new DataInputStream( contentUrl.openStream());
	String line = s.readLine();
	while( line != null ){
	    content.append( line + "\n");
	    line = s.readLine();
	}
	s.close();
	return content.toString();
    }

    /**
     * WindowListener Interface begins
     */

public  void windowDeactivated( WindowEvent e ) {
 }
public  void windowActivated( WindowEvent e ) {
        getFocus();
 }
public  void windowDeiconified( WindowEvent e ) {
        getFocus();
 }
public  void windowIconified( WindowEvent e ) {
 }
public  void windowOpened( WindowEvent e ) {
  }
public  void windowClosed( WindowEvent e ) {
 }
public  void windowClosing( WindowEvent e ) {
	System.exit(0);

    //handleDisconnect2(); 
}

 }
