/**
  Route.java

  Copyright (C) 1998 Geometrek

  This source is distributed as semi-opensource software. Please see the
  LICENSE file with this distribution or contact Geometrek (www.geometrek.com)
  for details.
*/

package matrix.deck.eai;

import matrix.vrml.*;
import matrix.vrml.eai.*;
import matrix.deck.RealTimeConsumer;
import matrix.deck.ConsumerException;
import matrix.deck.CtrlEvent;
import matrix.deck.Network;
import java.io.*;
import vrml.external.*;
import vrml.external.field.*;
import vrml.external.exception.*;

/**
 * manages a single VRML route. Now this is a Living Worlds' NetworkState node.
 *
 * @version 1.1
 */
public class CtrlTime  implements CtrlEvent, EventOutObserver {
    private String name;
    private String username = "";
    private String sLock = "#open";
    private Node myNode = null;
    private EventOutSFTime time_out = null;
	private EventInSFString setLock = null;
    private EventIn fromnet;
    private Network postOffice;

 public CtrlTime( Node netnode, Network office, String name ) {
	postOffice = office;
	myNode = netnode;
    username = name;
    try {
	this.name = ((EventOutSFString)myNode.getEventOut("tag")).getValue();
    setLock = ((EventInSFString)myNode.getEventIn("set_lock"));
	time_out = (EventOutSFTime)myNode.getEventOut("control_time");
    time_out.advise(this, new Integer(3) );
     }
	catch(NullPointerException f){ System.out.println( "CtrlTime error: " + f ); }
    catch(InvalidEventInException g){System.out.println( "CtrlTime error: " + g );  }
    catch(InvalidEventOutException h){System.out.println( "CtrlTime error: " + h ); } 
    catch(Error j){ System.out.println( "CtrlTime error: " + j );  }
    }

	  public void callback(EventOut value, double time, Object data) {
	try {
	    if( value == null ) {
		System.err.println("Got null value from ");
		return;
	    }
	    if(!(value instanceof EventOut)) {
		System.err.println("value of class "+value.getClass().getName() );
		return;
	    }
		if( value.getType()== FieldTypes.SFTIME ) {
	    if(sLock.equals("#open")){
     System.out.println("CtrlTime sLock is open " );
     postOffice.sendControlEvent( name, new String [] { username, "#lock"} );
     }
     else 
	 if(sLock.equals(username)&&!username.equals("")){
	 System.out.println("CtrlTime sLock was controlled now opening " );
     postOffice.sendControlEvent( name, new String [] { username,"#open"} );
       }
     }
	  else
    return;
     }
     	 catch(InterruptedException f){} 
     catch(IOException e){ System.err.println("CtrlTime: " + name + ": " +e ); }
     catch(Exception g){System.err.println("CtrlTime: " + name + ": " +g ); } 
	
    }
   

       public void handleLock( String [] lock ){
    sLock = lock[0];
    if(setLock!=null){ setLock.setValue( sLock ); }
    }

   	 public String ctrlName(){
    return name;
    }

	public void ctrlDelete(){                              
if(time_out!=null){ time_out.unadvise(this);	
 time_out = null;
    }
}

}
