

/*
  WorldSendAv_Name_Url.java

  Copyright 2005 by Russ Kinter

 *  SET Matrix 1 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  SET Matrix 1 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package matrix.deck.eai;

import matrix.vrml.*;
import matrix.deck.*;
import java.io.*;
import java.util.*;
import vrml.external.*; 
import vrml.external.field.*;
import vrml.external.exception.*;
 /**
 * New 11-12-05 Allows world to get the user clients nickname and their avatar url
 * either when the VRML world is being processed by the WorldObject class
 * or later via a true boolean sent by the world.  
 * Instanced by WorldObject class. 
 * @version 0.1    
 * @author Russ Kinter
 */
public class WorldSendAv_Name_Url implements EventOutObserver {
    /**
     *  New 11-12-05 EventOutSFBool request holds eventOut from Node wsn. This is observed for requests for nickname and av url.
     */
  private EventOutSFBool request;
    /**
     *  New 11-12-05 EventInMFString send is from Node wsn. The requested nickname and av url Strings are placed here.
     */
  private EventInMFString send;
    /**
     *  New 11-12-05 Node wsn holds instance of Proto WorldSendAv_Name_Url found in the scene graph by WorldObject.
     */
  private Node wsn;
  private String [] name_url = {"",""};
   public  WorldSendAv_Name_Url(){
 }  
 public void setWSANU(String NAME, String AVURL, Node WSN ){
  this.name_url[0] = NAME;
  this.name_url[1] = AVURL;
  wsn = WSN;  
  send = (EventInMFString)wsn.getEventIn("set_Av_Name_Url");  
  request = (EventOutSFBool)wsn.getEventOut("name_url_request");
  request.advise(this, new Integer(1) );
}

  public void callback(EventOut value, double time, Object data) {
    try {
	if( value == null ) {
		System.err.println("Got null value from WorldSendAv_Name_Url ");
		return;
	    }
	    if(!(value instanceof EventOut)) {
		System.err.println("WorldSendAv_Name_Url callback not EventOut: value of class "+value.getClass().getName() );
		return;
	    }
  if( value.getType()==FieldTypes.SFBOOL ) {  
  if(request.getValue()==true){
     this.sendName_Url();
   }
  }
 else return;
}
	catch(Exception e) {
	    System.err.println("Error converting boolean from world"+"\n\t" +e);
	}

    }

   public void sendName_Url(){ 
 try {
 send.setValue(name_url);
  }
catch(InvalidEventInException e){ System.out.println("set_Av_Name_Url invalid: "+ e);}
}

  public void delete(){ 
  if(request!=null){request.unadvise(this);}
  request = null; wsn = null; send = null; } 

}
