/**
  Gate.java

Copyright (C) 1998 Geometrek	and 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


package matrix.deck.eai2;

import matrix.RealTimeMessage;
import vrml.eai.*;
import vrml.eai.field.*;
import vrml.eai.event.*;

/**
 * manages a Matrix Gate
 *
 * @version 1.0
 */
public class Gate implements VrmlEventListener {
    private String target;
    private EventOut callingEvent;
    private Beta deck;
    private Node gate;
	private int vn = 0;

    public Gate( Node gate, Beta d, int VIN ) throws RuntimeException {
    deck = d;
    this.gate = gate;
	vn = VIN;
    callingEvent = gate.getEventOut("isActive");  // GC workaround
    callingEvent.addVrmlEventListener(this);
    }

    public void eventOutChanged(VrmlEvent vrmlevent) {
    BaseField bf =  vrmlevent.getSource();
    try {
        if(callingEvent==null) {
        System.err.println("No event out present!");
        return;
        }
        if(!(callingEvent instanceof EventOutSFString)) {
        System.err.println("Wrong eventOut type!");
        return;
        }
      if( bf.getType()==8 ){
        deck.gateFired(((EventOutSFString)callingEvent).getValue());}
        
    }
    catch(Exception e){
        System.err.println("Ex in gate "+e);return;
    }
    }

   public void delete(){ if(callingEvent!=null){ callingEvent.removeVrmlEventListener(this); callingEvent = null; }  gate = null;  }
}
