/** 
 IAnchor.java

 * Copyright (C) 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9. 
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * This file also uses open-source code of BrowserLauncher2 : 
 * Copyright 2004,2005,2006,2007 Markus Gebhard, Jeff Chapman
 * http://browserlaunch2.sourceforge.net/
 *
 * BrowserLauncher2 is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 */

package matrix.deck.eai2;

import edu.stanford.ejalbert.BrowserLauncher;
import edu.stanford.ejalbert.exception.*;
import edu.stanford.ejalbert.exceptionhandler.BrowserLauncherErrorHandler;
//import java.awt.Desktop;
import java.util.*;
import vrml.eai.*;
import vrml.eai.field.*;
import vrml.eai.event.*;
import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;

public class IAnchor implements VrmlEventListener, Runnable {

  /**
     *  New 11-12-05 Holds finished url String for Browserlauncher
     *  
     */
 
private String commandString;
// private String processString;
//private String exe;
	/**
     *  New 11-12-05 chat holds the eventOut of Node  ( WorldSendChat ) called "to_chat" 
     *  It is given an EventObserver to watch for new Strings
     */
  private String sDirectory;
  private boolean bLocal = false;

      /**
     *  New 11-12-05 localState holds the eventOut of Node  ( IAnchor ) called "Local" 
     *  Determines whether address is for local url or not.
     */
  private EventOutSFBool localState; 

  private EventOutMFString commandLines;
 /**
     *  New 11-12-05 commandLine holds the eventOut of Node  ( IAnchor ) called "address_changed" 
     *  It is given an EventObserver to watch for new Strings
     */

  private EventOutSFString commandLine;
     /**
     *  New 11-12-05 ia holds an instance of the Proto IAnchor.
     */
  private Node ia;
    /**
     *  New 11-12-05 Thread runner launches the new url.
     */
  private Thread runner = null;

	
 public IAnchor( Node IA, String directory ){
 ia = IA; 
 sDirectory = directory;
try {
 localState = (EventOutSFBool)ia.getEventOut("local");
  commandLine = (EventOutSFString)ia.getEventOut("address_changed");
  commandLine.addVrmlEventListener(this);
}
catch(NullPointerException e){ System.out.println("IAnchor constructor error: " + e ); }
catch(InvalidEventOutException f){ System.out.println("IAnchor constructor error: " + f ); }
 }	

	 public void eventOutChanged(VrmlEvent vrmlevent ){
	    BaseField bf = vrmlevent.getSource();
    try {
	    if( bf.getType()!= 8 ) {
		System.err.println("Got wrong value from ");
		return;
	    }
       String CS = commandLine.getValue();
       bLocal = localState.getValue();
  ;	   if(!bLocal){
	   commandString = CS;
       }
       else {
       if(CS.indexOf("http://")!=-1){ 
    	CS = CS.substring(7);
	   }
	    commandString = sDirectory + CS;
       }
   // System.out.println("IAnchor commandString: " + commandString);
       start();
	    }
	catch(Exception e) {
	    System.err.println("Error converting msg from world"+"\n\t" +e);
	}
     
 
    }

   public void start(){
 if(runner == null ){ 
  runner = new Thread(this); 
   runner.start(); }
  }
   
 public void stop(){
  runner = null;
 }

	public void run(){
 while( Thread.currentThread() == runner ) {
try {
BrowserLauncher launcher = new BrowserLauncher(); 
launcher.openURLinBrowser(commandString); 
}
catch (BrowserLaunchingInitializingException ex) {  
ex.printStackTrace();  
}    
catch (UnsupportedOperatingSystemException ex) {  
ex.printStackTrace();  
}  
stop();
  }
}

public void delete(){
if(commandLine!=null){ commandLine.removeVrmlEventListener(this);}
   runner = null; ia = null; commandLine = null; localState = null;
   } 

}
