 /**
  PrimeMoverString.java
 
  Copyright (C)  2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.deck.eai2;

public class PrimeMoverString {

private String sPrimeMover = (" PROTO PrimeMover [ " +
" eventIn	SFVec3f	set_position2 " +
" eventIn	SFRotation set_rotation2 " +
" eventIn	SFVec3f	set_start_position " +
" eventIn	SFRotation	set_start_rotation " +
" eventOut SFVec3f position_changed " +
" eventOut SFRotation orientation_changed " +
" eventOut SFVec3f position_changed2 " +
" eventOut SFRotation	orientation_changed2 " +
" exposedField SFVec3f translation 0 0 0 " +
" exposedField  SFRotation rotation 0 1 0 0	" +
" exposedField SFInt32 whichChoice 0 " +
" field SFTime rate 0.4	" +
" eventOut SFInt32 save_changed	" +
" eventIn MFFloat set_BeamTo " +
" ] { " +
" Switch {whichChoice IS whichChoice choice [Group {children [Transform {translation IS translation rotation IS rotation children [	" +
" Transform {translation .1 -.1 -.5 scale .05 .05 .05 children [Group {children [Transform {translation -2 .5 .5 children [DEF Sphs SphereSensor {}	" +
" DEF SphsTr Transform {children Shape {appearance Appearance {material Material {diffuseColor 0 .8 .8}}geometry Sphere {radius .5}}}]}Transform {translation -2 -.5 .5 children [ " +
" DEF Y_sw Switch {whichChoice 0 choice [Group {children [DEF Yoffts TouchSensor {}Shape {appearance Appearance {texture ImageTexture {url [\"world/Yoff.jpg\"]}}geometry IndexedFaceSet {coord Coordinate {point [-.25 .25 0, -.25 -.25 0, .25 -.25 0, .25 .25 0,]}coordIndex [0 1 2 3 -1,]}}]}Group {children [DEF Yonts TouchSensor {}Shape {appearance Appearance {texture ImageTexture {url [\"world/Yon.jpg\"]}}geometry IndexedFaceSet {coord Coordinate {point [-.25 .25 0, -.25 -.25 0, .25 -.25 0, .25 .25 0,]}coordIndex [0 1 2 3 -1,]}}]}]}	" +
" DEF X_sw Switch {whichChoice 0 choice [Group {children [DEF Xoffts TouchSensor {}Shape {appearance Appearance {texture ImageTexture {url [\"world/Xoff.jpg\"]}}geometry IndexedFaceSet {coord Coordinate {point [-.75 .25 0, -.75 -.25 0, -.25 -.25 0, -.25 .25 0,]}coordIndex [0 1 2 3 -1,]}}]}Group {children [DEF Xonts TouchSensor {}Shape {appearance Appearance {texture ImageTexture {url [\"world/Xon.jpg\"]}}geometry IndexedFaceSet {coord Coordinate {point [-.75 .25 0, -.75 -.25 0, -.25 -.25 0, -.25 .25 0,]}coordIndex [0 1 2 3 -1,]}}]}]}	" +
" DEF Z_sw Switch {whichChoice 0 choice [Group {children [DEF Zoffts TouchSensor {}Shape {appearance Appearance {texture ImageTexture {url [\"world/Zoff.jpg\"]}}geometry IndexedFaceSet {coord Coordinate {point [.25 .25 0, .25 -.25 0, .75 -.25 0, .75 .25 0,]}coordIndex [0 1 2 3 -1,]}}]}Group {children [DEF Zonts TouchSensor {}Shape {appearance Appearance {texture ImageTexture {url [\"world/Zon.jpg\"]}}geometry IndexedFaceSet {coord Coordinate {point [.25 .25 0, .25 -.25 0, .75 -.25 0, .75 .25 0,]}coordIndex [0 1 2 3 -1,]}}]}]}Transform {translation 0 -.1 0 scale .5 .5 1 children [DEF ResetTs TouchSensor {}Shape {appearance Appearance {texture ImageTexture {url [\"world/Reset.gif\"]}}geometry IndexedFaceSet {coordIndex [0 1 2 -1, 0 2 3 -1,]texCoordIndex [0 1 2 -1, 0 2 3 -1,]coord Coordinate {point [-.6 -.77 0, -.6 -1.15 0, .6 -1.15 0, .6 -.77 0,]}texCoord TextureCoordinate {point [0 1, 0 0, 1 0, 1 1,]}}}]} " +
" Transform {translation -.59 -.1 0 scale .5 .5 1 children [DEF AddrotTs TouchSensor {}Shape {appearance Appearance {texture ImageTexture {url [\"world/AddRot.gif\"]}}geometry IndexedFaceSet {coordIndex [0 1 2 -1, 0 2 3 -1,]texCoordIndex [0 1 2 -1, 0 2 3 -1,]coord Coordinate {point [-.4 -.32 0, -.4 -.7 0, .4 -.7 0, .4 -.32 0,]}texCoord TextureCoordinate {point [0 1, 0 0, 1 0, 1 1,]}}}]} " +
" Transform {translation -.15 -.1 0 scale .5 .5 1 children [DEF SubrotTs TouchSensor {}Shape {appearance Appearance {texture ImageTexture {url [\"world/SubRot.gif\"]}}geometry IndexedFaceSet {coordIndex [0 1 2 -1, 0 2 3 -1,]texCoordIndex [0 1 2 -1, 0 2 3 -1,]coord Coordinate {point [-.4 -.32 0, -.4 -.7 0, .4 -.7 0, .4 -.32 0,]}texCoord TextureCoordinate {point [0 1, 0 0, 1 0, 1 1,]}}}]} " +
" Transform {translation .43 -.1 0 scale .5 .5 1 children [DEF ReturnTs TouchSensor {}Shape {appearance Appearance {texture ImageTexture {url [\"world/Return.gif\"]}}geometry IndexedFaceSet {coordIndex [0 1 2 -1, 0 2 3 -1,]texCoordIndex [0 1 2 -1, 0 2 3 -1,]coord Coordinate {point [-.7 -.32 0, -.7 -.7 0, .7 -.7 0, .7 -.32 0,]}texCoord TextureCoordinate {point [0 1, 0 0, 1 0, 1 1,]}}}]} " +
" Transform {translation .7 -.9 0 scale 1.2 1.2 1 children [DEF Fix TouchSensor {}Shape {appearance Appearance {texture ImageTexture {url [\"world/Check.gif\"]}}geometry IndexedFaceSet {coordIndex [0 1 2 -1, 0 2 3 -1,]texCoordIndex [0 1 2 -1, 0 2 3 -1,]coord Coordinate {point [.35 .35 0, .35 -.25 0, .75 -.25 0, .75 .35 0,]}texCoord TextureCoordinate {point [0 1, 0 0, 1 0, 1 1,]}}}]}]}]} " +
" Transform {rotation 1 1 0 .7 children [Group {children [ " +
" Group {children [Shape {appearance Appearance {material DEF M1 Material {diffuseColor 1 0 0}}geometry IndexedFaceSet {coord Coordinate {point [-.1 -.0995 -.3, -.1 .1005 -.3, -.1 -.0995 -1, -.1 .1005 -1,.1 -.0995 -.3, .1 -.0995 -1, .1 .1005 -.3, .1 .1005 -1,]}coordIndex [3 1 6 7 -1, 6 4 5 7 -1, 7 5 2 3 -1, 2 5 4 0 -1, 2 0 1 3 -1,]}}DEF B_ts TouchSensor {}]} " +
" Group {children [Shape {appearance Appearance {material USE M1}geometry IndexedFaceSet {coord Coordinate {point [-.3 .100 .1, -1 .1005 .1, -1 -.0995 .1, -.3 -.0995 .1, -1 -.0995 -.1,-.3 -.0995 -.1, -.3 .1005 -.1, -1 .1005 -.1,]}coordIndex [0 1 2 3 -1, 4 5 3 2 -1, 0 6 7 1 -1, 6 5 4 7 -1, 1 7 4 2 -1,]}}DEF L_ts TouchSensor {}]} " +
" Group {children [Shape {appearance Appearance {material USE M1}geometry IndexedFaceSet {coord Coordinate {point [.1 -.3 .1, -.1 -.3 .1, -.1 -1 .1, .1 -1 .1, -.1 -.3 -.1, -.1 -1 -.1,.1 -.3 -.1, .1 -1 -.1,]}coordIndex [0 1 2 3 -1, 1 4 5 2 -1, 6 7 5 4 -1, 0 3 7 6 -1, 7 3 2 5 -1,]}}DEF D_ts TouchSensor {}]} " +
" Group {children [Shape {appearance Appearance {material USE M1}geometry IndexedFaceSet {coord Coordinate {point [1 .1005 .1, .3 .1005 .1, .3 -.0995 .1, 1 -.0995 .1, .3 .1005 -.1,1 .1005 -.1, 1 -.0995 -.1, .3 -.0995 -.1,]}coordIndex [0 1 2 3 -1, 4 1 0 5 -1, 5 0 3 6 -1, 7 6 3 2 -1, 7 4 5 6 -1,]}}DEF R_ts TouchSensor {}]} " +
" Group {children [Shape {appearance Appearance {material USE M1}geometry IndexedFaceSet {coord Coordinate {point [-.1 -.0995 .3, .1 -.0995 .3, .1 -.0995 1, -.1 -.0995 1, -.1 .1005 1,-.1 .1005 .3, .1 .1005 .3, .1 .1005 1,]}coordIndex [0 1 2 3 -1, 3 4 5 0 -1, 6 5 4 7 -1, 6 7 2 1 -1, 4 3 2 7 -1,]}}DEF F_ts TouchSensor {}]}Group {children [Shape {appearance Appearance {material USE M1}geometry IndexedFaceSet {coord Coordinate {point [.1 1 .1, -.1 1 .1, -.1 .3 .1, .1 .3 .1, .1 .3 -.1, .1 1 -.1,-.1 .3 -.1, -.1 1 -.1,]}coordIndex [0 1 2 3 -1, 0 3 4 5 -1, 6 7 5 4 -1, 1 7 6 2 -1, 7 1 0 5 -1,]}} " +
" DEF U_ts TouchSensor {}]}Group {children [DEF ReturnPosTs TouchSensor {}Shape {appearance Appearance {material Material {diffuseColor 0 1 0}}geometry Box {size .35 .35 .35}}]}]}]}]}]}DEF Tms1 TimeSensor {enabled FALSE loop TRUE } " +
" DEF Movesc Script { " +
"  eventIn SFBool set_OverYon " +
"  eventIn SFBool set_OverYoff " +
"  eventIn SFBool set_OverXon  " +
"  eventIn SFBool set_OverXoff " +
"  eventIn SFBool set_OverZon  " +
"  eventIn SFBool set_OverZoff " +
"  eventIn SFBool set_returnOverPos	" +
"  eventIn SFBool set_resetOverPos " +
"  eventIn SFBool add_Overrotation " +
"  eventIn SFBool sub_Overrotation " +
"  eventIn   SFBool set_Overcheck " +
"  eventIn   SFBool set_OverreturnRot " +
"  eventIn	SFBool set_OverresetRot	" +
"  eventIn      SFBool	set_over1 " +
"  eventIn      SFBool	set_over2 " +
"  eventIn      SFBool	set_over3 " +
"  eventIn      SFBool	set_over4 " +
"  eventIn      SFBool	set_over5 " +
"  eventIn      SFBool	set_over6 " +
"  eventIn	MFFloat	set_BeamTo IS set_BeamTo " +
"  eventIn SFTime set_returnPos	" +
"  eventIn SFTime set_resetPos	" +
"  eventIn SFTime add_rotation " +
"  eventIn SFTime sub_rotation " +
"  eventIn   SFTime set_check " +
"  eventIn   SFTime set_returnRot " +
"  eventIn	SFTime set_resetRot	" +
"  eventIn	SFVec3f	set_start_position	IS set_start_position " +
"  eventIn	SFRotation	set_start_rotation IS set_start_rotation  " +
"  eventIn SFRotation set_rotation " +
"  eventIn SFRotation set_rotation2 IS set_rotation2 " +
"  eventIn SFVec3f set_position2 IS set_position2 " +
"  eventIn SFTime set_Yon " +
"  eventIn SFTime set_Yoff " +
"  eventIn SFTime set_Xon " +
"  eventIn SFTime set_Xoff " +
"  eventIn SFTime set_Zon " +
"  eventIn SFTime set_Zoff " +
"  eventIn      SFBool	set_active1	" +
"  eventIn      SFBool	set_active2	" +
"  eventIn      SFBool	set_active3	" +
"  eventIn      SFBool	set_active4	" +
"  eventIn      SFBool	set_active5	" +
"  eventIn      SFBool	set_active6	" +
"  eventIn SFFloat set_float1 " +
"  field MFNode Tmss [USE Tms1 USE Y_sw USE X_sw USE Z_sw ] " + 
"  field SFVec3f start_pos 0 0 0 " +
"  field	SFVec3f	orig_pos 0 0 0 " +
"  field SFVec3f new_pos 0 0 0 " +
"  field	SFVec3f	cur_pos 0 0 0 " +
"  field SFVec3f pos5 0 0 0	" +
"  field SFVec3f pos4 0 0 -10 " +
"  field	SFRotation default_rot 0 1 0 0 " +
"  field SFRotation new_rot 0 1 0 0 " +
"  field SFRotation start_rot 0 1 0 0 " +
"  field SFRotation position_rot 0 1 0 0  " +
"  field	SFRotation cur_rot 0 1 0 0 " +
"  field	SFRotation prev_rot 0 1 0 0	" +
"  field SFRotation orig_rot 0 1 0 0 " +
"  field SFRotation reset_rot 0 1 0 0 " +
"  field SFRotation rot5 0 1 0 0 " +
"  field SFRotation rot4 0 1 0 3.14	 " +
"  field	SFFloat	Angle 0.0 " +
"  field	SFFloat	Angle2 0.0 " +
"  field	SFTime tms 0.0 " +
"  field	SFTime rate IS rate	 " +
"  field MFInt32 xyz [ 0 0 0 0 ] " +
"  field  SFInt32 ch 0 " +
"  field        MFFloat	ft	[ 0, 0, 0 ]	" +
"  field        SFVec3f	mv	0 0 0 " +
"  eventOut SFRotation offset_changed  " +
"  eventOut SFInt32 save_changed IS save_changed " +
"  eventOut SFVec3f position_changed IS position_changed " +
"  eventOut SFRotation orientation_changed IS orientation_changed  " +
"  eventOut SFVec3f position_changed2 IS position_changed2 " +
"  eventOut SFRotation orientation_changed2 IS orientation_changed2	" +
" directOutput TRUE	" +
" url	\"javascript: " +
" function resetft(){ ft[0] =  ft[1] = ft[2] = 0;} " +
" function describe( a, b){ " +
"  if(a){ Browser.setDescription(b);} " +
"   else { Browser.setDescription(''); } } " +
" function set_OverYon(v){ describe(v,'Rotation around Y axis enabled.');} " +
" function set_OverYoff(v){ describe(v,'Click for rotation around Y axis.');} " +
" function set_OverXon(v){ describe(v,'Rotation around X axis enabled.');} " +
" function set_OverXoff(v){ describe(v,'Click for rotation around X axis.');} " +
" function set_OverZon(v){ describe(v,'Rotation around Z axis enabled.');} " +
" function set_OverZoff(v){  describe(v,'Click for rotation around Z axis.');} " + 
" function set_returnOverPos(v){  describe(v,'Return to starting postion.');} " +
" function set_resetOverPos(v){  describe(v,'Return to original starting position.');} " +  
" function add_Overrotation(v){  describe(v,'Add new rotation to previous rotation.');} " +
" function sub_Overrotation(v){  describe(v,'Subtract newest rotation.');}  " +
" function set_Overcheck(v){  describe(v,'Save current position and orientation to server.');} " +
" function set_OverreturnRot(v){ describe(v,'Return original starting rotation.');}  " + 
" function set_OverresetRot(v){  describe(v,'Remove any rotation (default).');}  " +	
" function set_over1(v){ch = 0;  describe(v,'Increment position on Y axis.');}  " +
" function set_over2(v){ch = 1;  describe(v,'Decrement position on Y axis.');}  " +
" function set_over3(v){ch = 2;  describe(v,'Decrement position on X axis.');}  " +
" function set_over4(v){ch = 3;  describe(v,'Increment position on X axis.');}  " +
" function set_over5(v){ch = 4;  describe(v,'Decrement position on Z axis.');}  " +
" function set_over6(v){ch = 5;  describe(v,'Increment position on Z axis.');}  " +
" function set_returnPos(v){ resetft(); position_changed = cur_pos  = orig_pos;}  " +   
" function set_check(v){ if(v){ position_changed = cur_pos; orientation_changed = cur_rot;  save_changed = 1; }} " +
" function set_resetRot(v){ " + 
" orientation_changed = cur_rot = start_rot = new SFRotation( 0, 1, 0, 0); " + 
" offset_changed = cur_rot;} " +
" function set_BeamTo(v,ts){ " +
" pos5 = new SFVec3f(v[0],v[1],v[2]); " +
" rot5 = new SFRotation(v[3],v[4],v[5],v[6]); " +
" var vm = new VrmlMatrix(); " +
" vm.setTransform(pos4,rot4); " + 
" var vm2 = new VrmlMatrix(); " +
" vm2.setTransform(pos5, rot5 ); " +
" vm = vm.multRight(vm2);  " +
" vm.getTransform(position_changed,orientation_changed); " +
" save_changed = 1; " +
" }	" +
" function set_returnRot(v){ " +
" start_rot = orig_rot; " +
" orientation_changed = start_rot;  " + 
" offset_changed = new SFRotation(0, 1, 0, 0);  " +
" }	" +
" function set_start_position(v){ " +
" resetft(); " + 
" cur_pos = v; " +
" start_pos = v; " + 
" orig_pos = v; " +
" }	" +
" function set_start_rotation(v){  " +
" start_rot = v;  " + 
" orig_rot = v;  " +
" cur_rot = v;  " + 
" position_rot = v;  " + 
" }	" +
" function set_rotation2(v){ orientation_changed2 = v;} " +
" function set_position2(v){ position_changed2 = v;} " +
" function sub_rotation(v){ " +
" start_rot = prev_rot;	" +
" offset_changed = new SFRotation(0, 1, 0, 0); " +
" orientation_changed = start_rot; }  " +
" function add_rotation(v){ " +
" prev_rot = cur_rot; " +
"  start_rot = cur_rot; " + 
" offset_changed = new SFRotation(0, 1, 0, 0); " +
" orientation_changed = cur_rot; " +
" } " +   
" function set_rotation(v,ts){ " +
" if(0<v[3]){ new_rot[3] += -.017444; }	" +
" else { new_rot[3] += -.017444;} " +
" if(xyz[3]==0){ new_rot = new SFRotation(v[0],v[1],v[2],new_rot[3]); }	" +
" if((ts-tms)>=rate){ " +
" if(6.28<new_rot[3]){ new_rot[3] = (new_rot[3]-6.28); } " +
" if(new_rot[3]< -6.28){ new_rot[3] = (new_rot[3]+6.28); } " +
" var vm = new VrmlMatrix(); " +
" vm.setTransform(start_pos,new_rot); " + 
" var vm2 = new VrmlMatrix(); " +
" vm2.setTransform(start_pos, start_rot ); " +
" vm = vm.multRight(vm2); " +
" vm.getTransform(start_pos,cur_rot); " +
" orientation_changed = cur_rot; " +
" tms = ts;	" +
"   } " +
"  } " +
" function set_float1(v,ts){ " +
" if(ch==0){ ft[1] +=.01; }	" +
" if(ch==1){ ft[1] -=.01; }	" +
" if(ch==2){ ft[0] -=.01; }	" +
" if(ch==3){ ft[0] +=.01; }	" +
" if(ch==4){ ft[2] -=.01; }	" +
" if(ch==5){ ft[2] +=.01; }	" +
" if((ts-tms)>=rate){ " +
" new_pos = new SFVec3f(ft[0],ft[1],ft[2]); " + 
" var vm = new VrmlMatrix(); " +
" vm.setTransform(new_pos,default_rot); " + 
" var vm2 = new VrmlMatrix(); " +
" vm2.setTransform(cur_pos,position_rot); " +
" vm = vm.multRight(vm2); " +
" vm.getTransform(cur_pos); " +
" position_changed = cur_pos; " +
" resetft(); " +
" tms = ts; " +
" } " + 
" }	" +
" function set_Yon(v){ xyz[3] =  xyz[0] = Tmss[1].whichChoice = 0; " +
"  new_rot[3] = 0.0; } " +
" function set_Yoff(v){ xyz[2] = xyz[1] = Tmss[3].whichChoice = Tmss[2].whichChoice = 0; " + 
" xyz[3] = xyz[0] = Tmss[1].whichChoice = 1; " +
" new_rot = new SFRotation( 0, 1, 0, 0.0); " +
" }	" +
" function set_Xon(v){ xyz[3] = xyz[1] = Tmss[2].whichChoice = 0; " +
" new_rot[3] = 0.0; } " +
" function set_Xoff(v){ xyz[2] =  xyz[0] = Tmss[3].whichChoice = Tmss[1].whichChoice = 0; " +
" xyz[3] = xyz[1] =  Tmss[2].whichChoice = 1; " + 
" new_rot = new SFRotation( 1, 0, 0, 0.0); " +
" }	" +
" function set_Zon(v){ xyz[3] =  xyz[2] = Tmss[3].whichChoice = 0; " + 
" new_rot[3] = 0.0;  } " +
" function set_Zoff(v){xyz[1] =  xyz[0] = Tmss[1].whichChoice = Tmss[2].whichChoice = 0; " +
" xyz[3] = xyz[2] = Tmss[3].whichChoice = 1; " +
" new_rot = new SFRotation( 0, 0, 1, 0.0); Angle2 = 0.0;} " +
" function set_active1(v,ts){ if(v){ ch = 0; resetft();} Tmss[0].enabled = v;} " +
" function set_active2(v,ts){ if(v){ ch = 1; resetft();} Tmss[0].enabled = v;}	" +
" function set_active3(v,ts){ if(v){ ch = 2; resetft();} Tmss[0].enabled = v;} " +
" function set_active4(v,ts){ if(v){ ch = 3; resetft();} Tmss[0].enabled = v;} " +
" function set_active5(v,ts){ if(v){ ch = 4; resetft();} Tmss[0].enabled = v;}	" +
" function set_active6(v,ts){ if(v){ ch = 5; resetft();} Tmss[0].enabled = v;}\"} " +
" ]} ]} " +
"ROUTE Fix.isOver TO Movesc.set_Overcheck " +
"ROUTE Fix.touchTime	TO Movesc.set_check	" +
"ROUTE ReturnPosTs.touchTime TO Movesc.set_returnPos " +
"ROUTE ReturnPosTs.isOver TO Movesc.set_returnOverPos " +
"ROUTE Movesc.offset_changed TO Sphs.offset	" +
"ROUTE AddrotTs.touchTime TO Movesc.add_rotation " +
"ROUTE AddrotTs.isOver TO Movesc.add_Overrotation  " +
"ROUTE SubrotTs.touchTime TO	Movesc.sub_rotation	" +
"ROUTE SubrotTs.isOver TO Movesc.sub_Overrotation " +
"ROUTE ReturnTs.touchTime TO	Movesc.set_returnRot " +
"ROUTE ReturnTs.isOver TO Movesc.set_OverreturnRot " +
"ROUTE ResetTs.touchTime	TO Movesc.set_resetRot " +
"ROUTE ResetTs.isOver TO	Movesc.set_OverresetRot	" +
"ROUTE SphsTr.rotation TO Movesc.set_rotation " +
"ROUTE Yonts.touchTime TO Movesc.set_Yon " +
"ROUTE Yonts.isOver TO Movesc.set_OverYon " +
"ROUTE Yoffts.touchTime TO Movesc.set_Yoff " +
"ROUTE Yoffts.isOver TO Movesc.set_OverYoff	" +
"ROUTE Xonts.touchTime TO Movesc.set_Xon " +
"ROUTE Xonts.isOver TO Movesc.set_OverXon " +
"ROUTE Xoffts.touchTime TO Movesc.set_Xoff " +
"ROUTE Xoffts.isOver TO Movesc.set_OverXoff	" +
"ROUTE Zonts.touchTime TO Movesc.set_Zon " +
"ROUTE Zonts.isOver TO Movesc.set_OverZon " +
"ROUTE Zoffts.touchTime TO Movesc.set_Zoff " +
"ROUTE Zoffts.isOver TO Movesc.set_OverZoff	" +
"ROUTE Sphs.rotation_changed TO SphsTr.rotation	" +
"ROUTE Tms1.fraction_changed TO Movesc.set_float1 " +
"ROUTE U_ts.isActive TO Movesc.set_active1 " +
"ROUTE U_ts.isOver TO Movesc.set_over1 " +
"ROUTE D_ts.isActive TO Movesc.set_active2 " +
"ROUTE D_ts.isOver TO Movesc.set_over2 " +
"ROUTE R_ts.isActive TO Movesc.set_active3 " +
"ROUTE R_ts.isOver TO Movesc.set_over3 " +
"ROUTE L_ts.isActive TO Movesc.set_active4 " +
"ROUTE L_ts.isOver TO Movesc.set_over4 " +
"ROUTE F_ts.isActive TO Movesc.set_active5 " +
"ROUTE F_ts.isOver TO Movesc.set_over5 " +
"ROUTE B_ts.isActive TO Movesc.set_active6 " +
"ROUTE B_ts.isOver TO Movesc.set_over6 " +
" }	" +
" DEF Pm PrimeMover { whichChoice -1 } ");

public PrimeMoverString(){
}

public String getPrimeMoverString(){
return sPrimeMover;
}

}