/**
  WorldObject.java

  Copyright (C) 1999 Geometrek	and 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.deck.eai2;

import matrix.vrml.*;
import matrix.deck.RealTimeConsumer;
import matrix.deck.ConsumerException;
import matrix.deck.Network;
import matrix.deck.CtrlEvent;
import java.io.*;
import java.util.*;
import vrml.eai.*;
import vrml.eai.field.*;
import vrml.eai.event.*;

/**
 *  manages the NetworkState nodes of a world
 *
 *  @version 1.3
 */
public class WorldObject implements RealTimeConsumer, Runnable {

    private EventInMFString EISMT = null;
       /**
     * New 11-12-05 EventIn for WorldReceiveChat class. Given to the UserAvatar and then to the Beta class. Seemingly unnecessarily long process stops prevents crashes in Cosmoplayer.
     */
    private EventInMFString yak = null;
      /**
     * New 11-12-05 WorldSendAv_Name_Url class created on finding of instance of "MatrixAvatar_Name_Url"  Proto. Sends user name and avatar url to world.
     */
    private WorldSendAv_Name_Url WSANU = null;
   /**
     * New 11-12-05 tf is made true when an instance of Matrix Proto "WorldSendAv_Name_Url" is found in
     * the screen graph. This allows the VRML strings to be sent after the whole scene graph has been read. 
     */
    private boolean tf = false;
    /**
     * New 11-12-05 WorldRecieveChat class allows VRML world to receive text from user and network. Instanced when instance of Matrix Proto "MatrixReceiveChat" is found in scene graph.
     */
    private WorldReceiveChat WRC = null;
     /**
     * New 11-12-05 WorldSendChat class allows VRML world to send text from the world to the network. Instanced when instance of Matrix Proto "MatrixSendChat" is found in scene graph.
     */
    private WorldSendChat WSC = null;
    private WorldSendLocalChat WSLC = null;
	private boolean bObject = false, bOR = true;
    /**
     * New 11-12-05 vn is VRML browser viewer number to establish workarounds for plugin foibles.
     */
    private String sWorldUrl = null, sBackGround = "default", sForeGround = "default";
    private int vn = 0;
    private String name;
    private float [] fViewpointPos_Rot = new float [] { (float)0.0, (float)0.0, (float)0.0, (float)0.0, (float)1.0, (float)0.0, (float)0.0 };
    /**
     *  Sets top most Viewpoint in stack as true
     */
    private boolean bCont = true;
    private long lTime = (long)0.0;
    private long lSleep = (long)0.0;
    private PrimeRoute PR = null;
    private EventInSFInt32 setNav = null;
    private EventInSFFloat setSpeed = null;
   // private EventInSFBool binder = null;
	private navObserver NavObs = null;
    private navInfoObserver navInfoObs = null;
    private String [] sMBA = new String [2];	
    private boolean bMBA = false;
    private String sML = "";
    private boolean bAvalon = false;
    private boolean bOrigNav = false;
    private boolean bCollide = true;
    private boolean bML = false;
    private boolean bBkg = false;
    private boolean bFog = false;
    private boolean bContAb = false;
    private boolean bVp = false;
    private boolean bNav = false;
    private boolean bPNav = true;
    private boolean bPVp = true;
    private boolean bFirst = false;
    private boolean bSecond = false;
	private boolean bThird = false;
    private Node [] WIFO = null;
    private Hashtable VPEventIns = new Hashtable();
    private String sWalkerDesc = "Entry";
    private String sWait = "";
    private Node avNode = null;
    private EventInMFNode addAvChildren = null;
    private EventInMFNode removeAvChildren = null;
    private EventInMFNode setAvChildren = null;
    private EventOutMFNode childrenAvChanged = null;
    private int iCACsize = 0;
    private int nodeCt = 0;
    private Node origGrp = null;
    private int groupCt = 0;
    private int bindCt = 0;
    private String [] origNav = null;
    private float origVL = (float)0.0;
    private float origSp = (float)1.0;
    private float [] origAvSize	= { (float)0.0,(float)0.0,(float)0.0 };
    private boolean origHL = true;
    private float [] origPos = { (float)0.0,(float)0.0,(float)10.0 };
    private float [] origRot = { (float)0.0,(float)1.0,(float)0.0,(float)0.0 };
    private  float origFOV = (float)0.785398;
	public boolean bAvatar = false;
     /**
     * Holds ProximitySensor for distributing UserAvatar location  over network.
     */
    private Node proxy = null;
    //private Node PM = null;
     /**
     * New 11-12-05 ML is for instance of Matrix Proto "MatrixLights" Allows for delivering a boolean to VRML world for certain tasks like turning off lights when leaving to deal with memory leaks in certain VRML browsers ( Contact 4.4 and WorldView mainly )
     */
    private Node  ML = null; 
    private Node  MW = null;
    private Network postOffice;
      /**
     *  Holds Route classes created from SharedEvent Protos instances found.
     */
    private Vector states = new Vector();
    private Vector sounds = new Vector();
   /**
     *  Distance needed on Y axis to correctly/realistically position UserAvatar on ground
     */
    private float offset;
      /**
     *  Holds Gate classes created from MatrixGate Protos instances found.
     */
    private Hashtable ctrlevents = new Hashtable();
    private Rot_PosObserver ROPO; 
    private Vector gates = new Vector();
    private Vector timer_events = new Vector();
	private Vector anchors = new Vector();
     private Vector vMemory = new Vector();
    private Vector vSound = new Vector();
    private Vector vAppear = new Vector();
	private Thread runner = null;
    private Beta deck;
    /**
     * builds a new WorldObject. It parses the loaded world nodes and 
     * builds all the necessary Route objects, initializes the world.
     * New 11-12-05 Besides the looking for instances of new Protos, 
     * ( MatrixLights, MatrixSendChat, MatrixReceiveChat, MatrixAvatar_Name_Url )
     * the constructor sends a signal when it is finished by calling deck.world_loaded
     *
     * @param object the loaded object, containing the name and a Transform
     * @param browser reference to the VRML browser
     * @param postOffice reference to the Network object
     * @param beta reference to the Applet class for Matrix_Gates
     * @param vpIndex index to which Viewpoint to bind
     *
     
     */
  public class navObserver implements VrmlEventListener {
  private boolean bLoaded = false;
  private EventOutMFString typeChanged = null;
 
	    public navObserver( EventOutMFString type_changed ) throws Exception {
	 typeChanged = type_changed;
if(!bLoaded){ typeChanged.addVrmlEventListener(this);
   bLoaded = true;}
     }

	public void eventOutChanged( VrmlEvent vrmlevent ) {
  BaseField bf =  vrmlevent.getSource();
		if( bf.getType()==17 ) {
    postOffice.setNavChange( typeChanged.getValue()  );
    }
    }

  public void delete(){                              
if(typeChanged!=null&&bLoaded){ typeChanged.removeVrmlEventListener(this);	}
    }

  }

 public class navInfoObserver implements VrmlEventListener {
  private boolean bLoaded = false;
  private EventOutSFFloat floatChanged = null;
 
	    public navInfoObserver( EventOutSFFloat float_changed ) throws Exception {
	 floatChanged = float_changed;
if(!bLoaded){ floatChanged.addVrmlEventListener(this);
   bLoaded = true;}
     }

	public void eventOutChanged( VrmlEvent vrmlevent ) {
  BaseField bf =  vrmlevent.getSource();
		if( bf.getType()==3 ) {
    postOffice.setSpeedChange( floatChanged.getValue()  );
    }
   }

  public float getSpeed(){
  float ft = floatChanged.getValue();
  return ft;
    }

  public void delete(){                              
if(floatChanged!=null&&bLoaded){ floatChanged.removeVrmlEventListener(this);	}
    }

  }

    public WorldObject( SO2 object, Browser browser, Network postOffice, Beta beta, int vpIndex, int VIN, long slp, String localurl, String worldurl ) throws ConsumerException {
	// System.out.println("WorldObject1");
    deck = beta;
	name = object.getName();
	this.postOffice = postOffice;
	// get nodes 
    WIFO = browser.createVrmlFromString( "WorldInfo {}" );
	Node[] trans = null;
	Node xform = object.getTransform();
	offset = (float)2.0;
    vn = VIN;
    lSleep = slp;
	boolean viewBound = false, fogBound = false, backBound = false, infoBound = false;
   WSC = new WorldSendChat();
   WSLC = new WorldSendLocalChat();
   WSANU = new WorldSendAv_Name_Url();
   WRC = null;
	Node infoNode = null;
    try{
	 trans = ((EventOutMFNode)xform.getEventOut("children_changed")).getValue();
    }
	catch(InvalidEventOutException f){ }
	catch(Exception e){
	    System.out.println("PANIC : can't get world nodes "+e);
	    throw new ConsumerException("Error accessing loaded world !");
	}
	if( trans == null ){
	    System.out.println( name +" nodes not loaded !");
	    return;
	}

 sWorldUrl = worldurl.substring(0,(worldurl.lastIndexOf("/") + 1));
 origGrp = xform;
 lTime = System.currentTimeMillis();
 // System.out.println("WorldObject2");
try {
 sceneGraphSearch( trans, origGrp, beta, browser, vn,  slp, localurl );	
}
catch(NullPointerException j){System.out.println("WorldObject sceneGraphSearch type error: " + j); return;  }
catch(InvalidNodeException h){System.out.println("WorldObject sceneGraphSearch type error: " + h); return;  }
catch(InvalidVrmlException d){System.out.println("WorldObject sceneGraphSearch type error: " + d); return; }
catch(InvalidEventOutException f){System.out.println("WorldObject sceneGraphSearch type error: " + f); return; }
catch(InvalidEventInException g){System.out.println("WorldObject sceneGraphSearch type error: " + g); return; }
catch(Exception e){System.out.println("WorldObject sceneGraphSearch type error: " + e); return; } 
   if(proxy!=null){
	 try {
 ROPO = new Rot_PosObserver( (EventOutSFRotation)proxy.getEventOut("orientation_changed"), (EventOutSFVec3f)proxy.getEventOut("position_changed")  );
 }
catch(NullPointerException j){ System.out.println("WorldObject ROPO type error: " + j); return; } 
catch(InvalidEventOutException f){System.out.println("WorldObject ROPO type error: " + f); return; }
catch(InvalidEventInException g){System.out.println("WorldObject ROPO type error: " + g); return; }
catch(Exception e){System.out.println("WO ROPO error: " + e); return; }
boolean bCL = true;
boolean bMC = false;
 if(!bOrigNav){
 try {
  origSp = ((EventOutSFFloat)proxy.getEventOut("set_speed")).getValue();
 }
 catch(InvalidEventOutException f){ System.out.println("WorldObject sceneGraphSearch no speed: " + f); return;} 

 try {
 bMC = ((EventOutSFBool)proxy.getEventOut("masterCollide")).getValue();
  }
 catch(NullPointerException g){ System.out.println("WorldObject sceneGraphSearch getting collide and headlight info: " + g ); return; } 
 catch(InvalidEventOutException f){ System.out.println("WorldObject sceneGraphSearch no master collide info: continuing... " ); } 
 catch(InvalidNodeException h){ System.out.println("WorldObject sceneGraphSearch getting collide and headlight info: " + h ); return; }
 try {
 origHL = ((EventOutSFBool)proxy.getEventOut("headlight")).getValue();
  }
 catch(NullPointerException g){ System.out.println("WorldObject sceneGraphSearch getting collide and headlight info: " + g ); return; } 
  catch(InvalidEventOutException f){ origHL = true; System.out.println("WorldObject sceneGraphSearch no headlight info: continuing... " ); } 
  catch(InvalidNodeException h){ System.out.println("WorldObject sceneGraphSearch getting collide and headlight info: " + h ); return; }
if(!bMC){
 try {
 bCL = ((EventOutSFBool)proxy.getEventOut("collide")).getValue();
  }
 catch(NullPointerException g){ System.out.println("WorldObject sceneGraphSearch getting collide and headlight info: " + g ); return; } 
  catch(InvalidEventOutException f){ System.out.println("WorldObject sceneGraphSearch no collide info: continuing... " ); } 
  catch(InvalidNodeException h){ System.out.println("WorldObject sceneGraphSearch getting collide and headlight info: " + h ); return; }
 }
  }
  deck.handleCollide_Headlight( origHL, bMC, bCL );
	   	    try{
 setNav =  ((EventInSFInt32)proxy.getEventIn("set_navigation"));
 setSpeed = ((EventInSFFloat)proxy.getEventIn("set_speed"));
   }
  catch(InvalidEventInException f){ System.out.println("WorldObject proxy: set_navigation or set_speed error! Please check Walker Proto for error! " + f ); return; }
 if(bNav&&bPNav){
  //System.out.println("sceneGraphSearch setting proxy navigation"); 
 try {
    ((EventInMFString)proxy.getEventIn("type")).setValue(origNav);
	 ((EventInSFBool)proxy.getEventIn("headlight")).setValue(origHL);
     ((EventInMFFloat)proxy.getEventIn("avatarSize")).setValue(origAvSize);
     ((EventInSFFloat)proxy.getEventIn("visibilityLimit")).setValue(origVL);
     ((EventInSFFloat)proxy.getEventIn("set_speed")).setValue(origSp);
   }
   catch(NullPointerException g){ System.out.println("WorldObject sceneGraphSearch setting proxy: " + g ); return; } 
  catch(InvalidEventInException f){ System.out.println("WorldObject sceneGraphSearch setting proxy: " + f ); return; } 
  catch(InvalidNodeException h){ System.out.println("WorldObject sceneGraphSearch setting proxy: " + h ); return; } 
  bPNav = false;
  }
 if(bVp&&bPVp){
   try {
	((EventInSFFloat)proxy.getEventIn("fieldOfView")).setValue(origFOV);
    ((EventInSFVec3f)proxy.getEventIn("vpposition")).setValue(origPos); 
    ((EventInSFRotation)proxy.getEventIn("vporientation")).setValue(origRot);
     }
  catch(NullPointerException g){ System.out.println("WorldObject sceneGraphSearch setting proxy: " + g ); return; } 
 catch(InvalidEventInException f){ System.out.println("WorldObject sceneGraphSearch setting proxy: " + f ); return; } 
  catch(InvalidNodeException h){ System.out.println("WorldObject sceneGraphSearch setting proxy: " + h ); return; } 
  bPVp = false;
     }
   try {
  String [] Mfs = null;
 int s  = ((EventOutMFString)proxy.getEventOut("type")).size(); 
  if(s==0){ 
  Mfs = new String [] {"WALK","FLY","EXAMINE","FREEFLY","LOOKAT"};
   ((EventInMFString)proxy.getEventIn("type")).setValue(Mfs);
   }
  else {
 String []  Mfs2 = ((EventOutMFString)proxy.getEventOut("type")).getValue();
 Mfs = new String [Mfs2.length];
 Mfs = Mfs2;
    }
 if(Mfs!=null){ postOffice.setNavChange(Mfs); }
 }
catch(InvalidVrmlException d){System.out.println("WorldObject navigation type error: " + d); return; }
catch(InvalidEventOutException f){System.out.println("WorldObject navigation type error: " + f); return; }
catch(InvalidEventInException g){System.out.println("WorldObject navigation type error: " + g); return; }
catch(Exception e){System.out.println("WorldObject navigation type error: " + e); return; } 
		   try {
 NavObs = new navObserver( (EventOutMFString)proxy.getEventOut("type") );
 }
catch(Exception e){System.out.println("WorldObject navigation_changed error: " + e); return; }
	 try {
 navInfoObs = new navInfoObserver( (EventOutSFFloat)proxy.getEventOut("navigation_info_changed") );
 }
catch(Exception e){System.out.println("WorldObject set_speed error: " + e); return; }
 if( infoBound == false ){
            try {
			((EventInSFBool)proxy.getEventIn("set_navbind")).setValue(true);
            }
            catch(InvalidEventInException f){ System.out.println("WorldObject proxy: set_navbind error! " + f); return; } 
            try{
			float[] help = ((EventOutMFFloat)proxy.getEventOut("avatarSize")).getValue();
            if(help.length==1){
			offset = help[0];
            }
            else {
            offset = help[1];
            }
            }
            catch(InvalidEventInException f){ System.out.println("WorldObject proxy: Avatar Size error! " + f); return; }
			infoBound = true;
           System.out.println("Walker found");
             }
			if( viewBound == false ){
			if( vpIndex == -1 ){
         // binder = ((EventInSFBool)proxy.getEventIn("vpbind"));
          //binder.setValue(true);
       float [] ft1 =  ((EventOutSFVec3f)proxy.getEventOut("vpposition")).getValue();
       float [] ft2 =  ((EventOutSFRotation)proxy.getEventOut("vporientation")).getValue();
	   fViewpointPos_Rot = new float[] {ft1[0], ft1[1], ft1[2], ft2[0], ft2[1], ft2[2], ft2[3] };
			//    viewBound = true;
			} else {
			    vpIndex --;
			}
		    }
	if(tf==true){ WSANU.sendName_Url();}
	 if(navInfoObs!=null){ setSpeed( origSp ); }
      runner = new Thread( this, "WorldObject" );
     runner.start();
    }
     else {
    System.out.println("MISSION CRITICAL WALKER PROTO NOT FOUND!");
    return;
    } 
   }

  private void sceneGraphSearch( Node [] mfn, Node Grp, Beta beta, Browser browser, int VIN, long slp, String localurl  ) throws ConsumerException {
  groupCt += 1;
  for( int a = 0; a<mfn.length; a+=1 ){
  nodeCt += 1;
   	  if(!beta.bLogOut){
  long lTime2 = System.currentTimeMillis();
            if( (lTime + 7000) <= lTime2 ){ beta.onHeartBeat(); 
      beta.worldLoadWarning("World still loading...please wait!" ); 
			lTime = lTime2; 
          }
      if(bCont){
   if(mfn[a].getType().equals("Group")||mfn[a].getType().equals("Transform")){
   if(groupCt==1&&mfn[a].getType().equals("Group")){  bFirst = true; }
   Node [] MFN = ((EventOutMFNode)mfn[a].getEventOut("children_changed")).getValue();
   sceneGraphSearch( MFN, mfn[a], beta, browser, vn, slp, localurl );
    }
     if(groupCt==2){
  if(bFirst){
  int iVpCt = -1; 
   if(mfn[a].getType().equals("Walker")){
 // System.out.println("sceneGraphSearch Walker");
		  proxy = mfn[a];
	 sWalkerDesc = ((EventOutSFString)proxy.getEventOut("description")).getValue();
	  VPEventIns.put( sWalkerDesc,((EventInSFBool)proxy.getEventIn("vpbind")) );
      System.out.println("sceneGraphSearch Walker found!");
      } 
    else 
   if(mfn[a].getType().startsWith("Network")){
		   Route route = new Route( mfn[a], postOffice, vn, slp );
		    route.setName( name+"_"+route.getName());
		    states.addElement( route );
		    postOffice.addConsumer( route );
		  System.out.println("Network found");
        }
	  else 
    if( mfn[a].getType().startsWith("Ctrl")){
          if(mfn[a].getType().indexOf("Network")==4){
		    CtrlRoute CR = new CtrlRoute( mfn[a], postOffice, vn, 400, deck.set_AvatarName() );
		    CR.setName( name+"_"+CR.getName());
		    states.addElement( CR );
		    postOffice.addConsumer( CR );
		   addCtrlEvent( (CtrlEvent)CR );
    	   System.out.println("ControlRoute found");
         }
         else 
		  if(mfn[a].getType().indexOf("Time")==4){
           CtrlTime  CT = new CtrlTime( mfn[a], postOffice, deck.set_AvatarName() );
			 addCtrlEvent( (CtrlEvent)CT );
			  System.out.println("CtrlTime found");
         }
          else 
		  if(mfn[a].getType().indexOf("Remove")==4){
           CtrlRemove CR = new CtrlRemove( mfn[a], postOffice, deck.set_AvatarName() );
           addCtrlEvent( (CtrlEvent)CR );
          }
		}
	   else 
    	if ( mfn[a].getType().startsWith("MatrixViewpoint")){
       VPEventIns.put( ((EventOutSFString)mfn[a].getEventOut("description")).getValue(),((EventInSFBool)mfn[a].getEventIn("set_bind")) );
		System.out.println("MatrixViewpoint type found");
		}
	    else 
    	if ( mfn[a].getType().equals("Matrix_Sound")){
        MatrixSound MS = new MatrixSound( mfn[a], sounds.size()+1 );
        sounds.addElement( MS );
		System.out.println("Matrix_Sound found");
		}
      else 
    	if ( mfn[a].getType().equals("Matrix_Gate")){
      Gate gate = new Gate( mfn[a], beta, vn );
    gates.addElement(gate);
		System.out.println("Gate found");
		}
	    else 
		if ( mfn[a].getType().equals("Matrix_Text")){
         EISMT = (EventInMFString)mfn[a].getEventIn("set_matrixText" );
     //  boolean tf  = ((EventOutSFBool)mfn[a].getEventOut("bDefault")).getValue();
	          beta.handleMatrixText();
		   System.out.println("Matrix Text found");
		   }
        else 
    	if ( mfn[a].getType().equals("Matrix_Anchor")){
      IAnchor ianchor = new IAnchor( mfn[a], localurl );
      anchors.addElement(ianchor);
		System.out.println("Anchor found");
		}
      else 
	 if( mfn[a].getType().equals("Matrix_Gui")){
     String st2 =  ((EventOutSFString)mfn[a].getEventOut("description")).getValue();
     bMBA =  ((EventOutSFBool)mfn[a].getEventOut("bButtonChoice")).getValue();
     if(bMBA){
     String [] st1 = ((EventOutMFString)mfn[a].getEventOut("url")).getValue();
     if(!st1[0].startsWith("http://")){
     st1[0] = localurl + st1[0];
     }
     sMBA =	new String [] {st2,st1[0]};
     }
     else {
     sMBA = new String [] {st2};
     }
     sBackGround = ((EventOutSFString)mfn[a].getEventOut("backGround")).getValue();
     sForeGround = ((EventOutSFString)mfn[a].getEventOut("foreGround")).getValue();
     beta.handleGUIColors( sBackGround, sForeGround );
       System.out.println("Matrix_Gui found");
     }
	else 
    if (mfn[a].getType().equals("MatrixTimer")){
    TimerEvent TE  = new TimerEvent( mfn[a] ); 
	System.out.println("MatrixTimer found");
    timer_events.addElement(TE);
      }
    else 
    if (mfn[a].getType().equals("MatrixSendChat")){
     WSC  = new WorldSendChat(beta, mfn[a] ); 
	System.out.println("MatrixSendChat found");
      }
      else 
	 if (mfn[a].getType().equals("MatrixSendLocalChat")){
     WSLC  = new WorldSendLocalChat(beta, mfn[a] ); 
	System.out.println("MatrixSendLocalChat found");
      }
     else 
    if (mfn[a].getType().equals("MatrixReceiveChat")){
 try {
  yak = (EventInMFString)mfn[a].getEventIn("set_ChatIn");
 }
catch(NullPointerException e){ 
System.out.println("MatrixReceiveChat: set_ChatIn not found!" + e); 
 break;
 }
catch(InvalidEventOutException ieoe ) {
 System.out.println("MatrixReceiveChat: set_ChatIn not found!" + ieoe);
break; 
}
 if(yak!=null){
  WRC = new WorldReceiveChat( postOffice );
  WRC.set_yakker( yak );
  System.out.println("MatrixReceiveChat found");
  }
  
}
  else 
  if (mfn[a].getType().equals("MatrixLights")){
   ML = mfn[a];
  System.out.println("Matrix Lights found");
  }
  else 
  if (mfn[a].getType().equals("MatrixWorld")){
   MW = mfn[a];
  System.out.println("Matrix World found");
  }
  else 
  if (mfn[a].getType().equals("MatrixAvatar_Name_Url")){
    WSANU.setWSANU( beta.set_AvatarName(), beta.set_AvatarUrl(), mfn[a]  );
    tf = true;
   System.out.println("MatrixAvatar_Name_Url found");
 }
   else 
  if(!bBkg&&mfn[a].getType().equals("Background")){
  ((EventInSFBool)mfn[a].getEventIn("set_bind")).setValue( true );
   bindCt += 1; bBkg = true;
    }
   else 
  if(!bFog&&mfn[a].getType().equals("Fog")) {
    ((EventInSFBool)mfn[a].getEventIn("set_bind")).setValue( true );
   bindCt += 1; bFog = true;
   }
   else 
    if(mfn[a].getType().equals("PrimeMover")){ 
    Node PM = mfn[a];
    bObject = true;
	PR = new PrimeRoute( PM, postOffice, vn, slp, beta.set_AvatarName() );
		    PR.setName( name+"_"+PR.getName());
		    states.addElement( PR );
		    postOffice.addConsumer( PR );
		System.out.println("PrimeMover found");
   }
  if(a==mfn.length-1){
   if(proxy!=null){ 
  if(!bSecond){ bCont = false; break; }
   }
   else {
  if(!bSecond){  makeProxy( Grp, browser ); }
    continue;
    }
   }
  }
 else {
  //    System.out.println(" WO sceneGraphSearch making Group node " );
   Node [] help4 = makeGroup( browser );
 ((EventInMFNode)origGrp.getEventIn("addChildren")).setValue(help4);
 makeProxy( help4[0], browser );
 Node [] MFN2 = ((EventOutMFNode)origGrp.getEventOut("children_changed")).getValue();
 Node [] MFN3 = new Node [MFN2.length];
 MFN3[0] = MFN2[MFN2.length-1];
 for( int b = 0; b<MFN2.length-1; b +=1 ){
 MFN3[b+1] = MFN2[b];
 }
 groupCt = 0;
 sceneGraphSearch( MFN3, origGrp, beta, browser, vn, slp, localurl ); 
  }
 }
  if(!bBkg&&mfn[a].getType().equals("Background")){
  ((EventInSFBool)mfn[a].getEventIn("set_bind")).setValue( true );
   bindCt += 1; bBkg = true;
    }
   else 
  if(!bFog&&mfn[a].getType().equals("Fog")) {
    ((EventInSFBool)mfn[a].getEventIn("set_bind")).setValue( true );
   bindCt += 1; bFog = true;
   }
  if(!bNav&&mfn[a].getType().equals("NavigationInfo")){	 
 try {
 origNav = ((EventOutMFString)mfn[a].getEventOut("type")).getValue();
 origHL = ((EventOutSFBool)mfn[a].getEventOut("headlight")).getValue();
 origAvSize = ((EventOutMFFloat)mfn[a].getEventOut("avatarSize")).getValue();
 origVL = ((EventOutSFFloat)mfn[a].getEventOut("visibilityLimit")).getValue();
 origSp = ((EventOutSFFloat)mfn[a].getEventOut("speed")).getValue();
 bOrigNav = true;
   System.out.println(" NavigationInfo " );
  }
  catch(InvalidEventOutException h){ System.out.println( " WorldObject NavigationInfo prob: " + h );
	  throw new ConsumerException("Error getting NavigationInfo in world !");
   }
 if(origNav.length==1&&origNav[0].equals("ANY")){
 origNav = new String [] {"WALK","FLY","EXAMINE","FREEFLY","LOOKAT","PAN","SLIDE"};
 }
 
 bindCt += 1; bNav = true;
    }
  if(!bVp&&mfn[a].getType().equals("Viewpoint")){
 try {
 origFOV = ((EventOutSFFloat)mfn[a].getEventOut("fieldOfView")).getValue();
 origPos = ((EventOutSFVec3f)mfn[a].getEventOut("position")).getValue();
 origRot = ((EventOutSFRotation)mfn[a].getEventOut("orientation")).getValue();
		System.out.println(" Viewpoint " );
  }
  catch(InvalidEventOutException h){ System.out.println( " WorldObject Viewpoint prob: " + h );
	  throw new ConsumerException("Error getting ViewPoint in world !");
   }
 bindCt += 1; bVp = true;
  }
 if(a==mfn.length-1&&proxy==null){
System.out.println("Making Group");
Node [] help = makeGroup( browser );
 ((EventInMFNode)Grp.getEventIn("addChildren")).setValue(help);
 makeProxy( help[0], browser );
 Node [] MFN2 = ((EventOutMFNode)Grp.getEventOut("children_changed")).getValue();
 Node [] MFN3 = new Node [MFN2.length];
 MFN3[0] = MFN2[MFN2.length-1];
 for( int b = 0; b<MFN2.length-1; b +=1 ){
 MFN3[b+1] = MFN2[b];
 }
 groupCt = 0;
 sceneGraphSearch( MFN3, Grp, beta, browser, vn, slp, localurl ); 
}
 if(bindCt==4&&proxy!=null){ bCont = false; break; }
	 }
  else { break; }

    }
  else { bCont = false; break; }
   }
  }

 private void makeProxy( Node grp, Browser browser ) throws ConsumerException {
	        Node [] help3 = null; 
     WalkerString WS = new WalkerString();
       try {
       help3 = browser.createVrmlFromString( WS.getWalker() );
     ((EventInMFNode)grp.getEventIn("addChildren")).setValue(help3);
	 System.out.println("Creating Walker from String into Matrix Group Node.");
     bSecond = true;
       }
       catch (InvalidVrmlException g) { System.out.println(" Invalid VRML prob: " + g );
	throw new ConsumerException("Error adding Walker to infoNode in world !");
  } 
catch (InvalidNodeException d) { System.out.println(" Node prob: " + d );  
 throw new ConsumerException("Error adding Walker to infoNode in world !");
 }
catch(InvalidBrowserException e){ System.out.println( " Browser prob: " + e ); 
throw new ConsumerException("Error adding Walker to infoNode in world !");
}
catch(NullPointerException f){System.out.println("Null prob: " + f );
   throw new ConsumerException("Error adding Walker to infoNode in world !");
 }
catch(InvalidEventInException j){ System.out.println( " WorldObject EventIn prob: " + j ); }
	catch(Exception k){	System.out.println( " WorldObject EventIn prob: " + k );
	    throw new ConsumerException("Error adding Walker to infoNode in world !");
	} 

 }

 private Node [] makeGroup( Browser browser ) throws ConsumerException {
Node foo [] = null;
 try {
       foo = browser.createVrmlFromString( "Group {}" );
     System.out.println("Creating Matrix Group Node.");
       }
       catch (InvalidVrmlException g) { System.out.println(" Invalid VRML prob: " + g );
	throw new ConsumerException("Error creating Group Node in world !");
  } 
catch (InvalidNodeException d) { System.out.println(" Node prob: " + d );  
 throw new ConsumerException("Error creating Group Node in world !");
 }
catch(InvalidBrowserException e){ System.out.println( " Browser prob: " + e ); 
throw new ConsumerException("Error creating Group Node in world !");
}
catch(NullPointerException f){System.out.println("Null prob: " + f );
   throw new ConsumerException("Error creating Group Node in world !");
 }
catch(Exception k){	System.out.println( " WorldObject EventIn prob: " + k );
	    throw new ConsumerException("Error  in world !");
	} 
return foo;
}

 public void run(){
  deck.handleLableAnchorInfo( bMBA, sMBA );
  String [] sDescs = new String [ VPEventIns.size() ];
  sDescs[0] = sWalkerDesc;
  int iCt = 1;
  Enumeration list = VPEventIns.keys();
	while( list.hasMoreElements()){
   String st = (String)list.nextElement();
	   if(!st.equals(sWalkerDesc) ){
   sDescs[iCt] = st;
   iCt +=1;
        }
	   }
     deck.handleViewDescriptions( sDescs ); 
 if(bSecond){
      ((EventInSFBool)proxy.getEventIn("bufferEnabled")).setValue(true);
     }
 if(MW!=null){ ((EventInSFBool)MW.getEventIn("set_bool")).setValue(true); }
    deck.world_loaded();
	while( Thread.currentThread() == runner ) {
     if(bSecond){
     if(bThird){ 
    Node [] foo = ((EventOutMFNode)origGrp.getEventOut("children_changed")).getValue();
    Node [] foo2 = new Node[foo.length-1];
    for( int a = 0; a<foo.length; a +=1){  
    if(a<foo.length-1){ foo2[a] = foo[a]; }
    if(a==foo.length-1){ System.out.println("Last child is: " + foo[a].getType() ); }
    }
      try {
    inlinesGraphSearch( foo2 );
        }
catch(NullPointerException f){
  System.out.println("Null prob: inlinesGraphSearch: " + f );
    runner = null;
   }
catch(InvalidEventOutException e){
  System.out.println( " WorldObject EventOut prob inlinesGraphSearch: " + e );  
	runner = null;
 }
catch(InvalidEventInException j){ 
  System.out.println( " WorldObject EventIn prob inlinesGraphSearch: " + j );
  runner = null; 
  }
catch (InvalidNodeException d) { 
 System.out.println(" Node prob inlinesGraphSearch : " + d ); 
    runner = null; 
 }
	catch(Exception k){	
 System.out.println( " WorldObject prob inlinesGraphSearch : " + k );
  runner = null;
	} 
  deck.worldLoadWarning("Inlined files' urls restoration complete!" );
  vMemory.removeAllElements();
  bSecond = false;
  try {
  synchronized(sWait){ 
       sWait.wait(500);
         }
       }
	 catch(InterruptedException e){}
   }
  else {
      try {
  synchronized(sWait){ 
       sWait.wait();
         }
       }
	 catch(InterruptedException e){}
      }
     }
   else { 
    runner = null;
        }
      }
     } 
 
  private void inlinesGraphSearch( Node [] mfn ){
  //System.out.println("WO inlnesGraphSearch mfn length: " + mfn.length );
  for( int a = 0; a<mfn.length; a+=1 ){
  nodeCt += 1;
  //System.out.println(" Node is: " + mfn[a].getType() + " groupCt is " + groupCt + " bFirst is " + bFirst );
   	  if(!deck.bLogOut){
            if(nodeCt!=0&&nodeCt%38==0){ deck.onHeartBeat(); 
      deck.worldLoadWarning("Restoring inlined files' urls...please wait!" ); 
          }
    if(!bContAb){
   Node [] MFN = null;
   if(mfn[a].getType().equals("Group")||mfn[a].getType().equals("Transform")||mfn[a].getType().equals("Collision")||mfn[a].getType().equals("Billboard")){
    MFN = ((EventOutMFNode)mfn[a].getEventOut("children_changed")).getValue();
   inlinesGraphSearch( MFN );
    }
	else
      if(mfn[a].getType().equals("LOD")){
   MFN = ((EventOutMFNode)mfn[a].getEventOut("level")).getValue();
   inlinesGraphSearch( MFN );
    }
	else
         if(mfn[a].getType().equals("Switch")){
    MFN = ((EventOutMFNode)mfn[a].getEventOut("choice")).getValue();
   inlinesGraphSearch( MFN );
    }
	else
   if(mfn[a].getType().equals("Anchor")&&!vMemory.contains( mfn[a] )){
	 changeToAbsolute(mfn[a], "url");
    MFN = ((EventOutMFNode)mfn[a].getEventOut("children_changed")).getValue();
   inlinesGraphSearch( MFN );
    }
    else
	if(mfn[a].getType().equals("Background")&&!vMemory.contains( mfn[a] )){
	 changeToAbsolute(mfn[a], "backUrl");
	 changeToAbsolute(mfn[a], "bottomUrl");
	 changeToAbsolute(mfn[a], "frontUrl");
	 changeToAbsolute(mfn[a], "leftUrl");
	 changeToAbsolute(mfn[a], "rightUrl");
	 changeToAbsolute(mfn[a], "topUrl");
       }
    else 
    if(mfn[a].getType().equals("Sound")){
      Node aC = ((EventOutSFNode)mfn[a].getEventOut("source")).getValue();
      if(aC!=null&&!vMemory.contains( aC )){
      changeToAbsolute(aC, "url"); vSound.addElement( aC );
       }
      else { 
     //System.out.println(" Got AudioClip already ");
      continue; }
	  }
    else 
	if(mfn[a].getType().equals("Inline")&&!vMemory.contains( mfn[a] )){
      changeToAbsolute(mfn[a], "url");
      }
    else 
	if(mfn[a].getType().equals("Shape")){
      Node aP = ((EventOutSFNode)mfn[a].getEventOut("appearance")).getValue();
      if(aP!=null){
      Node tX =	((EventOutSFNode)aP.getEventOut("texture")).getValue();
       if(tX!=null&&!tX.getType().equals("PixelTexture")&&!vMemory.contains( tX )){
      changeToAbsolute(tX, "url");
            }
       else { continue; }
          }
       else { continue; } 
        }
        else
       continue;
     } 
  else { 
    bContAb = false; 
    continue; 
    }
   }
  }
   }



  private void changeToAbsolute( Node foo, String event ){
  boolean bChange = false;
  boolean bChange2 = false;
  String [] mfs = ((EventOutMFString)foo.getEventOut(event)).getValue(); 
  if(0<mfs.length){
  String [] mfs2 = new String[mfs.length];
   for( int a = 0; a<mfs.length; a +=1 ){
 if(mfs[a].equals("")||mfs[a].indexOf(sWorldUrl)!=-1||mfs[a].indexOf("http://")==0){ 
   mfs2[a] = mfs[a]; if(!bChange2) { bChange = false; }
     } 
   else {
  mfs2[a]=(sWorldUrl + mfs[a]); bChange2 = true; bChange = true;
     }
   }
 if(bChange){
 ((EventInMFString)foo.getEventIn(event)).setValue(mfs2);
  vMemory.addElement( foo );
// System.out.println("WO changeToAbsolute");
   }
  }
 else {
  bContAb = true;
  }
 }

   public void startInlineSearch(){
     if(bSecond&&runner!=null){
     // System.out.println("WO startInlineSearch");
      synchronized(sWait){ 
	   bThird = true;
       sWait.notify();
         }  
	  }
     }


 

    /**
     * returns offset found in the NavigationInfo node.
     */
    public float getOffset(){
	return offset;
    }

  
    public Rot_PosObserver getRoPo(){
    return ROPO;
    }

      public void setBinder(){
  //if(binder!=null){
  //binder.setValue(true); }
 }

     /**
     * returns proxy found in the ROOT group node. Used by
     * UserAvatar to track users position.
     */

    public Node getProxy(){
	return proxy;
    }

   private void createPrimeMover(){
     Browser browser = deck.getBrowser();
   PrimeMoverString PMS = new PrimeMoverString();
   try {
  Node [] help = browser.createVrmlFromString( PMS.getPrimeMoverString() );
  ((EventInMFNode)origGrp.getEventIn("addChildren")).setValue(help);
      Node PM = help[0];
    bObject = true;
	PR = new PrimeRoute( PM, postOffice, vn, lSleep, deck.set_AvatarName() );
    PR.setName( name+"_"+PR.getName());
    states.addElement( PR );
	postOffice.addConsumer( PR );
    System.out.println("PrimeMover created");
   }
   catch (InvalidVrmlException g) { System.out.println(" Invalid VRML creating PrimeMover: " + g );
    return;
  } 
catch (InvalidEventInException j) { System.out.println(" Node PrimeMover: " + j ); 
   return;
 }
catch (InvalidNodeException d) { System.out.println(" Node PrimeMover: " + d ); 
   return;
 }
catch(InvalidBrowserException e){ System.out.println( " Browser PrimeMover: " + e ); 
   return;
}
catch(NullPointerException f){System.out.println("Null PrimeMover: " + f );
  return;
 }
catch(Exception k){ System.out.println("Exception PrimeMover: " + k ); 
 return;
 }
 }

      public Node getPrimeMover(){
  Node PM = null;
 if(PR==null){ createPrimeMover();}
 if(PR!=null){ PM = PR.getPrimeMover();}
  return PM;
  }
 
   /**
     * New 11-12-05 getChatIn method returns the EventInMFString for the world receiving chat
     * input. It is called by the UserAvatar class and is placed in the Beta for getting
     * chat from both the network and user. Transfering it from the UserAvatar class keeps
     * Cosmoplayer from crashing...for some unknown reason.
     */
 
     public EventInMFString getChatIn(){
	return yak;
    }

    public String getName(){
	return name;
    }

	  public void objectRoutes( String target ){
  Browser browser = deck.getBrowser();
  Node PM = getPrimeMover();
  if(PM!=null){
  if(bOR==true){
     ((EventInSFVec3f)PM.getEventIn("translation")).setValue( ((EventOutSFVec3f)proxy.getEventOut("translation_changed")).getValue() );
     ((EventInSFRotation)PM.getEventIn("rotation")).setValue( ((EventOutSFRotation)proxy.getEventOut("rotation_changed")).getValue() );
   browser.addRoute( proxy, "rotation_changed", PM, "rotation");
   browser.addRoute( proxy, "translation_changed", PM, "translation");
   ((EventInSFInt32)PM.getEventIn("whichChoice")).setValue(0);
  PR.userView("WAKE");
  bOR = false;
   }
  else {
   ((EventInSFInt32)PM.getEventIn("whichChoice")).setValue(-1);
   browser.deleteRoute( proxy, "rotation_changed", PM, "rotation");
   browser.deleteRoute( proxy, "translation_changed", PM, "translation");
   PR.userView("WAIT");
     bOR = true;
    }
   }
  }


       public void addCtrlEvent( CtrlEvent ctrlevt ){
	if( ctrlevents.containsKey(ctrlevt.ctrlName())){
	    System.err.println("WorldObject addCtrlEvent: "+ctrlevt.ctrlName()+" exists allready");
	    return;
	}
	ctrlevents.put( ctrlevt.ctrlName(), ctrlevt );
    }

         public void removeCtrlEvent( String objname ){
	if( !ctrlevents.containsKey(objname)){
	    System.err.println("WorldObject removeCtrlEvent: "+objname+" doesn't exist!");
	    return;
	}
	ctrlevents.remove( objname );
    }

    public synchronized void handleControlEvent( String target, String [] lock ){
		  CtrlEvent ctrlvt = (CtrlEvent) ctrlevents.get(target);
         if(ctrlvt!=null){ ctrlvt.handleLock( lock );}
    }
  
    public void setViewpoint( String sDesc ){
	EventInSFBool EISFB = (EventInSFBool)VPEventIns.get(sDesc);
    if(EISFB!=null){
    EISFB.setValue(true);
     }
    }

    public void setWorldMessage( String  line, String name    ){
    if(WRC!=null){ WRC.setYak( line, name ); }
    }
   
    public void setMatrixTextMsgs( String [] mtm ){
     if(EISMT!=null){
     try {
      EISMT.setValue(mtm); 
      }
    catch(NullPointerException e){ System.out.println("WorldObject setMatrixTextMsgs error: " + e);	}
	catch(InvalidEventInException f){ System.out.println("WorldObject setMatrixTextMsgs error: " + f); }
       }
     }
    
    public void handleMessage( String tag, Field data ) throws ConsumerException {
	throw new ConsumerException("WorldObject should not receive any messages !");
    }

    public void update(){
	Enumeration list = states.elements();
	while( list.hasMoreElements()){
	    ((RealTimeConsumer)list.nextElement()).update();
	}	
    } 

   public void sharedObjectName( String target, int state ){
  if(PR!=null){
   PR.sharedObjectName( target, state );
   }
 }

 public void setStraightenUp( String st ){
 if(bAvalon){
  }
 }

 public void beamingObjectName( String target, float [] mft, int state ){
 if(PR==null){ createPrimeMover();}
if(PR!=null){  PR.beamingObjectName( target, mft, state );}
 }

  /**
   * New 11-12-05 reset method Calling VRML EventIns do turn off stuff some before
   * the delete method is called in RealTimeHandler simply seems to work better
   * when changing rooms and disconnecting.
   */


 public void reset(){
 runner = null;
 tf = false;
 if(ML!=null){ ((EventInSFBool)ML.getEventIn("set_bool")).setValue(false);}
 	Enumeration list = vSound.elements();
	while( list.hasMoreElements()){
      Node foo = (Node)list.nextElement();
	     try { 
		  ((EventInSFBool)foo.getEventIn("enabled")).setValue( false );
            }
         catch(NullPointerException h){ System.out.println("WorldObject vSound delete type error: " + h); }
    	 catch(InvalidVrmlException d){ System.out.println("WorldObject vSound delete type error: " + d); }
         catch(InvalidNodeException f){ System.out.println("WorldObject vSound delete type error: " + f); } 
         catch(InvalidEventInException g){ System.out.println("WorldObject vSound delete type error: " + g); }
         catch(Exception e){ System.out.println("WorldObject vSound delete type error: " + e); }
	     }
    vSound.removeAllElements();
 //if(proxy!=null){ ((EventInSFBool)proxy.getEventIn("enabled")).setValue(false); }
  } 

    public void delete() throws RuntimeException {
   Enumeration list = states.elements();
	while( list.hasMoreElements()){
	    postOffice.removeConsumer(((RealTimeConsumer)list.nextElement()).getName());
	}
	states.removeAllElements();
    list = gates.elements();
	while( list.hasMoreElements()){
	    ((Gate)list.nextElement()).delete();
	}
 gates.removeAllElements();
  list = anchors.elements();
	while( list.hasMoreElements()){
	    ((IAnchor)list.nextElement()).delete();
	}
 anchors.removeAllElements();
 list =  ctrlevents.elements();
	while( list.hasMoreElements()){
	   ((CtrlEvent)list.nextElement()).ctrlDelete();
	}
   list =  sounds.elements();
	while( list.hasMoreElements()){
	   ((MatrixSound)list.nextElement()).delete();
	}
   list =  timer_events.elements();
	while( list.hasMoreElements()){
	   ((TimerEvent)list.nextElement()).delete();
	}
 VPEventIns.clear();
 ctrlevents.clear();
  WSANU.delete();
  WSC.delete();
  WSLC.delete();
 yak = null;
  proxy = ML = null;
 if(WRC!=null){ WRC.delete();}
 if(NavObs!=null){ NavObs.delete();}
 if(navInfoObs!=null){ navInfoObs.delete(); }
    }

  /**
     * New 11-12-05 beamto is here because it is a member of the RealTimeConsumer interface
     * It doesn't do anything except stop an error
     */

   public void beamto( String target ){
}

   public void userView( String target ){
 }

   public boolean getbAvatar(){
  return bAvatar;
     }

   public void setUserPosition( float[] flt ){
  }

   public void checkPosition( float[] fUP, boolean bUPs  ){
 }

  public float [] getViewpointPos_Rot(){
 return fViewpointPos_Rot;
  }
  

  public void setNavigation( int num ){
 if(setNav!=null){	setNav.setValue( num );	}
 }

 public synchronized void setSpeed( float ft ){
   if(setSpeed!=null){ setSpeed.setValue( ft ); }
   }

}
