

/*
  WorldReceiveChat.java

 Copyright (C) 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */  

package matrix.deck.eai2;

import matrix.Message;
import matrix.vrml.*;
import matrix.deck.*;
import java.io.*;
import vrml.eai.*;
import vrml.eai.field.*;


/**
 * New 11-12-05 receives all chat messages from the network to display in the 
 * VRML world. Instanced by WorldObject class. 
 * WorldObject analog to AvatarTextTalk class for drone Avatar class.
 * @version 0.1    
 * @author Russ Kinter
 */

public class WorldReceiveChat implements NetworkListener {
  private Network postOffice;
  private String Mfstg [] = new String[2];
    /**
     *  New 11-12-05 EventInMFString yak is from instance of Proto WorldReceiveChat.
     */
 private EventInMFString yak;

  public  WorldReceiveChat( Network network ){ 
    postOffice = network;
   }
  
  public EventInMFString set_yakker( EventInMFString talk_talk ){
  yak = talk_talk;
  postOffice.addNetworkListener( this );
  return (yak);      
  }


  public synchronized void setYak( String from, String line) {
   Mfstg[0] = from; Mfstg[1] = line;  
   yak.setValue(Mfstg); 
 }


 public void handleMSG( String from, String line ){ 
	   setYak( from, line );
 }
  

  public void handleERROR(String str, String str1) {
  }
  
  public void handleLOGOUT() {  
  }
  
  public void handleOBJADD(String str, String str1) {
  }
  
  public void handleOBJDEL(String str) {
  }

  public void handleOBJIGN( String name, String tf ){
  }
  
  public void handleCTRLEV( String name, String [] lock ){
  }

  public void handleROOM_A( String name ) throws InterruptedException {
  }
  
  public void handleROOM_B( String name, String url ) throws InterruptedException {
  }

  public void handleNetFailure( String reason ){
 }

  public void handleWHOIS(String[] str) {
  }

  public void handleOBJIS( String[] objects ){
  }

    public void handleWWW( Message msg ){
  }
  
    public void handleNEWRM( String new_room ){
  }
  
   public void handleADMIN( int arg ){
   }

    public void handleNavChange( String [] types ){
   }

    public void handleSpeedChange( float ft ){
   }

  public void delete(){postOffice.removeNetworkListener( this );  yak = null;} 
}
