

/*
  WorldSendAv_Name_Url.java

 Copyright (C) 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */ 

package matrix.deck.eai2;

import matrix.vrml.*;
import matrix.deck.*;
import java.io.*;
import java.util.*;
import vrml.eai.*;
import vrml.eai.field.*;
import vrml.eai.event.*;
 /**
 * New 11-12-05 Allows world to get the user clients nickname and their avatar url
 * either when the VRML world is being processed by the WorldObject class
 * or later via a true boolean sent by the world.  
 * Instanced by WorldObject class. 
 * @version 0.1    
 * @author Russ Kinter
 */
public class WorldSendAv_Name_Url implements VrmlEventListener {
    /**
     *  New 11-12-05 EventOutSFBool request holds eventOut from Node wsn. This is observed for requests for nickname and av url.
     */
  private EventOutSFBool request;
    /**
     *  New 11-12-05 EventInMFString send is from Node wsn. The requested nickname and av url Strings are placed here.
     */
  private EventInMFString send;
    /**
     *  New 11-12-05 Node wsn holds instance of Proto WorldSendAv_Name_Url found in the scene graph by WorldObject.
     */
  private Node wsn;
  private String [] name_url = {"",""};
   public  WorldSendAv_Name_Url(){
 }  
 public void setWSANU(String NAME, String AVURL, Node WSN ){
  this.name_url[0] = NAME;
  this.name_url[1] = AVURL;
  wsn = WSN;  
  send = (EventInMFString)wsn.getEventIn("set_Av_Name_Url");  
  request = (EventOutSFBool)wsn.getEventOut("name_url_request");
  request.addVrmlEventListener(this);
}

 public void eventOutChanged(VrmlEvent vrmlevent ){
	  BaseField bf = vrmlevent.getSource();
    try {
	    if( bf.getType()!= BaseField.SFBool ) {
		System.err.println("Got wrong value from ");
		return;
	    }
    
  if(request.getValue()==true){
     System.out.println("WSAv_Name_Url called");
     this.sendName_Url();}
}
	catch(Exception e) {
	    System.err.println("Error converting boolean from world"+"\n\t" +e);
	}

    }

   public void sendName_Url(){ 
 try {
 send.setValue(name_url);
  }
catch(InvalidEventInException e){ System.out.println("set_Av_Name_Url invalid: "+ e);}
}

  public void delete(){ 
  if(request!=null){request.removeVrmlEventListener(this);}
  request = null; wsn = null; send = null; } 

}
