 /*
  MatrixD.java
 
  Copyright (C) 1999 Geometrek	and 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.server;

import matrix.vrml.SFInt32;
import matrix.*;
import java.io.*;
import java.net.*;
import java.util.*;

/**
 * This class is the server program for the Matrix multi-user VRML system. It reserves a port for
 * TCP connections. No UDP in this version !!!
 *<pre>
 *synopsis  : java matrix.server.MatrixD [-port number] [-loglevel level] [-rcfile filename]
 *</pre>
 * Portnumber is the number the TCP port should be bound to.The default number used is 6666.
 * Level is an integer number between 0 and 3 giving the level of logdata written to standard out.
 * Filename is the name of an alternative configuration file. If no filename is given MatrixD tries to read
 * the file <tt>matrixrc</tt>
 *
 * @version 1.1
 */
public final class MatrixD extends Thread {
    
    public final static String version = "DeepMatrixIP9 v 1.04";
    
    public final static int PORT = 6666;
    private int logLevel = 0, conQueue = 30;  
    protected int passLevel = 1;
    private boolean levelread = false, portread = false, running = true, bUsers = false, bBooted = false, bAuxRooms = false;
    String startRoom = null, rcfile = "matrixrc", rcbooted = "bootedrc", rcusers = "usersrc", rcauxrooms = "aux_roomsrc",  logfile="matrix.log", serverip = null, sAbsolutePath = "", userPassword = "none", adminPassword = "none", sBotPassWord = null, sAdminBotPassWord = null, sIPExempt = "Harry";
    private int newID = 1, iIP = 3,  iLastID = 0;
    public  int	iSTO = 30000;
	private File bootFile;
    private File userFile;
    private File aux_roomFile;
	private PrintWriter Bwriter = null;
	private PrintWriter Uwriter = null;
    private PrintWriter ARwriter = null;
    private boolean bBusy = false;
    private Log log;
    protected boolean bWrite = true;
    protected int adminID = -1;
    protected int port=PORT;
    protected Vector vOrgRooms, vAuxRooms, vRemovedRooms;
    protected ServerSocket Listener;
    protected Hashtable Threads, Rooms, Objects, Users, Booted, Booted2, Transition, IPCount;

    public AdminHelper AH;


    public class AdminHelper implements Runnable {
        private Vector buffer;
        private Thread runner;
        private boolean bAdminKill = false;
		private boolean bNewUser = false;
        private boolean bNewBan = false;
        private boolean bNewObj = false;
        private boolean bNewRoom = false;
        private boolean bRemRoom = false; 
        protected String objUrl = null;
        protected String objName = null;
        
            AdminHelper(){
            buffer = new Vector(10,10);
            start();
        }
        
        public void run(){
		   Enumeration threads;
           String st2;
			ServerThread help = null;
            ControlMessage cm;
            AdminControl ac;
            while( Thread.currentThread() == runner ){
                try{
             synchronized( buffer ){
			  if(!buffer.isEmpty()){
        	  String foo = null;
		      String foo2 = null;
			cm = new ControlMessage();
			cm.name = "MatrixD";
            ac = (AdminControl) buffer.firstElement();
          switch( ac.command ) { 
           case AdminControl.HELLO :
            try {
            adminID = Integer.parseInt( ac.arg );
            }
			catch(NumberFormatException f ){ log( "AdminHelper clientID to AdminID failure: " + f,1 );
            }
			postTo2Admin(adminID, new AdminControl( AdminControl.HELLO, "", "" ) );
            log("Admin login",1);
            break;
           case AdminControl.DONE :
         if(adminID!=-1){
           int aID = adminID; 
         if(bNewUser){log(" Admin writes users ",1); writeUsers(); bNewUser = false;}
         if(bNewBan){log(" Admin writes booted ",1); writeBooted(); bNewBan = false;}
         if(bNewRoom){log(" Admin writes rooms ",1); writeRooms(); setbNewRoom( false );}
		  if(!ac.arg.equals("finis")){ 
            postTo2Admin(aID, new AdminControl( AdminControl.DONE, "", "" ) );	
            }
		   adminID = -1;
           }
		 log("Admin log out",1);
            break;
           case AdminControl.NEWOBJ :
		     String [] sFoo = new String [3];
  int iCt = -1;
  int iC = 0;
  String st7 = ac.arg;
  boolean bTf = true;
  for( int i = 0; i<st7.length(); i +=1 ){
  if(st7.charAt(i)==(',')){
   iCt += 1;
  sFoo[iCt] = st7.substring(iC,i);
  iC = i+1;
  if(iCt==1){ 
  sFoo[2] = st7.substring(i+1);
  break;
     }
    }
   }
 if(sFoo[0]!=null){
  if(sFoo[0].length()==0){
 cm.command =  ControlMessage.ERROR;
 cm.arg = "Admin: Add-New-Object has failed! The first entry of object's name is incomplete!";
  bTf = false;
 }
 else {
 
 }
   }
 else { cm.command =  ControlMessage.ERROR;
 cm.arg = "Admin: Add-New-Object has failed! The first entry of object's name is null!";
  bTf = false;

  }
 //if(sFoo[1]!=null){
// if(sFoo[1].length()==0||sFoo[1].indexOf("http://")!=0){
// cm.command =  ControlMessage.ERROR;
// cm.arg = "Admin: Add-New-Object has failed! The second entry of object's url must start with 'http://'!";
//  bTf = false;
 //   }
//  }
//  else { 
// cm.command =  ControlMessage.ERROR;
// cm.arg = "Admin: Add-New-Object has failed! The second entry of object's url is null!";
//  bTf = false;
//  }
  if(sFoo[2]!=null){
 if(sFoo[2].length()==0){
 cm.command =  ControlMessage.ERROR;
 cm.arg = "Admin: Add-New-Object has failed! The third entry of object's room location is incomplete!";
  bTf = false;
  }
 else {
     if(!Rooms.containsKey(sFoo[2])){
     cm.command = ControlMessage.ERROR;
	 cm.arg = "Admin: The "+sFoo[2]+" room name does not exist!";
	 }
   else {
     RoomManager rmg = (RoomManager)Rooms.get(sFoo[2]);
     if(!rmg.objectInfoNameExists( sFoo[0] )){
    objName = sFoo[0];
    objUrl = sFoo[1];
	ObjectEnvelope OE = new ObjectEnvelope( sFoo[0], sFoo[0], new SFInt32( 2 ),new SFInt32( 2 ) );
    rmg.setObjectEnvelope( OE );
    cm.command =  ControlMessage.MSG;
    cm.arg = "Admin: Object " + objName + " at " + objUrl + " has been added to room " + sFoo[2];
    bTf = true;
       }
     }
    }
  }
 else { 
 cm.command =  ControlMessage.ERROR;
 cm.arg = ( "Admin: Add-Object has failed! The third entry of object's room location is null!" );
  bTf = false;
  }
	       postTo2Admin(adminID, cm );
		   break; 
           case AdminControl.REMOBJ :
  if(ac.name.length()==0){
 cm.command =  ControlMessage.ERROR;
 cm.arg = "Admin: Remove-Object has failed! The object's name is incomplete!";
  bTf = false;
  }
 else {
  if(ac.arg.length()==0){
   cm.command =  ControlMessage.ERROR;
 cm.arg = "Admin: Remove-Object has failed! The room name containing the is incomplete!";
  bTf = false;
  }
 else {
	if(!Rooms.containsKey(ac.arg)){
     cm.command = ControlMessage.ERROR;
	 cm.arg = "Admin: The "+ac.arg+" room name does not exist!";
	bTf = false;
	 }
	else {
 RoomManager rmg = (RoomManager)Rooms.get(ac.arg);
	if(!rmg.objectInfoNameExists( ac.name )){
       cm.command =  ControlMessage.ERROR;
   cm.arg = "Admin: Remove-Object has failed! The object " + ac.name + " doesn't exist in " + ac.arg + "!";
  bTf = false;
      }
	else {
	  ObjectEnvelope OE = new ObjectEnvelope( ac.name, ac.name, new SFInt32( 3 ),new SFInt32( 3 ) );
    rmg.setObjectEnvelope( OE );
    cm.command =  ControlMessage.MSG;
    cm.arg = "Admin: Object " + ac.name + " has been removed from room " + ac.arg;
    bTf = true;
         }
	    }
       }
      }
      postTo2Admin(adminID, cm );
           break;
           case AdminControl.NEWUSR :
           if(Users.containsKey(ac.name)){
		   cm.command =ControlMessage.ERROR;
           cm.arg = "Admin: " + ac.name + " already exists as a user!" ;
            }
           else {
		  String sPl = "";
          if(passLevel==3){
		  sPl = ac.arg;
          }
          if(passLevel==2){
          sPl = userPassword;
          }
           cm.command = ControlMessage.MSG;
           cm.arg = "Admin: " + ac.name + " with password " + sPl + " has been added!";
           if(Booted2.containsKey(ac.name)){
		   String sAddy = (String)Booted2.get( ac.name );
           if(Booted.containsKey(sAddy)){
             Booted.remove(sAddy);
           }
          bNewBan = true;
		  postTo2Admin(adminID, new ControlMessage( ControlMessage.MSG,"MatrixD","Admin: " + ac.name + " had been un-banned!" ) );
		  Booted2.remove(ac.name);
		    }
          else {
		  postTo2Admin(adminID, new ControlMessage( ControlMessage.MSG,"MatrixD","Admin: " + ac.name + " had not been banned!" ) );
          }
          bNewUser = true;
     
		  Users.put( ac.name, sPl );
           }
	       postTo2Admin(adminID, cm );
           break;
		   case AdminControl.BANUSR :
      //   if(!Booted2.containsKey( ac.arg )){
           boolean bRU = true;
		 		 if(1<passLevel){
           if(Users.containsKey( ac.arg )){ 
		 cm.command = ControlMessage.MSG;
         cm.arg = "Admin: user " + ac.arg + " has been removed from the users list!";
         bNewUser = true;
		 bNewBan = true;
		 Users.remove( ac.arg );
               }
         else {
           bRU = false;
		 cm.command = ControlMessage.ERROR;
         cm.arg = "Admin: user " + ac.arg + " doesn't exist in users list!";
          }
             }
        if(bRU){
		  threads = Threads.elements();
		while(threads.hasMoreElements()) {
			help = (ServerThread) threads.nextElement();
			if(help!=null&&help.name.equals( ac.arg )) {
	           try {
					help.sendMessage2( new ControlMessage( ControlMessage.LOGOUT, "", "" ) );
				}
				catch( InterruptedException f ){ }
				catch(IOException e){ log(" AdminHelper: " + help.name + " " + e,1);}
         ControlMessage cm4 = new ControlMessage( ControlMessage.MSG,"MatrixD","Admin: current user " + help.name + " has been booted from server!" );
		 postTo2Admin(adminID, cm4 );
		 bNewBan = true;
		  	Booted.put( help.connection.getInetAddress().getHostName(), help.name  );
            Booted2.put( help.name, help.connection.getInetAddress().getHostName() ); 
		      }
             }
			}
    //       }
	//	 else {
    //	cm = new ControlMessage( ControlMessage.ERROR,"MatrixD","Admin: " + ac.arg + " has already been banned!" );
    //     }
		   postTo2Admin(adminID, cm);
           break;
		   case AdminControl.BANADD :
           int iS = Booted.size()+1;
           String sBan = ("Banned" + iS);
		   Booted.put(ac.arg,sBan);
		     cm.command = ControlMessage.MSG;
	        cm.arg = "Admin: The "+ac.arg+" has been added to banned list!";
	         postTo2Admin(adminID, cm );
           break;
		   case AdminControl.APRVRM :
   if(!Rooms.containsKey(ac.arg)){
     cm.command = ControlMessage.ERROR;
	 cm.arg = "Admin: The "+ac.arg+" room name does not exist!";
	 postTo2Admin(adminID, cm );
	 }
   else {
     RoomManager rmg = (RoomManager)Rooms.get(ac.arg);
     rmg.setApproval( true );
      cm.command = ControlMessage.MSG;
	  cm.arg = "Admin: " + ac.arg + " approval has been set to true!";
     vAuxRooms.addElement(ac.arg);
     File mkDir = new File(sAbsolutePath + ac.arg);
     mkDir.mkdir();
	 postTo2Admin(adminID, cm );
    setbNewRoom( true );
    }
           break;
		   case AdminControl.REMBAN : 
           boolean bRM = true; 
		  if(Rooms.containsKey( ac.arg )){ 
           RoomManager rmg = (RoomManager)Rooms.get( ac.arg );
		   Booted.put( rmg.ownerAddress, rmg.owner ); 
           Booted2.put( rmg.owner, rmg.ownerAddress );
           bNewBan = true;
		   if(1<passLevel){
           if(Users.containsKey( rmg.owner )){
		 cm.command = ControlMessage.MSG;
         cm.arg = "Admin: Room owner " + rmg.owner + " has been removed from the users list!";
		    bNewUser = true;
           Users.remove( rmg.owner ); 
    		 }
		    else {
           bRM = false;
		 cm.command = ControlMessage.ERROR;
         cm.arg = "Admin: user " + rmg.owner + " doesn't exist in users list!";
             }
            }
        if(bRM){
		  threads = Threads.elements();
		while(threads.hasMoreElements()) {
			help = (ServerThread) threads.nextElement();
			if(help!=null&&help.name.equals( rmg.owner )) { 
			   try {
					help.sendMessage2( new ControlMessage( ControlMessage.LOGOUT, "", "" ) );
				}
				catch( InterruptedException f ){ }
				catch(IOException e){ log(" AdminHelper: " + help.name + " " + e,1);}
		 		 postTo2Admin(adminID, new ControlMessage( ControlMessage.MSG,"MatrixD","Admin: Room owner " + help.name + " has been booted from server!" ) );
		      }
             }
			}
           addNewRoom(adminPassword,ac.arg+"#p","remove", "");
    	   }
           else {
		   cm.command = ControlMessage.ERROR;
           cm.arg = "Admin: room " + ac.arg + " doesn't exist!";
		   postTo2Admin(adminID, cm );
            }
           break;
           case AdminControl.REMRM :
		   if(!Rooms.containsKey(ac.arg)){
          cm.command = ControlMessage.ERROR;
	      cm.arg = "Admin: The "+ac.arg+" room name does not exist. Server cannot remove it!";
	      postTo2Admin(adminID, cm );
	     }
         else {
		   addNewRoom(adminPassword,ac.arg+"#p","remove", "");
          }
           break;
		     case AdminControl.CLREVN :
		   if(!Rooms.containsKey(ac.arg)){
          cm.command = ControlMessage.ERROR;
	      cm.arg = "Admin: The "+ac.arg+" room name does not exist. Server cannot remove its events! ";
	      postTo2Admin(adminID, cm );
	     }
         else {
		RoomManager rmg  = (RoomManager)Rooms.get(ac.arg);
        int iZ = rmg.getEventsSize();
        rmg.clearEvents( new RealTimeMessage( RealTimeMessage.CLR, "foo", new SFInt32( 1 ), false ) );
        cm.command = ControlMessage.MSG;
	    cm.arg = ac.arg + " cleared of " + iZ + " total events.";
	      postTo2Admin(adminID, cm );
          }
           break;
		   case AdminControl.REJCT :
           break;
		default :
		 log(" AdminHelper: unknown message typez; " + ac.toString(),1 );
           break;
         }
	   buffer.removeElementAt(0); 
       buffer.wait(600000);               
            }
          else {
		 writeToFile();
          if(!bAdminKill){
		   if(bNewRoom){ writeRooms(); setbNewRoom( false );}
    	 threads = Transition.keys();
        while( threads.hasMoreElements()){
          String sKey = (String)threads.nextElement();
         ServerThread ST = (ServerThread)Transition.get(sKey);
         if(ST.iTransCt==0){  ST.iTransCt = 1; }
          else {
            String sHN = ST.hostName;
        	Transition.remove(sKey);
            setIPCount( sHN );
              }
  ;          }
			//log( "Admin transit",1);
            buffer.wait(600000); 
                 }
           else {
		 if(bNewUser){ writeUsers(); bNewUser = false;}
         if(bNewBan){ writeBooted(); bNewBan = false;}
         if(bNewRoom){ writeRooms(); setbNewRoom( false );}
		 runner = null;
                 }
               }
              }
             }
                catch(InterruptedException e){
                       }
                catch(NullPointerException f){
				   	 buffer.removeElementAt(0); 
                	 log( f.toString(),1);
                   }
                catch(Exception g){	
					 buffer.removeElementAt(0); 
                	 log( g.toString(),1);
                }
            }
        }
         
      
        
        public void put( AdminControl ac ){
            synchronized( buffer ){
                buffer.addElement( ac );
                buffer.notify();
            }
        }
    
    public synchronized void setbNewRoom( boolean tf ){
    bNewRoom = tf;
    }
        
        public void start(){  
  if(runner==null){   
  runner = new Thread( this, ("AdminHelper") ); 
   runner.start(); 
      }	
      }

        public void stop() {
             bAdminKill = true; 
            synchronized( buffer ){
            buffer.removeAllElements();
               buffer.notify(); 
            }
          }

        }
    
    public MatrixD( String rcfile, int port, int loglevel ) {
        super("Matrix");
        
        this.rcfile = rcfile;
        if( port != -1 ){
            this.port = port;
            portread = true;
        }            
        if( loglevel != -1 ){
            this.logLevel = loglevel;
            levelread = true;
        }
        vOrgRooms = new Vector();
		vAuxRooms = new Vector();
    	vRemovedRooms = new Vector();
        Rooms = new Hashtable();
        Threads = new Hashtable();
        Transition = new Hashtable();
        Objects = new Hashtable();
        Users = new Hashtable();
        Booted = new Hashtable();
        Booted2 = new Hashtable();
        IPCount = new Hashtable();
		AH = new AdminHelper();
    Runtime rt = Runtime.getRuntime();
    System.err.println("Main: adding shutdown hook");
    rt.addShutdownHook(new Thread() {
      public void run() {
    System.err.println("Running my shutdown hook");
      ShutDownHook SDH = new ShutDownHook( Rooms );
      }
    });
        loadInit(rcfile); 
        loadFile((sAbsolutePath + rcbooted),"booted");
	  if(1<passLevel){
		if(passLevel==3){ userPassword = "someone"; }
        loadFile((sAbsolutePath + rcusers),"user");
      }
        loadFile((sAbsolutePath + rcauxrooms),"room");
        System.out.println("Done with loadInit(rcfile) ");      
        try {
            if( serverip == null )
                Listener = new ServerSocket( this.port, conQueue );
            else
                Listener = new ServerSocket( this.port, conQueue, InetAddress.getByName( serverip ));
        }
        catch( IOException e ) { 
            fail( e, "Could not open socket"); 
        }
        
		 System.out.println("MatrixD listening on "+Listener.getInetAddress()+":"+ this.port );
        log("MatrixD listening on "+Listener.getInetAddress()+":"+ this.port,1);
        this.start();
    }
    
    public void run() {
        try {
            Listener.setSoTimeout( 1000 );
        }
        catch(SocketException e){}
        while( running == true ) {
            try {
                Socket con = Listener.accept();
                con.setTcpNoDelay( true );
                con.setSoTimeout( iSTO );
                ServerThread th = new ServerThread(this, startRoom , new TCPConnection( con, 10000 ));
            }
           catch( InterruptedException f ) {}
            catch( InterruptedIOException e ) {}
            catch ( IOException e ) {
                log("Error while listening :"+e,1);
            }
        }
    }
   

    public static void main( String[] args ) {
        int i = 0;
        int port = -1;
        int loglevel = -1;
        String rcfile = "matrixrc";
        String arg;
        System.out.println(version+" starting up ...");
        while( i < args.length && args[i].startsWith("-")) {
            arg = args[i++];
            if(arg.equals("-port")) {
                if( i < args.length ) {
                    try { 
                        port = Integer.parseInt( args[i++] ); 
                    }
                    catch( NumberFormatException e){
                        System.err.println("error converting port number "+e);
                        port = -1;
                    }
                }
                else usage();
            }
            else if(arg.equals("-loglevel")) {
                if( i < args.length ) {
                    try { 
                        loglevel = Integer.parseInt( args[i++] );
                        if( loglevel < 0 && loglevel > 3 ) usage();                  
                    }
                    catch( NumberFormatException e){
                        System.err.println("error converting loglevel "+e);
                        loglevel = -1;
                    }
                }
                else usage();
            }
            else if(arg.equals("-rcfile")) {
                if( i < args.length )
                    rcfile = args[i++];
                else usage();
            }
        }
      new MatrixD( rcfile, port, loglevel ); 
    }
    
    public int Check( ServerThread newST, String name, String passwd, String addy ) {
    System.out.println("Login Check name: " + name + " passwd: " + passwd);
        Enumeration th;
        if(Booted2.containsKey( name )){
		  Transition.remove(name+addy);
           return 4;
           }
        if(!addy.equals("localhost")&&Booted.containsKey( addy )){
		   Transition.remove(name+addy);
           return 4;
          }
	 if(Transition.containsKey(name+addy)){
	   ServerThread st = (ServerThread)Transition.get(name+addy);
       newST.bTrans = false;
       newST.objects2 = st.objects2;
       Transition.remove(name+addy);
           return 1; 
          }
        if(passLevel==2){
		if(!Users.containsKey( name )){
            return 2;
          }
        else {
        if(passwd.equals(userPassword)||passwd.equals(sBotPassWord)||passwd.equals(sAdminBotPassWord)){
            return 1;
               }
           else {
            return 3;
             }
           }
		 }
        if(passLevel==3){
		   if(!Users.containsKey( name )){
            return 2;
             }
           else {
          String st = (String)Users.get( name );
		 if(passwd.equals(userPassword)||passwd.equals(sBotPassWord)||passwd.equals(sAdminBotPassWord)){
            return 1;
               }
           else {
            return 3;
             }
          }
        }
        th = Threads.elements();
        while(th.hasMoreElements()){
            if(((ServerThread)th.nextElement()).getName().equals( name ))
                return 5;
        }
	  if(!name.equals(sIPExempt)&&!addy.equals("localhost")&&!addy.equals(serverip)){
      if(IPCount.containsKey(addy)){   
      if( iIP < ((Integer)IPCount.get(addy)).intValue() ){
          return 6;
         }
       else {
        Integer I = (Integer)IPCount.get(addy);
        IPCount.remove(addy);
        IPCount.put(addy, new Integer( I.intValue()+1 ) );
		return 1;
         }
       }
        else {
    	IPCount.put(addy, new Integer( 1 ) );
		System.out.println("MatrixD new IPCount addy");
		 return 1;
         }
       }
      else {
      String sEx = "ServerIP or localhost or Exempt name login";
      System.out.println( sEx );
      log( sEx, 1);
        }
        return 1; 
    }
   
       public boolean Check2( String name ) {
        Enumeration th = Threads.elements();
        while(th.hasMoreElements()){
            if(((ServerThread)th.nextElement()).getName().equals( name ))
                return false;
        }
        return true;
    }

    public String getAdminPassword(){
    return adminPassword;
    }

    public boolean botPassWord( String pw ){
    boolean tf = false;
    if(sBotPassWord!=null){
    if( sBotPassWord.equals(pw)){ tf = true; }}
    return tf;
    }

	 public boolean adminBotPassWord( String pw ){
    boolean tf = false;
    if(sAdminBotPassWord!=null){
    if( sAdminBotPassWord.equals(pw)){ tf = true; }}
    return tf;
    }
 
    public void adminAction( AdminControl ac ){
      if(!bBusy){  AH.put( ac );	}
    else {
  ControlMessage cm = new ControlMessage( ControlMessage.MSG, "MatrixD", "Admin: server is busy writing updates! Try again later!");
	       postTo2Admin(adminID, cm);
     }
    }
    
    public synchronized int addThread( ServerThread th, boolean bOK ){
        Integer id = new Integer( newID );
        newID = newID + 1;
        while( Threads.containsKey(id)){ id = new Integer(newID++);	}
       if(bOK){ Threads.put( id, th ); }
        return id.intValue();
    }

	public synchronized void setIPCount( String sHN ){
	 if(IPCount.containsKey(sHN)){
      Integer I = (Integer)IPCount.get(sHN);
        if(I!=null){
          if(I.intValue()==1){
           IPCount.remove(sHN);
           }
        else {
		   IPCount.remove(sHN);
    	   IPCount.put( sHN, new Integer( I.intValue()-1 ) );
          }
         }
        }
      }
    
    public void loadInit(String file) {
        File fl = new File(file);
    	String st = fl.getAbsolutePath();
		int idx = st.indexOf("matrixrc");
    	sAbsolutePath = st.substring(0,idx);
        BufferedReader fin = null;
        String line, roomName, roomURL, keyword, lower;
        int index = 1, maxNumber;
        boolean multible;
        
        try {
            fin = new BufferedReader(new FileReader(file));
            line = fin.readLine();
            while(line != null ) {
                if( line.length() > 0 ) {
                    StringTokenizer token = new StringTokenizer(line," ");
                    keyword = token.nextToken();
                    if(keyword.charAt(0) != '#') {                          // No Comment !
                        lower = keyword.toLowerCase();
                        if(lower.equals("loglevel") && levelread == false) {  // loglevel
                            logLevel = Integer.parseInt( token.nextToken());
                        }
                        else if(lower.equals("port") && portread == false) {  // portnumber
                            port = Integer.parseInt( token.nextToken());
                        }
                        else if(lower.equals("logfile")) {                    // logfile
                            logfile = token.nextToken();
							log = new Log(logfile);
                        } 
                        else if(lower.equals("passlevel")) {                    // password security level
                           passLevel = Integer.parseInt( token.nextToken());
                        } 
                        else 
                        if(lower.equals("userpass")) {                    // user password for second password level
                            userPassword = token.nextToken();
                        } 
             			else if(lower.equals("adminpass")) {                    // admin password
                            adminPassword = token.nextToken();
                        } 
                        else if(lower.equals("serverip")) {                   // serverip
                            serverip = token.nextToken();
                        }
                        else if(lower.equals("bot_pw")){
    					sBotPassWord = token.nextToken();
                         }
						else if(lower.equals("admin_bot_pw")){
    					sAdminBotPassWord = token.nextToken();
                         }
                        else if(lower.equals("per_ip")){
                        iIP = Integer.parseInt( token.nextToken() );
                        }
                        else if(lower.equals("exempt_ip")){
						  sIPExempt = token.nextToken();
                        System.out.println( "IP Exempt name is: " + sIPExempt );
                         }
						 else if(lower.equals("socket_time_out")){
                        iSTO = Integer.parseInt( token.nextToken() );
                        }
                        else if(lower.equals("waitingconnections")){          // maximum connections in waiting queue
                            conQueue = Integer.parseInt( token.nextToken() );
                        }
                        else {                                                // a room definition
                            try {
                                roomName = keyword;
                                roomURL = token.nextToken();
                                maxNumber = 0;
                                if( token.hasMoreTokens()) {
                                    try{
                                        maxNumber = Integer.parseInt( token.nextToken());
                                    }
                                    catch(NumberFormatException e){
                                        System.err.println("Error parsing "+file+" : "+line+"\n\t"+e);
                                        maxNumber = 0;
                                    }
                                }
                                multible = false;
                                if( maxNumber > 0 && token.hasMoreTokens()) {
                                    multible = Boolean.valueOf( token.nextToken()).booleanValue();
                                }
                                if( Rooms.containsKey(roomName))
                                    System.err.println(roomName+" is allready defined!");
                                else {
								   roomName = roomName.replace('_',' ');
								   System.out.println("MatrixD matrixrc file read out: " + "roomName: "  + roomName + " roomURL: " + roomURL);
                                    Rooms.put( roomName, new RoomManager( this, roomName, roomURL, maxNumber, true ));
									vOrgRooms.addElement( roomName );
                                try {
                                Thread.sleep(100);
                                 }
                                catch(InterruptedException e){}
                                    if( startRoom == null )
                                        startRoom = roomName;
                                }
                            }
                            catch(NoSuchElementException e) {
                                System.err.println("Error parsing "+file +" : "+line+"\n\t"+e);
                            }
                        }
                    }
                }
                line = fin.readLine();
                index++;
            }
        }
        catch(Exception e) { 
            fail(e,"Error reading "+file+" in line "+index); 
        }
        finally { 
            try{ 
                if(fin != null) 
                    fin.close(); 
            } 
            catch(Throwable e) {}
        }
    }
   
    public void loadFile2( File instrc, String file, String kw ){
	//System.out.println( " loadFile2 file: " + file + " kw: " + kw );
      String foo1, foo2, foo3, foo4, foo5, keyword, line;
	    BufferedReader fin = null;
		FileOutputStream fos = null;
		int index = 1;
	    try {
            fin = new BufferedReader(new FileReader(file));
            line = fin.readLine();
            while(line != null ) {
                if( line.length() > 0 ) {
                    StringTokenizer token = new StringTokenizer(line," ");
                    keyword = token.nextToken();
                    if(keyword.charAt(0) != '#') {  
                      if(keyword.equals(kw)) {  
                            try {
							foo1 = token.nextToken();
                       if(kw.equals("user")&&passLevel==3&&!userPassword.equals("none")){
							foo2 = token.nextToken();
							Users.put(foo1,foo2);
                          }
                       if(kw.equals("user")&&passLevel==2&&userPassword.equals("none")){
    						Users.put(foo1,userPassword);
                           }
					  if(keyword.equals("booted")) {
						   foo2 = token.nextToken();
							Booted.put(foo1,foo2);
                            Booted2.put(foo2,foo1);
                           }
                      if(keyword.equals("room")){
                         foo1 = foo1.replace('_',' ');
					  if( Rooms.containsKey(foo1))
                                    System.err.println(" " + foo1+ " is allready defined!");
                                else {
								   foo2 = token.nextToken();
                                   foo3 = token.nextToken();
                                   foo4 = token.nextToken();
                                   foo5 = token.nextToken();
                                   foo5 = foo5.trim();
								   System.out.println("MatrixD aux_roomsrc file read out: " + "roomName: "  + foo1 + " roomURL: " + foo2 + " owner:" + foo3 + " owner's IP: " + foo4 );
                                    Rooms.put( foo1, new RoomManager( this, foo1, foo2, foo3, foo4, foo5, 1, true ) );
									vAuxRooms.addElement( foo1 );
                                        }
                                try {
                                Thread.sleep(1000);
                                 }
                                catch(InterruptedException e){}
                               }
                              }
                       catch(NoSuchElementException e) {
                                System.err.println("Error parsing "+file +" : "+line+"\n\t"+e);
                              }
                       catch(NullPointerException npe){
							 System.err.println("NullPointerException: "+file +" : "+line+"\n\t"+npe);
                           }      
                             }
                           }
                          } 
				line = fin.readLine();
                index++;
              }
            }
        catch(Exception e) { 
            fail(e,"Error reading "+file+" in line "+index); 
        }
        finally { 
            try{ 
                if(fin != null) 
                    fin.close(); 
            } 
            catch(Throwable e) {}
        }
    }

    public void loadFile(String file, String kw ) {
		//String st = sAbsolutePath + File.separatorChar + file,  keyword;
        if(kw.equals("booted")){
		bootFile = new File(file);
        try {
        bBooted = bootFile.createNewFile();
        }
       catch( FileNotFoundException f ){ System.err.println(" bootedrc file: " + f); }
       catch( IOException e ){ System.err.println( " bootedrc file: " + e ); }
        if(!bBooted){
    loadFile2( bootFile, file, kw );
       }
      }

     if(kw.equals("user")){
       System.out.println( "loadFile user file: " + file );
		userFile = new File(file);
        try {
		bUsers = userFile.createNewFile();
        }
	   catch( FileNotFoundException f ){ System.err.println( "usersrc file: " + f ); }
       catch( IOException e ){ System.err.println( "usersrc file: " + e );}
	  //System.out.println( " loadFile bUsers: " + bUsers );
      if(!bUsers){
	  loadFile2( userFile, file, kw );
		  }
        }
     if(kw.equals("room")){
	    System.out.println( "loadFile aux room file: " + file );
		aux_roomFile = new File(file);
        try {
		bAuxRooms = aux_roomFile.createNewFile();
        }
	   catch( FileNotFoundException f ){ System.err.println( "aux_roomsrc file: " + f ); }
       catch( IOException e ){ System.err.println( "aux_roomsrc file: " + e );}
      if(!bAuxRooms){
	  loadFile2( aux_roomFile, file, kw );
		  }
      }
       }

    public void closeAdminHelper(){
    if(AH!=null){ AH.stop(); }
    }

	public synchronized void writeToFile(){ 
		     bBusy = true;
		   Enumeration rooms = Rooms.elements();
        while( rooms.hasMoreElements()){
   RoomManager rm = (RoomManager)rooms.nextElement();
   if(rm.bRFM2){
	 rm.printUpdate( new TriggerEnvelope() );
    }
   }
    bBusy = false;
       }
    
      public void closeWrite(){
	if(AH!=null){ AH.stop(); }
	writeToFile();
	} 

	    public Room enterRoom( ServerThread thread, String roomName ) throws Exception {
        // check for any trailing viewpoint indices at the and of the name
        // something like name#2, we only need the name.
        // see matrix.deck.Beta for the use of this index.
        if( roomName.lastIndexOf('#') != -1 ){
            roomName = roomName.substring(0, roomName.lastIndexOf('#'));
        }
	   //System.out.println("Daemon enterRoom1 + roomName: " + roomName);
        RoomManager help = (RoomManager) Rooms.get( roomName );
        if( help == null )
            throw new Exception("No room of name "+roomName+" known !");
        Room ret = help.addUser( thread );
        if( ret == null )
            throw new Exception("Maximum number of users for room "+roomName+" reached !");
		if(!ret.bPublic){
        if((adminID!=thread.clientID)&&!ret.owner.equals(thread.name)&&!ret.Members.contains(thread.name) ){
            throw new Exception(thread.name + " is not a member of private " + roomName + "!");
             }
            }
        return ret;
    }

	public void userTransition( Integer clientID ){
    ServerThread help = (ServerThread)Threads.get( clientID );
    String sID = help.getName()+help.hostName;
    // System.out.println("MatrixD userTransition: " + sID );
    Transition.put(sID,help);
    }
    
    public void leaveRoom( ServerThread thread, Room room ) throws Exception {
        RoomManager help = (RoomManager) Rooms.get( room.getName());
        if( help == null )
            throw new Exception("No room of name "+room.getName()+" known !");
        help.removeUser( thread, room );
    }
    
    public static void fail( Throwable e,String msg ) {
        System.err.println("MatrixD "+msg+":"+e);
        System.exit(1);
    }
    
    public void log( String msg, int level ) {
        if ( level <= logLevel ) {
        log.println( msg );
        }
    }

 public synchronized void addNewRoom( String creator, String roomname, String roomurl, String addy ){
  String sRoompass = null;
  String sRoomname2 = null;
  Message msg = null;
 String [] st = new String [1];
 ControlMessage cm = new ControlMessage();
   cm.name = "MatrixD";
  StringTokenizer token = new StringTokenizer(roomname,"#");
 while(token.hasMoreTokens()){ 
 sRoompass = token.nextToken(); }
 sRoomname2 = roomname.substring(0, roomname.indexOf("#") );
  log("MatrixD addNewRoom sRoomname2: " + sRoomname2 + " sRoompass: " + sRoompass,1); 
if(sRoompass!=null){
   if(!Rooms.containsKey(sRoomname2)){
    if(roomurl.equals("remove")){
      cm.command = ControlMessage.ERROR;
	 if(!creator.equals(adminPassword)){cm.arg = "Your "+ sRoomname2 +" does not yet exist!";	 postTo2(creator, cm);	}
 else { cm.arg = "Admin "+ sRoomname2 +" does not yet exist!"; postTo2Admin(adminID,cm); }
	 }
    else {
   st[0] = "(0)";
   if(vRemovedRooms.contains(sRoomname2)){ vRemovedRooms.remove(sRoomname2); }
   Rooms.put( sRoomname2, new RoomManager( this, sRoomname2, roomurl, creator, addy, sRoompass, 0, false ));
   log(" Adding new room " + sRoomname2 + " at " + roomurl + " for " + creator + " of " + addy + " ",1);
   try {
 msg = new WhoWhatWhere( WhoWhatWhere.WHRUPD, sRoomname2, st );
   }
  catch(IOException e){ msg = null;
  log(" MatrixD addNewRoom WHRUPD sRoomname2 or st is null: " + e,1); 
  return;
  }
if(msg!=null){   postToAllUsers2(	msg );	}
	 cm.command = ControlMessage.MSG;
	 cm.arg = "Your " + sRoomname2 + " has been added to the list!";
	 postTo2(creator, cm);
	 cm.command = ControlMessage.NEWROOM;
	 cm.arg = sRoomname2;
     postTo2(creator, cm);
    }
   }
 else {
 if(roomurl.equals("remove")){
 RoomManager rmg = (RoomManager)Rooms.get( sRoomname2 );
 boolean bRmRmv = false;
 String sCmarg = null;
 if(!creator.equals(adminPassword)){
 if(!rmg.sRoompass.equals(sRoompass)){ 
	cm.command = ControlMessage.ERROR;
	 cm.arg = "World "+ sRoomname2 + " can only be removed with a correct password or by admin!";
	log(" Removal of room failure: " + sRoomname2 + " by " + creator + " at " + addy + " " + " using password: |" + sRoompass + "| room password is: |" + rmg.sRoompass + "| " ,1);
	}
  else {
 cm.command = ControlMessage.MSG;
 cm.arg = "Your " + sRoomname2 + " has been removed from the room list!";
 bRmRmv = true;
   }
  postTo2(creator, cm);
  }
 else {
  vRemovedRooms.addElement(sRoomname2);
     cm.command = ControlMessage.MSG;
      cm.arg = "Admin " + sRoomname2 + " has been removed from the room list!"; 
 bRmRmv = true; 
 vRemovedRooms.addElement(sRoomname2);
 postTo2Admin(adminID,cm); 
     }
 if(bRmRmv){
 AH.setbNewRoom( true );
  log("Removing room " + sRoomname2 + " for " + creator + " of " + addy + " ",1);
 rmg.removeFromMatrix();
    }
   }
  else {
	 cm.command = ControlMessage.ERROR;
	 cm.arg = "World " + sRoomname2 + " allready exists !";
	 postTo2(creator, cm);
   }
  }
 }
else {
	cm.command = ControlMessage.ERROR;
	 cm.arg = "You must include a password!";
	postTo2(creator, cm);
} 
}

 public synchronized void removeRoom( String roomname ){
 if(Rooms.containsKey(roomname)){
	Message msg = null;
 String [] st = {"(-1)"};
 vAuxRooms.removeElement( roomname ); 
 try {
 msg  = new WhoWhatWhere( WhoWhatWhere.WHRUPD, roomname, st );
  } 
  catch(IOException e){ msg = null; 
  log(" MatrixD removeRoom WHRUPD roomname or st is null: " + e,1); 
  return; }
if(msg!=null){ postToAllUsers2( msg ); }
  Rooms.remove( roomname );
  }
 else {
 log("MatrixD removeRoom: Rooms hashtable does not have: " + roomname,1 );  
  }
 }
 
 public synchronized String [] Roomis(){
  int i = 0;
  String [] st = new String [Rooms.size()];
  Enumeration rooms = Rooms.elements();
        while( rooms.hasMoreElements()){
   RoomManager rm = (RoomManager)rooms.nextElement();
   st[i] = rm.name + " (" + rm.getUsers() + ")";
    i += 1;
	}
    return st;
  }

 public void removalToAllUsers( Message msg, String roomname, ServerThread st ){
 if(!vRemovedRooms.contains(roomname)){
	postToAllUsersBut2( st, msg );
   }
 }

 public void postToAllUsers2( Message msg ){
		   Enumeration threads = Threads.elements();
        while( threads.hasMoreElements()){
       try {
            ((ServerThread)threads.nextElement()).sendMessage2( msg );
          }
        catch( InterruptedException f ){ }
			catch(IOException e){ log(" MatrixD: postToAllUsers: " + e,1);}
        }
  }

 public void postToAllUsersBut2( ServerThread st, Message msg ){
     ServerThread help;
		   Enumeration threads = Threads.elements();
        while( threads.hasMoreElements()){
          help =  ((ServerThread)threads.nextElement());
          if(help!=st){
             try {
              help.sendMessage2( msg );
               }
			catch( InterruptedException f ){ }
			catch(IOException e){log(" MatrixD: postToAllUsersBut2: " + help.name + " " + e,1);}
          }
       }
  }



 private void postTo2( String nm, Message msg ) {
		ServerThread help;
		Enumeration threads = Threads.elements();
		while(threads.hasMoreElements()) {
			help = (ServerThread) threads.nextElement();
			if( help.name.equals( nm )) {
				try {
					help.sendMessage2( msg );
				}
				catch( InterruptedException f ){ }
				catch(IOException e){ log(" MatrixD postTo2: " + help.name + " " + e,1);}
				break;
			}
		}
	}

private void postTo2Admin( int id, Message msg ) {
        Integer Id = new Integer( id );
		ServerThread help;
			help = (ServerThread)Threads.get(Id);
          if(help!=null){
				try {
					help.sendMessage2( msg );
				}
				catch( InterruptedException f ){ }
				catch(IOException e){ log(" MatrixD postTo2Admin: " + help.name + " " + e,1);}
              }
			}

     /**
  *	Writes new Users and their passwords (if password level is set at 3) to file rcusers.
  *	Called every ten minutes by Admin thread.
  */

   private void writeUsers(){
	  	log("MatrixD writing users ",1);
    File users = new File( sAbsolutePath + rcusers );
    try {
    FileOutputStream fos = new FileOutputStream( users );
    Uwriter = new PrintWriter(fos);
     }
	catch( IOException e ){ } 
	if(Uwriter!=null){
		Enumeration list = Users.keys();
        	  while( list.hasMoreElements()){
       String sU =  (String)list.nextElement();
       String sU2 = (String)Users.get(sU);
       String sU3;
	  if(passLevel==3&&!userPassword.equals("none")){
       sU3 = "user "+ sU + " " + sU2;
         }
       else {
         sU3 = "user "+ sU;
        }
			try {
		    Uwriter.write( sU3 );
			Uwriter.println();	    
			Uwriter.flush();
            	    }
		catch(Exception e) { 
          }
         }
	   Uwriter.close();
           }
   }

   /**
  *	Writes new Booted ex-users and their IP numbers to file  rcbooted.
  *	Called every ten minutes by Admin thread.
  */  

  private void writeBooted(){
  	log("MatrixD writing banned ",1);
     String sB3 = "";
	 File banned = new File( sAbsolutePath + rcbooted );
    try {
    FileOutputStream fos = new FileOutputStream( banned );
    Bwriter = new PrintWriter(fos);
     }
	  catch( IOException e ){ }
    if(Bwriter!=null){
	    if(!Booted.isEmpty()){
		Enumeration list = Booted.keys();
        	  while( list.hasMoreElements()){
       String sB =  (String)list.nextElement();
       String sB2 = (String)Booted.get(sB);
       sB3 = "booted "+ sB + " " + sB2;
	   try {
		    Bwriter.write( sB3 );
			Bwriter.println();	    
			Bwriter.flush();	    
		}
		catch(Exception e) { 
          }
    	 } 
        Bwriter.close();
        }
     else {
	   try {
		    Bwriter.write( sB3 );
			Bwriter.println();	    
			Bwriter.flush();
            Bwriter.close();	    
		}
		catch(Exception e) { 
          }
         }
	    }
       }

   /**
  *	Writes new Rooms approved by admin to file rcauxrooms .
  *	Called every ten minutes by Admin thread.
  */

   private void writeRooms(){
	log("MatrixD writeRooms ",1);
    String sR3 = "";
	File rooms = new File(sAbsolutePath + rcauxrooms);
	 try {
    FileOutputStream fos = new FileOutputStream( rooms );
    ARwriter = new PrintWriter(fos);
     }
  catch( IOException e ){ }
	          if(ARwriter!=null){
    	 if(!vAuxRooms.isEmpty()){
		Enumeration list = Rooms.keys();
        	  while( list.hasMoreElements()){
       String sR =  (String)list.nextElement();
       if(vAuxRooms.contains(sR)){
       RoomManager RM = (RoomManager)Rooms.get(sR);
       if(RM.bRFM2){
       sR = sR.replace(' ','_');
       sR3 = "room "+ sR + " " + RM.url + " " + RM.owner + " " + RM.ownerAddress + " " + RM.sRoompass + " ";
       log("MatrixD writeRooms 2 sR3: " + sR3,1);
			try {
		    ARwriter.write( sR3 );
			ARwriter.println();	    
		    ARwriter.flush();	    
		}
		catch(Exception e) { 
           }
          }
		 }
        }
      ARwriter.close();
       }
	  else {
     try {
		    ARwriter.write( sR3 );
			ARwriter.println();	    
		    ARwriter.flush();
	    	ARwriter.close();
		}
		catch(Exception e) { 
           }
        }
      }
     }

     

    public String getAbsolutePath(){
    return sAbsolutePath;
    }
    
    public static void usage(){
        System.err.println("Usage : java matrix.server.MatrixD [-port portnumber] [-loglevel level] [-rcfile name]");
        System.err.println("        level between 0 and 3");
        System.exit(1);
    }
    
    public void destroy(){
        running = false;
        
        Enumeration threads = Threads.elements();
        while( threads.hasMoreElements()){
            ((ServerThread)threads.nextElement()).close();
        }
		Enumeration rooms = Rooms.elements();
        while( rooms.hasMoreElements()){
            ((RoomManager)rooms.nextElement()).close();
        }
	//	if(AH!=null){ AH.stop(); }
        log("Shutting down server", 0 );
    }
}



