 /**
 Room.java
 
  
  Copyright (C) 1999 Geometrek	and 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.server;

import matrix.vrml.*;
import matrix.*;
import java.io.*;
import java.util.*;

/**
 * implements the notion of a room, i.e. a world where some users are together.
 * you can only see and talk to users in the same room. It maintains a table of
 * the objects add to it to update new users on them.
 *
 * @version 1.2
 */
public class Room {
     private int iMembers = 0;
	 private boolean bMembers = false;
     private   String sRoompass = "public";
	 protected boolean bRFM = true;
     private String sLockControl = "#open";
	 protected String owner = "public";
	 protected boolean bDropRights = false;
     protected Vector Members;
     protected boolean bPublic = true;
     protected boolean bObjChange = false;
	 private Vector listeners;
     private Vector maybes;
     private Vector bots;
//	 private Vector putupwith;
//     private Hashtable annoyers;
    private Vector loadedObjects;
	private Hashtable objects;
    private Hashtable locks;
	private Hashtable events;
	private Hashtable ObjStore;
	private MatrixD parent;
	private String wrlUrl;
    private int roomnum = 0;
	private String name; 
	private EventBuffer evtBuffer;
	private EventBuffer2 evtBuffer2;


   private class EventBuffer2 implements Runnable {
        
        private Vector buffer;
        private Thread runner;
        
            EventBuffer2(){
            buffer = new Vector(10,10);
            runner = new Thread( this, ("eventBuffer2_"  + name + "_" + roomnum  ) );
            runner.start();
        }
        
        public void run(){
            while( Thread.currentThread() == runner ){
                try{
            if(!buffer.isEmpty()){
             synchronized( buffer ){
   RealTimeMessage rtm = (RealTimeMessage)buffer.firstElement();
   if(rtm.persist!=RealTimeMessage.CLR){
   if(events.containsKey(rtm.tag)){
		  events.remove(rtm.tag);
         }
      events.put(rtm.tag,rtm);
   }
   else {
      events.clear();
    }
	  buffer.removeElementAt(0);                      
            }
          }
          else {
              synchronized( buffer ){
                buffer.wait();
               }
              }
             }	catch(NullPointerException f){
				 buffer.removeElementAt(0);
				 exceptionLog( " " + name + " " + roomnum +   " EventBuffer2 NullPointerException " + f + " " );
			     }
                catch(InterruptedException e){
                       }
                catch(Exception g){	
				   buffer.removeElementAt(0); 
                   exceptionLog( " " + name + " " + roomnum +   " EventBuffer2 Error " + g + " " );
                }
            }
        }
        
        public void put( RealTimeMessage rtm ){
            synchronized( buffer ){
                buffer.addElement( rtm );
                buffer.notify();
            }
        }
        

        public void stop() {
             runner = null; 
            synchronized( buffer ){
            buffer.removeAllElements();
               buffer.notify(); 
            }
          }
        }


    private class EventBuffer implements Runnable {
        
        private Vector buffer;
        private Thread runner;
		private boolean bKill = false;
        private boolean bExists = false;
		//private boolean exists = false;
        //private boolean change = false;
		private File OrigFile;
        private File TempFile;
        private String sObject_record;
        private String sMembers_record;
		private BufferedReader Breader = null;
	    private PrintWriter Pwriter = null;
        private Vector OIvec  = new Vector();
        
            EventBuffer( String dir, String RN, int num ){
			sObject_record = ( dir +  RN + File.separatorChar + RN + "_Objects.txt" );
			sMembers_record = ( dir +  RN + File.separatorChar + RN + "_Members.txt" );
            buffer = new Vector(10,10);
            runner = new Thread( this, ("eventBuffer_"  + name + "_" + roomnum  ) );
            runner.start();
        }
        
        public void run(){
			 Message msg;
			RoomControl rc;
            ControlMessage cm;
			readInfo( sObject_record );
			readMembers( sMembers_record );
            while( Thread.currentThread() == runner ){
                try{
             synchronized( buffer ){
			      if(!buffer.isEmpty()){
				  msg = (Message)buffer.firstElement();
            switch( msg.getType() ){
			case ObjectEnvelope.TYPE :
                          ObjectEnvelope oe = (ObjectEnvelope)msg; 
                         String sObj = oe.tag;
                         String sSender = oe.sender;
						 int iState = ((SFInt32)oe.state).getValue();
                         if(iState<2){
                    if(ObjStore.containsKey( oe.tag )){
						   float [] mft = new float[7];
	                       ObjInfo OI2 =  (ObjInfo)ObjStore.get( sObj );
                         if(OI2.objState==0){
				         OI2.owner = sSender;
				         mft = ((MFFloat)oe.data).getValue();
    					 OI2.position[0] = mft[0];
                         OI2.position[1] = mft[1];
						 OI2.position[2] = mft[2];
                         OI2.rotation[0] = mft[3];
                		 OI2.rotation[1] = mft[4];
                         OI2.rotation[2] = mft[5];
                         OI2.rotation[3] = mft[6];
              cm = new ControlMessage( ControlMessage.MSG, "MatrixD", "Object " + OI2.objName + " will be loaded into this room!");
		 postTo( sSender, cm );
		 cm	 = new ControlMessage( ControlMessage.OBJADD, OI2.objName, OI2.objUrl );
    	 postTo( sSender, cm );
            bObjChange = true;
		Enumeration list = locks.keys();
        while( list.hasMoreElements()) {
        String st = (String)list.nextElement();
       if(st.startsWith(OI2.objName + "#")){ locks.remove(st); }
           }
	    list = events.keys();
        while( list.hasMoreElements()) {
        String st = (String)list.nextElement();
       if(st.startsWith(OI2.objName + "#")){ events.remove(st); }
           }
			OI2.objState = iState;
           }
        else {
        if(OI2.owner.equals( sSender )||OI2.owner.equals("")){
          if(iState==0){ 
            OI2.resetFloats();
		 cm = new ControlMessage( ControlMessage.MSG, "MatrixD", "Object " + OI2.objName + " will be unloaded from this room!");
		 postTo( sSender, cm );
         cm	 = new ControlMessage( ControlMessage.OBJDEL, OI2.objName, OI2.objUrl ); 
    	 postToAll( cm );
    	Enumeration list = locks.keys();
        while( list.hasMoreElements()) {
        String st = (String)list.nextElement();
       if(st.startsWith(OI2.objName + "#")){ locks.remove(st); }
           }
	    list = events.keys();
        while( list.hasMoreElements()) {
        String st = (String)list.nextElement();
       if(st.startsWith(OI2.objName + "#")){ events.remove(st); }
           }
          OI2.objState = iState;
           }
           else {
           mft = ((MFFloat)oe.data).getValue();
    	OI2.position[0] = mft[0];
                         OI2.position[1] = mft[1];
						 OI2.position[2] = mft[2];
                         OI2.rotation[0] = mft[3];
                		 OI2.rotation[1] = mft[4];
                         OI2.rotation[2] = mft[5];
                         OI2.rotation[3] = mft[6];
		   RealTimeMessage rtm = new RealTimeMessage( sObj, new SFVec3f(mft[0],mft[1],mft[2]), true );
             postToAll( rtm );
	RealTimeMessage rtm2 = new RealTimeMessage( sObj, new SFRotation(mft[3],mft[4],mft[5],mft[6]), true );
             postToAll( rtm2 );
 cm = new ControlMessage( ControlMessage.MSG, "MatrixD", "Info for Object " + sObj + " saved and updated!");
             postTo( sSender, cm );
                }
		 bObjChange = true;
        }
     else {
 cm = new ControlMessage( ControlMessage.MSG, "MatrixD", "Object " + sObj + " is currently controlled by " + OI2.owner + "!");
             postTo( sSender, cm );
     }
   }
  }
  else {
  cm = new ControlMessage( ControlMessage.ERROR, "MatrixD", "Can't save info for Object " + sObj + " does not exist in this room!");
             postTo( sSender, cm );
     }
   }
  else {
  if(iState==2){
	if(oe.tag.equals(parent.AH.objName)){
	float [] pos = new float [] { (float)0.0, (float)0.0, (float)0.0 }; 
    float [] rot = new float [] { (float)0.0, (float)1.0, (float)0.0, (float)0.0 };
	ObjInfo OI = new ObjInfo( oe.tag, parent.AH.objUrl, false, 0, pos, rot);
    ObjStore.put( OI.objName, OI );
     }
	}
  else {
  if(iState==3){
  ObjInfo OI = (ObjInfo)ObjStore.get( oe.tag );
  if(OI.objState==1){
  cm = new ControlMessage( ControlMessage.OBJDEL, oe.tag, "" );
  postToAll2( cm );
  }
  ObjStore.remove(oe.tag);
   }
  }
  String[] objList = Objis();
  postToAll2( new WhoWhatWhere( WhoWhatWhere.WHAT, "", objList ) );
  bObjChange = true;
  }
   break;
   case RoomControl.TYPE :
            rc = (RoomControl)msg;
             if((!sRoompass.equals("public")&&!owner.equals("public"))&&rc.name.equals(owner+sRoompass)){ 
                    switch(rc.command){
                   case  RoomControl.SET :
                    if(rc.rc[0].equals("public")){
                    if(bPublic){
                    postTo( owner, new ControlMessage( ControlMessage.MSG, "MatrixD", "This world is already public!"  ) );
                    }
                    else {
             String []  foo2 = new String [] {"public"};
					 postTo( owner, new RoomControl( RoomControl.SET, new String( owner + sRoompass ), foo2 ) );
                    Members.removeAllElements();
			ServerThread help;
		Enumeration list = listeners.elements();
		while(list.hasMoreElements()) {
			help = (ServerThread) list.nextElement();
			if( !help.name.equals(owner)) {
				try {
					help.sendMessage3( new ControlMessage( ControlMessage.MSG, "MatrixD", "This world has been made public!"  ) );
				}
				catch(IOException e){parent.log("eventBuffer_" + name + " to "+help.getName()+" "+e,1);}
			}
                      }
                  if(!Members.isEmpty()){ bMembers = true; }
                  Members.removeAllElements();
				  bPublic = true;
                     }
                   }
                   else 
					if(rc.rc[0].equals("private")){  
                     if(!bPublic){
                    postTo( owner, new ControlMessage( ControlMessage.MSG, "MatrixD", "This world is already private!"  ) ); 
                     }
                    else {
               String []  foo2  = new String [] {"private"};
					 postTo( owner, new RoomControl( RoomControl.SET,  new String( owner + sRoompass ), foo2 ) );
                ServerThread help;
		Enumeration list = listeners.elements();
		while(list.hasMoreElements()) {
			help = (ServerThread) list.nextElement();
			if( !help.name.equals(owner)) {
				try {
					help.sendMessage2( new ControlMessage( ControlMessage.LOGOUT, owner, ""  )  );
				}
				catch(IOException e){parent.log("eventBuffer_" + name + " to "+help.getName()+" "+e,1);}
			}
                    }
			    bPublic = false; bMembers = true;
                     }
                    }
                    break;
				  case	RoomControl.GET :
                    if(bPublic==true){
    				postTo( owner, new ControlMessage( ControlMessage.MSG, "MatrixD", "This world is currently public!"  ) );
                    }
                    else { 
                  int memct = Members.size();
                  if(0<memct){
                  String [] mems = new String [ Members.size() ];
                  for( int i = 0; i<memct; i +=1 ){
                    mems[i] = (String)Members.elementAt(i);
                     }
					 postTo( owner, new RoomControl( RoomControl.GET,  new String( owner + sRoompass ), mems ) );
                    }
                   else {
				   postTo( owner, new ControlMessage( ControlMessage.MSG, "MatrixD", "This world doesn't have any members yet!"   ) );
                   }  
                    }
                    break;
                 case  RoomControl.ADDMEM :
                    boolean bAddCurrent = false;
                    for ( int i = 0; i<rc.rc.length; i +=1 ){
                    if(!Members.contains(rc.rc[i])){
                     Members.addElement(rc.rc[i]);
					 bAddCurrent = true; bMembers = true;
                     }
                     else {
				   postTo( owner, new ControlMessage( ControlMessage.MSG, "MatrixD", (rc.rc[i] + " is already a member of this world!") ) ); 
                      }
                     }
                    if(bAddCurrent){
					postTo( owner, new ControlMessage( ControlMessage.MSG, "MatrixD", "Members added!" )  ); 
                     } 
                    break;
                  case  RoomControl.REMMEM :
					boolean bSubCurrent = false;
					for ( int i = 0; i<rc.rc.length; i +=1 ){
                    if(Members.contains(rc.rc[i])){
                     Members.removeElement(rc.rc[i]);
					bSubCurrent = true; bMembers = true;
				    postTo2( rc.rc[i], new ControlMessage( ControlMessage.LOGOUT, rc.rc[i], "" )  ); 
                     }
                     else {
				    postTo2( owner, new ControlMessage( ControlMessage.MSG, "MatrixD", (rc.rc[i] + " is not a member of this world!") ) ); 
                      }
                     }
                    if(bSubCurrent){ 
				    postTo( owner, new ControlMessage( ControlMessage.MSG, "MatrixD", "Members removed!") ); 
                    }
                    break;
                  case RoomControl.PASSWD :
                    String sPub = null;
                    if(bPublic){
                    sPub = "public";
                    }
                    else {
                    sPub = "private";
                    }
					postTo( owner, new RoomControl( RoomControl.PASSWD,  new String( owner + sRoompass ), new String [] {sPub} ) );
                    break;
                    default :
					parent.log("Room " + name + "unknown RoomControl message "+ rc,1);
                    break;
                  }
                }
               else {
				postTo( owner, new ControlMessage( ControlMessage.ERROR, "MatrixD", "Either your world owner's name or password is incorrect!" ) );
               }
              break;
   case ControlEvent.TYPE :
		   String [] help = new String [2];
          ControlEvent cv = (ControlEvent)msg;
          switch( cv.command ) { 
          case ControlEvent.CTRLEV :
		help[0]  = cv.name;
		help[1]  = cv.arg[0];                                 
        String st = cv.arg[1];
		if(!locks.containsKey( cv.name )){
          if(st.equals("#lock")){ 
		    locks.put( cv.name, help );
			 postToAll2( new ControlEvent( ControlEvent.CTRLEV, cv.name, new String [] { help[1] } ) );
              }
			}
		   else{
		   String [] help2 = new String [2];
           help2 = (String [])locks.get( cv.name );
          if(help2[1].equals(help[1])&&st.equals("#open")){
            locks.remove( cv.name );
			postToAll2( new ControlEvent( ControlEvent.CTRLEV, cv.name, new String [] { "#open" } ) );
             }
           }
            break;
		  case ControlEvent.CTRLCR :
    			Enumeration list = locks.elements();
	while( list.hasMoreElements()){
	    help = (String [])list.nextElement();
	    if(help[1].equals( cv.name )){ 
          locks.remove( help[0] );
		   postToAll2( new ControlEvent( ControlEvent.CTRLEV, cv.name, new String [] { "#open" } ) );
           }
          }
          break;
          case ControlEvent.CTRLRM :
	    help[0]  = cv.name;
		help[1]  = cv.arg[0];                                 
         st = cv.arg[1];
	 if(sLockControl.equals("#open")&&st.equals("#lock")){
       sLockControl = help[1];
       postToAll2( new ControlEvent( ControlEvent.CTRLEV, help[0], new String [] {help[1]} ) );
        }
     else 
     if(sLockControl.equals( help[1] )&&st.equals("#clear")){
    list = locks.elements();
	while( list.hasMoreElements()){
	 String [] sClear = (String [])list.nextElement(); 
          locks.remove( help[0] );
		   postToAll2( new ControlEvent( ControlEvent.CTRLEV, sClear[0], new String [] {"#open"} ) );
            }
    	postTo2( sLockControl, new ControlMessage( ControlMessage.MSG, "MatrixD", (name + " locks cleared.") ) );
           }
      else 
	   if(sLockControl.equals( help[1] )&&st.equals("#open")){
       postToAll2( new ControlEvent( ControlEvent.CTRLEV, help[0], new String [] {"#open"} ) );
       sLockControl = st;
       }
          break;
		default :
		parent.log("Room " + name + " EvtBuffer: unknown ControlEvent type "+ cv,1);
           break;
         }
	   case TriggerEnvelope.TYPE :
       closeWrite();
       break;
	   default :
		parent.log("Room " + name + " EventBuffer: unknown Message type "+ msg,1);
           break;
         }
      buffer.removeElementAt(0);
        }
	   else {
             if(!bKill){ 
             buffer.wait();
                   }
			  else {
               closeWrite();
               runner = null;
                 }
                }
              }
             }
                catch(NullPointerException f){
				 buffer.removeElementAt(0);
				 exceptionLog( " " + name + " " + roomnum +   " EventBuffer NullPointerException " + f + " " );
			     }
                catch(InterruptedException e){
                       }
                catch(Exception g){	
				   buffer.removeElementAt(0);
                   exceptionLog( " " + name + " " + roomnum +   " EventBuffer Error " + g + " " );
                }
            }
        }
        
        public void put( Message msg ){
            synchronized( buffer ){
                buffer.addElement( msg );
                buffer.notify();
            }
        }

		   private void readMembers(String file){
		   String line, keyword, sMem;
           int index = 0;
           File MemFile = new File(file);
		   BufferedReader Mreader = null;
		   if(MemFile.exists()){
            try {
			Mreader = new BufferedReader( new FileReader(file) );
			 line = Mreader.readLine();
            while(line != null){
			   if( line.length() > 0 ) {
				    StringTokenizer token = new StringTokenizer(line," ");
                    keyword = token.nextToken();
                    if(keyword.charAt(0) != '#') { 
					   String st = keyword.toLowerCase();
                       if(st.equals("public")){
					  try {
                          Boolean BB = new Boolean( token.nextToken() );
						 bPublic =  BB.booleanValue();
                             }
					  catch(NoSuchElementException e) {
                     exceptionLog(" Error parsing "+file +" position: "+line+"\n\t"+e + " ");
                            return;
                            }
                          }
                      if(!bPublic){
					  keyword = token.nextToken();
					  st = keyword.toLowerCase();
					  if(st.equals("members")){
                      while(token.hasMoreTokens()){ 
                         try{
                         sMem = token.nextToken(); 
						 }
						 catch(NoSuchElementException e) {
                    exceptionLog(" Error parsing "+file +" : "+line+"\n\t"+e +" ");
                            return;
                            } 
                       sMem = sMem.trim();
                       Members.addElement(sMem);
                        }
                       }
                      }  
				    }
                  }
			   line = Mreader.readLine();
                index++;
               }	  
         }
      catch( Exception e ){ exceptionLog( e.toString() ); }
	  finally { 
            try{ 
                if(Mreader != null) 
                    Mreader.close(); 
            } 
            catch(Throwable e) {}
           }
        }

          else {
         String er = " " + file + " does not exist! ";
	    exceptionLog( er);
             }
           }

	/**
  * Reads  object name text file (found in directory of room name) at server start up
  * and creates a ObjInfo class instance, then stores it in ObjStore hashtable with the key being objects name.		
  */
		
	   	       private void readInfo(String file) {
        //int Ct1 = 0;
        //int Ct2 = 0;
		int index = 0;
         String line, objName, keyword, objChange, objUrl;
        OrigFile = new File(file);
		bExists = OrigFile.exists();
        if(bExists){
        try {
			Breader = new BufferedReader( new FileReader(file) );
			line = Breader.readLine();
            while(line != null ) {
                if( line.length() > 0 ) {
                 //Ct1 = Ct2;
                 //Ct2 += line.length();
                    StringTokenizer token = new StringTokenizer(line," ");
                    keyword = token.nextToken();
                    if(keyword.charAt(0) != '#') {                          // No Comment !
                      String  obj = keyword.toLowerCase();
                        if(obj.equals("object")) { 
                            try { 
                            objName = token.nextToken();
							 }
                            catch(NoSuchElementException e) {
                    exceptionLog(" Error parsing "+file +" : "+line+"\n\t"+e +" ");
                            return;
                            } 
						if( ObjStore.containsKey(objName))
                    exceptionLog( " " + objName+" is allready defined!");
                          else {
                            try {
                            objUrl = token.nextToken();
                            
                            }
							catch(NoSuchElementException e) {
                     exceptionLog(" Error parsing "+file +" position: "+line+"\n\t"+e + " ");
                            return;
                            }
                         boolean  bBool = false;
                            try {
                          Boolean BB = new Boolean( token.nextToken() );
						 bBool =  BB.booleanValue();
                             }
						 catch(NoSuchElementException e) {
                     exceptionLog(" Error parsing "+file +" position: "+line+"\n\t"+e + " ");
                            return;
                            }
                            int num = 0;
							try {
							 Integer Int = new Integer( token.nextToken() );
							num = Int.intValue();
                            }
							catch(NoSuchElementException e) {
                     exceptionLog(" Error parsing "+file +" position: "+line+"\n\t"+e + " ");
						    return;
							}
						   	catch(NumberFormatException f){
                      exceptionLog(" Error parsing "+file+" position : "+line+"\n\t"+f+ " ");
                             return;
                              }
							float [] pos = new float [3];
		                    float [] rot = new float [4];
                            if(num!=0){
							for( int i = 0; i<3; i++){
                            try {
                            Float ft = new Float( token.nextToken() );
            				pos[i] = ft.floatValue();
                            }
							catch(NoSuchElementException e) {
                     exceptionLog(" Error parsing "+file +" position: "+line+"\n\t"+e + " ");
	                        return;
                            } 
							catch(NumberFormatException f){
                     exceptionLog(" Error parsing "+file+" position : "+line+"\n\t"+f+ " ");
                             return;
                              }
                            }
                            for( int i = 0; i<4; i++){
                            try {
							Float ft = new Float( token.nextToken() );
            				rot[i] = ft.floatValue();
                             }
							catch(NoSuchElementException e) {
                      String er = " Error parsing "+file +" rotation: "+line+"\n\t"+e + " ";
                      exceptionLog( er );
						     return;
                            } 
							catch(NumberFormatException f){
                      String er = " Error parsing "+file+" rotation : "+line+"\n\t"+f+ " ";
                      exceptionLog( er );
                              return;
                               }
                              }
                            }
                            else {  
                             pos = new float [] { (float)0.0, (float)0.0, (float)0.0 }; 
                             rot = new float [] { (float)0.0, (float)1.0, (float)0.0, (float)0.0 }; 
                            }
                         ObjInfo OI = new ObjInfo(objName, objUrl, bBool, num, pos, rot);
                         ObjStore.put( objName, OI );
                        System.out.println("OI: " + OI.printObjInfo() );
                        }
                       }
                      }
                     }
                line = Breader.readLine();
                index++;
           }
          }
    catch( Exception e ){ exceptionLog( e.toString() ); }
      finally { 
            try{ 
                if(Breader != null) 
                    Breader.close(); 
            } 
            catch(Throwable e) {}
        }
    }
    else {
    String er = " " + file + " does not exist! ";
	exceptionLog( er);
     }
   }

      private void closeWrite(){
	  //System.out.println("Room " + name + " closeWrite called");
		if(bRFM){
		if(bObjChange){
        try {
		FileOutputStream fos = new FileOutputStream(OrigFile);
        Pwriter = new PrintWriter(fos);
        }
        catch(FileNotFoundException e) { 
        parent.log(name + " EventBuffer closeWrite "+ e,1);
          }
		Enumeration list = ObjStore.elements();
        	  while( list.hasMoreElements()){
       ObjInfo OI = ((ObjInfo)list.nextElement());
       String sOi = OI.printObjInfo();
       // System.out.println("Room " + name + " closeWrite " + sOi );
       parent.log("Room " + name + " closeWrite: " + sOi,1);
			try {
		    Pwriter.write( sOi );
			Pwriter.println();	    
			Pwriter.flush();
            	    
		}
		catch(Exception e) { 
          }
         }
		 Pwriter.close();
         bObjChange = false;
           }
       if(bMembers){
	 String mems = "";
        try {
        File MemFile = new File( sMembers_record );
		FileOutputStream fos = new FileOutputStream(MemFile);
           PrintWriter Mwriter = new PrintWriter(fos);
	if(!Members.isEmpty()){	 Enumeration list = Members.elements();
         mems = "public " + bPublic + " members ";
			 while( list.hasMoreElements()){
        mems += ( ((String)list.nextElement()) + (" ") );
            }
         }
		    Mwriter.write( mems );
			Mwriter.println();	    
			Mwriter.flush();
            Mwriter.close();
             }
		catch(Exception e) { 
          }
    	bMembers = false;
             }
        else {
        }
            }
          }   

        public void stop() {
             bKill = true;
            synchronized( buffer ){
            buffer.removeAllElements();
               buffer.notify(); 
            }
          }



        }
	
	public Room( MatrixD par, String na, String wrl, String owner, String rp, int num, boolean keep ) {
		parent = par;
		wrlUrl = wrl;
        sRoompass = rp;
        this.owner = owner;
		name = na;
		bRFM = keep;
        bots = new Vector();
        //maybes = new Vector();
        listeners = new Vector();
		Members = new Vector();
		objects = new Hashtable();
        ObjStore = new Hashtable();
    	loadedObjects = new Vector();
  roomnum = num;
  events = new Hashtable();
  locks = new Hashtable();
  String st = parent.getAbsolutePath();
  evtBuffer = new EventBuffer(st, name, 1 );
  evtBuffer2 = new EventBuffer2();
  	}
	
	public String getWrl() {  return wrlUrl; }

	public void setWrl( String wrl ) { wrlUrl = wrl; }
	
	public String getName() { return name; }

	public void setName(String n) { name = n; }

    public void removeFromMatrix(){	
    ControlMessage cm = new ControlMessage( ControlMessage.LOGOUT, "", "" );
	postToAll2( cm );
	close(); 
    parent.removeRoom( name );
	}

	public void close(){ 
     evtBuffer.stop(); 
     evtBuffer2.stop(); 
     }
	
    public void finishWrite(){
      parent.closeAdminHelper();
    }


 	public void addTentative( ServerThread user ) {
		maybes.addElement( user );
	}

    public void removeTentative( ServerThread user ){
	   maybes.removeElement( user );
    }

	/**
	 * adds new user to room and sends WHO to all users
	 *
	 * @param user the ServerThread handling the users network connection
	 */

	public synchronized void addUser( ServerThread user ) {
        //removeTentative( user );
		listeners.addElement( user );
        if(user.getbBot()||user.getbAdminBot()){ 
        bots.addElement( user.getName() ); 
            }
	}
 
/**
	 * removes user and sends WHO to all remaining users
	 *
	 * @param user the ServerThread handling the users network connection
	 */
	public synchronized void removeUser( ServerThread user ) throws InterruptedException {
   Message msg = null;
		listeners.removeElement( user );
        bots.removeElement( user.getName() );
    String [] st = new String [1];
    st[0] = (name + " (" + countAllUsers() + ")");
    sendControlEvent( new ControlEvent( ControlEvent.CTRLCR, user.getName(), new String [] {"#open"} ) );
	changeOwnerObjects( user.getName() );
  try {
 msg = new WhoWhatWhere( WhoWhatWhere.WHRUPD, name, st );
   }
  catch(IOException e){ 
  msg = null; 
  parent.log(" Room removeUser WHRUPD name or st is null: " + e,1);
  return; }
if(msg!=null){	parent.removalToAllUsers( msg, name, user ); }
    if( countUsers() > 0 ) {
			String[] help = Whois();
	try {
 msg = new WhoWhatWhere( WhoWhatWhere.WHO, "", help );
   }
catch(IOException e){ 
msg = null;
 parent.log(" Room removeUser WHO help is null: " + e,1);
return;
 }			
if(msg!=null){ postToAll2( msg  );}
		}
 else { 
   if(!bRFM){
  if(0==bots.size()){ close(); parent.removeRoom( name ); }
      }
 else {
 Enumeration eventobjs = events.elements();
       while( eventobjs.hasMoreElements()){
    RealTimeMessage rtm = (RealTimeMessage)eventobjs.nextElement(); 
if(rtm.persist==RealTimeMessage.POP ){ 
 events.remove( rtm.tag ); 
       }
      }
    }
   }
  }

	public int countUsers(){
     return listeners.size()-bots.size();
	}

   	public int countAllUsers(){
     return listeners.size();
	}

   public int getEventsSize(){
  int iZ = events.size();
  return iZ;
  }  

   public boolean objectInfoNameExists( String nm ){
  boolean tf = false;
 if(ObjStore.containsKey( nm )){
  tf = true;
   }
 return tf;
  }
	
	/**
	 * updates a user on all objects in the room.
	 * It sends an OBJADD message with the data of each object.
	 *
	 * @param user the ServerThread dealing with the client
	 */

	public synchronized void update( ServerThread user ) {
        Enumeration names = objects.keys();
		ControlMessage msg = new ControlMessage();
		msg.command = ControlMessage.OBJADD;
		while( names.hasMoreElements()) {
			msg.name = (String)names.nextElement();
			msg.arg = (String) objects.get( msg.name );
			try {
				user.sendMessage2( msg );
			}
   catch(InterruptedException f){}
   catch(IOException e){parent.log(name+" OBJADD to "+user.getName()+" "+e,1); 
    try {
    removeUser( user );
     }
    catch(InterruptedException g){}
     return;}
		}
          addLoadedObjects( user.getName() );
	}


      public synchronized Hashtable getObjects() {
       Hashtable HT = objects;
         return HT;
       }

	
	/**
	 * selects a user to receive an UPDATE message. This causes the user to send the last
	 * value of the networkState nodes it holds.
	 *
	 * @param user the ServerThread dealing with the client
	 */

   public synchronized Enumeration updateRoutesEnum(){
   Enumeration enum1 = locks.elements();
   return enum1;
   }

   public synchronized Enumeration updateEventsEnum(){
   Enumeration enum1 = events.elements();
   return enum1;
   }


	public synchronized void updateRoutes( ServerThread user ){
      // System.out.println("Room updateRoutes A");
		 Enumeration names2 = locks.elements();
		ControlEvent msg2 = new ControlEvent();
		msg2.command = ControlEvent.CTRLEV;
		while( names2.hasMoreElements()) {
			String [] help = (String [])names2.nextElement();
        if(help[0].indexOf("#")==-1){
            msg2.name = help[0];
			msg2.arg = new String []  {help[1]};
			try {
				user.sendMessage2( msg2 );
			}
   catch(InterruptedException f){}
 catch(IOException e){parent.log(name+" CTRLEV to "+user.getName()+" "+e,1);}
          }
         }
		Enumeration eventobjs = events.elements();
       while( eventobjs.hasMoreElements()){
       RealTimeMessage rtm = (RealTimeMessage)eventobjs.nextElement();
       if(rtm.tag.indexOf("#")==-1){
            try {
               user.sendMessage( rtm );
        }
    	catch(IOException e){ parent.log(name+" rtm events update to "+user.getName()+" "+e,1);}
        }
      }
	}
                                                             	
	/**
	 * adds an object to the room. If an object with the name of the new one allready
	 * exists, it returns false and does nothing, otherwise true.
	 *
	 * @param sender the ServerThread dealing with the client that adds the object
	 * @param name the objects name
	 * @param url the url of the content file representing the object
	 */
	public synchronized boolean addObject( ServerThread sender, String name, String url ) throws InterruptedException {
		if( objects.containsKey( name ))
			return false;
        if(!sharedObjectExist( name )){
		objects.put( name, url );
        }
		ControlMessage msg = new ControlMessage( ControlMessage.OBJADD, name, url );
		postToAllBut2( sender, msg );
		return true;
	}

//   public synchronized boolean addSharedObject( String name, String url ) throws InterruptedException {
//		if( objects.containsKey( name ))
//			return false;
//		objects.put( name, url );
//		return true;
//	}

    public synchronized void sendControlEvent( Message msg )  throws InterruptedException {
      evtBuffer.put( msg );
  }
	
	/**
	 * deletes an object from the room.
	 *
	 * @param sender the ServerThread dealing with the client that deletes the object
	 * @param name the objects name
	 */
	public synchronized void deleteObject( ServerThread sender, String name ) throws InterruptedException {
		if( objects.containsKey( name )){
			objects.remove( name );
			ControlMessage msg = new ControlMessage( ControlMessage.OBJDEL, name, "" );
			postToAllBut2( sender, msg );
		}
	}

   public synchronized void objectOfAnnoyer( String target, String name, String tf ) throws InterruptedException {
			ControlMessage msg = new ControlMessage( ControlMessage.IGG, name, tf );
          postTo( target, msg );
	}
	
	/**
	 * updates an object by telling each client to update it and if it holds it
	 * it will do so :)
	 *
	 * @param name the name of the object
	 */

	public void updateObject( String name ) throws InterruptedException {
		Enumeration list = listeners.elements();
		while( list.hasMoreElements()){
			((ServerThread)list.nextElement()).updateObject( name );
		}
	}

   public boolean SharedObjectExists( String name ){
   boolean bSOE = ObjStore.containsKey( name );
   return bSOE;
   }

   public Message [] updateSharedObjectMsgs( String name ){
   Message [] msgs = null;
     if(ObjStore.containsKey( name )){
	ObjInfo OI =  (ObjInfo)ObjStore.get( name );
    if(0<OI.objState){
	msgs = new Message [2];
     Field rot = new SFRotation( OI.rotation );
    RealTimeMessage rtm1 = new RealTimeMessage( name, rot,   false    );
    //System.out.println("updateSharedObject SFRotation: " + OI.rotation[0] + " " + OI.rotation[1] + " " + OI.rotation[2] + " " + OI.rotation[3]);
    msgs[0] = rtm1;
     Field pos = new SFVec3f( OI.position );
	RealTimeMessage rtm2 = new RealTimeMessage( name, pos, false  );
	 //System.out.println("updateSharedObject SFVec3f: " + OI.position[0] + " " +  OI.position[1] + " " +  OI.position[2] );
    msgs[1] = rtm2;
    }
    else {
	msgs = new Message [1];
    ControlMessage cm = new ControlMessage( ControlMessage.ERROR, "MatrixD", "Object " + name + " has not yet been loaded!");
    msgs[0] = cm;
     }
    }
    else {
	msgs = new Message [1];
    ControlMessage cm = new ControlMessage( ControlMessage.ERROR, "MatrixD", "Object " + name + " does not exist in this room!");
	msgs[0] = cm;
    }
    return msgs;
   }
 

   public void	updateSharedObject( String name, String target ){
     if(ObjStore.containsKey( name )){
	ObjInfo OI =  (ObjInfo)ObjStore.get( name );
    if(0<OI.objState){
     Field rot = new SFRotation( OI.rotation );
    RealTimeMessage rtm1 = new RealTimeMessage( name, rot,   false    );
    //System.out.println("updateSharedObject SFRotation: " + OI.rotation[0] + " " + OI.rotation[1] + " " + OI.rotation[2] + " " + OI.rotation[3]);
	postToRTM( target, rtm1 );
     Field pos = new SFVec3f( OI.position );
	RealTimeMessage rtm2 = new RealTimeMessage( name, pos, false  );
	 //System.out.println("updateSharedObject SFVec3f: " + OI.position[0] + " " +  OI.position[1] + " " +  OI.position[2] );
	postToRTM( target, rtm2 );
    }
    else {
    ControlMessage cm = new ControlMessage( ControlMessage.ERROR, "MatrixD", "Object " + name + " has not yet been loaded!");
    postTo( target, cm );
    }
    Enumeration eventobjs = events.elements();
       while( eventobjs.hasMoreElements()){
       RealTimeMessage rtm = (RealTimeMessage)eventobjs.nextElement();
       if(rtm.tag.startsWith(name+"#")){
		 postToRTM( target, rtm );
          }
        }
        eventobjs = locks.elements();
		ControlEvent msg2 = new ControlEvent();
		msg2.command = ControlEvent.CTRLEV;
		while( eventobjs.hasMoreElements()) {
			String [] help = (String [])eventobjs.nextElement();
        if(help[0].startsWith(name + "#" )){
        // System.out.println("Room updateSharedObject help[0]: " + help[0] + " help[1]: " + help[1] );
            msg2.name = help[0];
			msg2.arg = new String []  {help[1]};
			postTo2( target, msg2 );
          }
         }
      }
	else {
    ControlMessage cm = new ControlMessage( ControlMessage.ERROR, "MatrixD", "Object " + name + " does not exist in this room!");
    postTo( target, cm );
    }
   }

   public void sendSharedObjectUpdate( RealTimeMessage RTM, String target ){
    
   }

  // public void requestObject( String requester, String name, String state ){
  // OR.requestObject( requester, name, state );
  // }

 //  public void saveObjectInfo( String sender, Message rts ){
 //  OR.saveObjectInfo( sender, rts );
 //  }


   public synchronized void saveObjectInfo( Message msg ){
   evtBuffer.put( msg );
   }
  

   public synchronized String[] Objis() {
	String[] val = new String[(ObjStore.size())];
 //System.out.println("Room Objis val length: " + val.length ); 
		int i = 0;
		Enumeration list = ObjStore.elements();
		while( list.hasMoreElements()) {
         ObjInfo OI =  (ObjInfo)list.nextElement();
         if(0<OI.objState){
			val[i] = OI.objName;
             }
          else{
            val[i] = OI.objName + "(BP)";
           }
          i += 1;
        }
		return val;	
	}

   public boolean sharedObjectExist( String name ){
	 if( !ObjStore.containsKey( name )){
	  return false;
        }
    else
    return true;
   }

   public synchronized void handleStorage( RealTimeMessage rtm ){
	evtBuffer2.put( rtm );
   } 
 
	/**
	 * returns a list of all the clients names.
	 */
	public synchronized String[] Whois() {
		String[] val = new String[listeners.size()];
		int i = 0;
		Enumeration list = listeners.elements();
		while( list.hasMoreElements())
			val[i++] = ((ServerThread)list.nextElement()).name;
		return val;
	}


   	private void changeOwnerObjects( String quiter ){
	   	Enumeration list = ObjStore.elements();
        	  while( list.hasMoreElements()){
       ObjInfo OI3 = ((ObjInfo)list.nextElement());
	  if(OI3.owner.equals(quiter)&&(!OI3.objChange)){
         OI3.owner = "";
        }
      }
   }

   public synchronized Enumeration addLoadedObjectsEnum(){
   Enumeration LT = ObjStore.elements();
   return LT;
   }
  
   private void addLoadedObjects( String requester ){
	   	Enumeration list = ObjStore.elements();
        	  while( list.hasMoreElements()){
       ObjInfo OI3 = ((ObjInfo)list.nextElement());
	  if(0<OI3.objState){
 ControlMessage	cm	 = new ControlMessage( ControlMessage.OBJADD, OI3.objName, OI3.objUrl );
	 postTo( requester, cm );
        }
      }
   }
  
   public void exceptionLog( String problem ){
   System.err.println( problem );
   parent.log( problem,1);
    }

	public void postToRTM( String name, Message msg ) {
		ServerThread help;
		Enumeration list = listeners.elements();
		while(list.hasMoreElements()) {
			help = (ServerThread) list.nextElement();
			if( help.name.equals( name )) {
				try {
					help.sendMessage( msg );
				}
				catch(IOException e){parent.log(""+name+" to "+help.getName()+" "+e,1);}
				break;
			}
		}
	}

	
	public void postTo( String name, Message msg ) {
		ServerThread help;
		Enumeration list = listeners.elements();
		while(list.hasMoreElements()) {
			help = (ServerThread) list.nextElement();
			if( help.name.equals( name )) {
				try {
					help.sendMessage3( msg );
				}
				catch(IOException e){parent.log(""+name+" to "+help.getName()+" "+e,1);}
				break;
			}
		}
	}


   public void postTo2( String name, Message msg ) {
		ServerThread help;
		Enumeration list = listeners.elements();
		while(list.hasMoreElements()) {
			help = (ServerThread) list.nextElement();
			if( help.name.equals( name )) {
				try {
					help.sendMessage2( msg );
				}
				catch( InterruptedException f ){ }
				catch(IOException e){parent.log(""+name+" to "+help.getName()+" "+e,1);}
				break;
			}
		}
	}

	
	public void postToAllBut( ServerThread sender, Message msg ) {
		ServerThread help;
		Enumeration list = listeners.elements();
		while(list.hasMoreElements()) {
			help = (ServerThread) list.nextElement();
			if( help != sender) {
				try {
					help.sendMessage( msg );
				}
				catch(IOException e){parent.log(name+" to "+help.getName()+" "+e,1);}
			}
		}
	}

 public void postToAllBut2( ServerThread sender, Message msg ) {
		ServerThread help;
		Enumeration list = listeners.elements();
		while(list.hasMoreElements()) {
			help = (ServerThread) list.nextElement();
			if( help != sender) {
				try {
					help.sendMessage2( msg );
				}
    catch( InterruptedException f ){ }
				catch(IOException e){parent.log(name+" to "+help.getName()+" "+e,1);}
			}
		}
	}

 	public void postToAllBut3( ServerThread sender, Message msg ) {
		ServerThread help;
		Enumeration list = listeners.elements();
		while(list.hasMoreElements()) {
			help = (ServerThread) list.nextElement();
			if( help != sender) {
				try {
					help.sendMessage3( msg );
				}
				catch(IOException e){parent.log(name+" to "+help.getName()+" "+e,1);}
			}
		}
	}
 
	
	public void postToAll( Message msg ) {
		ServerThread help;
		Enumeration list = listeners.elements();
		while(list.hasMoreElements()) {
			help = (ServerThread) list.nextElement();
			try {
				help.sendMessage( msg );
			}
			catch(IOException e){parent.log(name+" to "+help.getName()+" "+e,1);}
		}
	}

 	public void postToAll2( Message msg ) {
		ServerThread help;
		Enumeration list = listeners.elements();
		while(list.hasMoreElements()) {
			help = (ServerThread) list.nextElement();
			try {
				help.sendMessage2( msg );
			}  
   catch( InterruptedException f ){ }
			catch(IOException e){parent.log(name+" to "+help.getName()+" "+e,1);}
		}
	}

  	public void postToAll3( Message msg ) {
		ServerThread help;
		Enumeration list = listeners.elements();
		while(list.hasMoreElements()) {
			help = (ServerThread) list.nextElement();
			try {
				help.sendMessage3( msg );
			}
			catch(IOException e){parent.log(name+" to "+help.getName()+" "+e,1);}
		}
	}



}
